Welcome to SyncBackSE

 Return to Introduction

SyncBackSE V5

Welcome to the help and information guide of SyncBackSE V5.

SyncBackSE is used to back-up, restore, and synchronize files and directories, whether they are on a local drive, a network drive, a ZIP archive, an FTP server, or on removable media.

SyncBackSE copies locked and/or open files, has a powerful FTP engine, a Fast Backup option, Smart Synchronization, file versioning, fast compression with AES encryption, and a number of crucial advantages over its freeware namesake.

For a comparison of SyncBackPro, SyncBackSE, and SyncBack freeware go to Version Comparison.

For a list of what is only available in the sbpro-feature-16x16 Pro version go to Pro Only Features.

All Content: 2BrightSparks Pte Ltd © 2003-2008


Why Use SyncBackSE?

SyncBackSE Version 5 in Action

As you work on your computer you'll find there are times when you wish you had a backup (copies of your files). Perhaps you have inadvertently deleted a file you should not have, perhaps you need to roll-back your work to a previous time and date, perhaps you have a laptop and a desktop you need to synchronize via FTP. SyncBackSE can help you with all these tasks and more.

castle

Protect yourself from data loss

SyncBackSE helps you to protect yourself from data loss by allowing you to backup your important files. When disaster strikes all you have to do is click a single button to restore.

lifebelt

Recover files in minutes instead of hours

SyncBackSE helps you spend time on those things that matter. Trying to recover from the effects of lost data can be very costly and time consuming. SyncBackSE's proven backup and synchronization solution is a breeze to implement, reliable, and affordable.

gears

Ease of use and advanced functionality

SyncBackSE delivers great ease of use and outstanding functionality at a highly competitive price. Look at the features that SyncBackSE has to offer:

· Backup, Restore, Synchronize, or Mirror Files
· Backup Locked/Open Files
· File Versioning
· Fast Backup option
· Smart Synchronization that lets you truly synchronize directories
· Fast compression with options, 256-bit AES encryption, Zip64, BZip2 compression ( sbpro-feature-16x16 Pro version only), and self-extracting Zip file support
· SFTP support ( sbpro-feature-16x16 Pro version only)
· Backup and sync files with an email server ( sbpro-feature-16x16 Pro version only)
· Backup directly to a CD or DVD with automatic disk spanning ( sbpro-feature-16x16 Pro version only)
· Detection of impending drive failure using S.M.A.R.T. technology ( sbpro-feature-16x16 Pro version only)
· Powerful configuration via scripting ( sbpro-feature-16x16 Pro version only)
· Database technology used for backup/sync of an unlimited number of files ( sbpro-feature-16x16 Pro version only)
· Fully Vista compatible
· Incremental and Differential backups
· Fully Unicode so filenames can be in any language
· New Differences window that provides clear & complete control over what to do with changed & new files
· Simulated Run and Restore
· Improved HTML log file layout (text version also available)
· New folder & file selection tree to allow for complete control over what files & folders are included in a profile
· Powerful regular expression filters
· Easy and Expert modes for beginner and advanced users
· Background Backups & Synchronizations
· Full Scheduling
· Progress bar
· SSLv2, SSLv3, and TLSv1 encryption support
· Secure FTP Backup and Synchronization
· Support for one-time-passwords
· Support for MODE Z compression
· Support for XCRC command (so files can be verified)
· Support for new FTP extensions, e.g. MLSD
· Better firewall/NAT support (external IP address and port ranges)
· Improvements to the method empty folders are created/deleted
· Profile exports strings with double-quotes
· New graphics and improved interface
· Export and Import Profiles
· Scheduling
· Differences Window
· Show Groups Only
· Hibernate or Standby
· Start with Windows
· Definable Double-Click Actions
· Minimize Program Options
· View Columns Options
· Update Check
· File Filtering
· Compare files options
· Network Capabilities
· Eject Source Drive Media post task
· Select programs to run before and after task
· Select programs to close before task
· Right Click Menu
· Internet Update Check
· Extensive New Help File Documentation
· Industry leading Internet support, including an updated Knowledge Base, FAQs, Trouble Shooter, and active online forum.

medal

Award-winning software

SyncBackSE has received awards and accolades as a great backup tool from numerous review websites, industry magazines, and independent computer journalists. SyncBackSE V5 delivers significant improvements in functionality and presentation over its predecessor. To view some of our awards, testimonials, and media features go to:

http://www.2brightsparks.com/awards.html


What's New in Version 5?

What's New in SyncBackSE Version 5

Great Features in SyncBackSE

The latest version of SyncBackSE offers significant advantages over previous versions, and is a free upgrade for all registered users of SyncBackSE.

New Features in V5

Listed below are just some of the new features included in this version. All these new features are covered in greater detail in this help file and in our Online Support Area.

· Profile Settings Search: The profile settings can be searched for quick access and discovery.

· Archive Bit: The file archive bit can now be used for traditional incremental and differential backups.

· Mirroring: As well as backup and synchronize, files can also be mirrored.

· File Renames: SyncBackSE can now optionally detect file renames when synchronizing files.

· Full Backup Folder: The folder to use for full backups can now be defined.

· Variables: Values from the registry can now be retrieved using variables, variables can be defined at the group level, and user-defined variables can be created. A number of new variables have also been included.

· Speech: SyncBackSE can now speak to you (and play .WAV files) to tell you when a profile has started or finished.

· Shutdown: SyncBackSE can be told to automatically switch off the computer once it has finished a backup.

· Versioning: Files to be versioned can now be filtered, e.g. don't version EXE files.

· Snapshots: Entire backups can be made from a shadow volume, which ensures all files copied are copied at the same time.

· Notes: Notes/comments can be included in a profile.

· Protected Files: If an attempt is made to delete or replace a Windows protect file then SyncBackSE will detect this and give the appropriate error message.

· Tray Icon: The tray icon can be configured to warn you if any profiles that have failed.

· Revised and extended Help File

History of changes

For a complete history of changes which details all updates, fixes, and features, go to:

http://www.2brightsparks.com/syncback/sbse-changes.html


Pro Only Features

Pro Features

The following features are only available in the sbpro-feature-16x16 Pro version:

· Backup and sync via an email server: You can now backup and synchronize your files via an email server (POP3/IMAP4 and SMTP), e.g. Gmail, Yahoo!, etc. For example, you could synchronize your files with a friend or colleague via a dedicated shared email account. You could also sign up to a free email account and backup your files to it. There is no need to worry about spam - SyncBackPro can be configured to automatically delete all emails that are not used by SyncBackPro. There is also no need to worry about security because you can store your files using 256-bit AES encryption.

· Backup directly to a CD/DVD: Now you can backup directly to CD or DVD (including Blu-Ray), with automatic disk spanning. There is no need to pre-format the CD/DVD, and compression does not need to be used for disk spanning.

· Scripting: This powerful new feature allows you to configure how SyncBackPro works and runs profiles. For example, you could create a script that lets SyncBackPro backup to a database (or anything else you can access). Scripting can also be used to change how profiles run.

· Unlimited number of files: SyncBackPro uses a database to store details of the files it is copying, instead of storing the information in RAM (memory). This means an unlimited number of files and folders can now be processed. SyncBackPro will use RAM for performance but will automatically and seamlessly switch to a database if memory is running low or the number of files reaches a threshold. Using a database will actually be significantly faster when the number of files is in the hundreds of thousands.

· Automatic drive failure detection: Using S.M.A.R.T. technology, SyncBackPro can detect the impending failure of a hard drive. If a hard drive is going to fail (or has failed) then the log file will have details, and the profile status will indicate it. To use this feature your computers BIOS and hard drive must support S.M.A.R.T. (and it must also be enabled via the BIOS settings).

· BZip2 compression: As well as supporting the industry standard Zip compression, and BWT compression, you can now also compress using BZip2. It compresses most files more effectively than more traditional gzip or Zip, but it is slower. If space is more of a concern than speed, then BZip2 may be the solution.

· SFTP: As well as supporting traditional FTP and FTPS, SyncBackPro now also supports SFTP.

upgrade-sbse-pro

Upgrade SyncBackSE to SyncBackPro

All SyncBackSE licensees can upgrade to SyncBackPro at reduced prices. Visit Our Web Store and choose your upgrade option today.


Version Comparison

Version Comparison

Below is a list of some of the major features and in which version of SyncBack they appear:

Feature | SyncBackPro | SyncBackSE | SyncBack Freeware
Backup/sync via an email server | Yes | No | No
Backup directly to CD/DVD | Yes | No | No
Scripting | Yes | No, requires 3rd party software | No, requires 3rd party software
Unlimited number of files | Yes | No, limited by RAM | No, limited by RAM
Drive failure detection using S.M.A.R.T. | Yes | No | No
BZip2 compression | Yes | No | No
SFTP | Yes | No | No
Unlimited filename lengths (except with Zip) | Yes | Yes | No
Copy open/locked files | Yes | Yes | No
File versioning | Yes | Yes | No
Incremental & differential backups | Yes | Yes | No
Fast Backup feature to reduce backup time | Yes | Yes | No
Smart Synchronization | Yes | Yes | No
Fully Unicode for multi-language support | Yes | Yes | No
Zip64 compression with 256-AES encryption | Yes | Yes | No
BWT compression | Yes | Yes | No
Create self extracting Zip files | Yes | Yes | No
Extended FTP support, with SSL/TLS support | Yes | Yes | No
Fine grained control over what to backup/sync | Yes | Yes | No
Regular expression filters | Yes | Yes | No
Bandwidth throttling | Yes | Yes | No
Emailing logs | Yes | Yes | No
Extensive variables | Yes | Yes | No
Automatic backup when files changed | Yes | Yes | No
Control over what actions to take | Yes | Yes | No
Move files | Yes | Yes | No
Detect renamed files | Yes | Yes | No
Enable & disable profiles | Yes | Yes | No
Run profiles on login or logout | Yes | Yes | No
Run profiles whenever media is connected | Yes | Yes | No
Free technical support | Yes | Yes | No

upgrade-sbse-pro

Upgrade SyncBackSE to SyncBackPro

All SyncBackSE licensees can upgrade to SyncBackPro at reduced prices. Visit Our Web Store and choose your upgrade option today.


System Requirements

System Requirements

windows

SyncBackSE requires Windows 2000, Windows XP, Windows 2003, Windows Vista, Windows 2008, or newer. Both 32-bit and 64-bit versions of Windows are supported.

In line with Microsoft's policy, Windows 95, 98, 98SE, ME, and NT 4 are not supported.

note

To copy locked/open files, you must be running Windows XP (Pro or Home), Windows 2003, Windows Vista, Windows 2008, or newer, and as a user who is a member of the Backup Operators group (administrator users are). Both 32-bit and 64-bit versions of Windows are supported. In addition, the file being copied (which is locked) must be on a local volume (i.e. a drive physically connected to the computer). If it is on a FAT32 volume then you must also have a local NTFS volume on an internal drive.

How to find out what system a drive is using

note

SyncBackSE produces log reports which will show what system you are currently using. To view a log report select a profile, then "View Log" from the Task Menu - you may also use the shortcut keys "Ctrl" and "L" after selecting a profile.

A sample of the kind of information shown in logs created by SyncBackSE follows:


How to Buy SyncBackSE

Purchase SyncBackSE Today and Enjoy Instant Delivery

We recognize that security is one of the major concerns for the shopper during an online transaction. Our payment processor uses state of the art security tools and techniques to ensure that you are protected against online fraud.

All payment transactions at 2BrightSparks are handled through the eSellerate payment system. At no time do we process or save customer payment card details on our website.

If you would like to learn more about eSellerate, visit their site at:

http://www.esellerate.net/company_overview.asp

lock Direct Ordering and Download

Pay via Credit Card, by Phone or FAX, or via PayPal...

Ordering SyncBackSE couldn't be simpler. Your serial number will be presented to you immediately following payment on eSellerate's secure server. Your order details and serial number will also be sent to you via email.

SyncBackSE, and other 2BrightSparks software, are only available from our website as downloadable products. Orders can be processed for VISA, Mastercard, DISCOVER, American Express, JCB, and via PayPal

Buy Now

Click the following link to order directly from our Web Store:

Buy SyncBackSE

upgrade-sbse-pro

Upgrade SyncBackSE to SyncBackPro

All SyncBackSE licensees can upgrade to SyncBackPro at reduced prices. Visit Our Web Store and choose your upgrade option today.

Phone and Fax Orders

Alternatively, you may use the following URLs for phone or Fax orders:

phone | http://store.eSellerate.net/s.asp?s=STR2236179640&CMD=PHONE
phone-fax | http://store.eSellerate.net/s.asp?s=STR2236179640&CMD=FAX

Website

A fully functional evaluation version of SyncBackSE is also available from our website by clicking any of the 'Try' links:

Download the full evaluation of SyncBackSE today:

Download SyncBackSE 30 Day Trial

Sales and Support

Sales and Support are available by submitting a support ticket from our Support Area. Find out more about our industry leading support resources.

Other Great Software from 2BrightSparks

InfoHesive

Infohesive48x48

A powerful program to organize your data files and share information. For Microsoft Windows XP/2003/Vista. Find out more...

• InfoHesive Projects link to any data file on your computer.

• Write notes associated with any file or URL.

• Use the powerful on-board rich-text editor and save as an eBook or Help File.

• Share your InfoHesive WorkSpaces using the the Freeware InfoHesive Viewer.

Create InfoHesive WorkSpaces for your own needs: Support & Marketing; Personal Information Manager; Home Inventory; Boilerplate Documentation; Brain Storming; Photo & Music Album; Study or Research Aid; Recipe Book; Project Management; e-Authoring; help file dev. The list is endless...

Download the fully functional 30 day trial of InfoHesive

OnClick Utilities

ocu48x48

A suite of easy to use software utilities for Microsoft Windows 2000/XP/2003/Vista. Find out more...

• FindOnClick performs lightning fast file searches.

• UndeleteOnClick recovers deleted files.

• DeleteOnClick securely deletes data.

• HashOnClick helps guarantee files are identical.

• EncryptAllOnClick delivers military grade encryption.

• ScrambleOnClick encrypts/decrypts files and text.

• PatchOnClick easily updates large files.

Select one or all of the OnClick Utilities programs for your needs:

Download OnClick Utilities

Company Postal Address

2BrightSparks Pte Ltd

PSA Building

PO Box 364

911143

Singapore

Read Company Information for more.


Help using SyncBackSE

Help! Online and Printable Support Resources

As a user of SyncBackSE you can enjoy extensive support from 2BrightSparks Pte Ltd:

Your first port of call for support is to read this help file. Click 'Help' under the help menu, or the Help button on the main program window to open the help file:

If you have never backed up data before, we advise you read the New User Guide which explains the fundamentals about different kinds of backup. Using SyncBackSE provides detailed explanations of all the functions in SyncBackSE including Basic Operation; Easy Mode; Expert Mode; Runtime Help; and a Technical Reference.

This help file also offers context sensitive guidance when using the program. You'll find a 'Help' button in most of the program's windows. Clicking the help button will take you straight to the help page for that particular task or option. The following help button in the program for example will take you to the section of this help file called Email, Advanced:

Fully Searchable Settings

When editing the settings for a profile you can use the settings search feature to locate the settings you need.

Fully Searchable and Printable Help Manual

Do not directly print this help file from the Microsoft help viewer because the print quality of the HTML Help viewer is poor.

A fully searchable and printable SyncBackSE Help File is available as an Adobe PDF file (Portable Document Format).

This help file is available from our website in PDF format at:

http://www.2brightsparks.com/syncback/SyncBackSE-PDF.zip

Although Adobe Acrobat Reader is installed as standard on Windows computers, you may wish to download and install the very latest version which includes significant improvements over its predecessors:

adobe-reader

Get latest Adobe Acrobat Reader

Online Support from 2BrightSparks

Our online support is among the best in the industry. You'll find Tutorials to get you up and running, our extensive Support Area which features our Knowledge Base and FAQs (Frequently Asked Questions), and quick fix TroubleShooter.

Technical Support Via Email

If after reviewing the help file and online support resources you continue to experience difficulties using SyncBackSE, you may submit a support ticket. The new Technical Support Wizard creates a special file that provides the essential information which you may attach to your ticket.


Technical Support Wizard

Requesting Support

Email Support

You must use our Support Ticketing service for email support which is available at:

http://www.2brightsparks.com/help/index.php?pf=usr

Support Ticketing ensures we keep the appropriate records of your support request and our response history to you. This helps us deliver better service to all our customers as we respond efficiently, audit the effectiveness of our responses and generally improve the quality of our support. In addition, analysis of our support performance and the frequency level of specific support requests also leads to improving our software. By using a support system that does not require email, the problems associated with spam filters are also avoided.

We trust you understand the importance we place on the high quality of our software and service, and therefore we must follow procedures that are of greatest benefit to the majority of our users. Direct email support requests will be ignored.

The Technical Support Wizard

If after reviewing the help file and online support resources you continue to experience difficulties using SyncBackSE, you may submit a support ticket. The new Technical Support Wizard creates a special file that provides the essential information we require when you submit your ticket.

You can open the Technical Support Wizard by clicking on the help menu and choosing the Technical Support Wizard item from the drop down list:

You may now choose items to include, select the profile, then click "Create":

An informational window will open showing where the support zip file has been saved to:

The Technical Support Wizard will create a zip file similar to those shown in the screenshot below:

The Support Zip File created by the wizard may then be attached to a Support Ticket.

Debug Logs

Debug logs are text files that are stored in the same folder as your profile settings. The folder in which profiles are stored is defined using Global Settings.


Quick Start

Start Using SyncBackSE Straight Away

information If you have not used a backup program before, we advise you spend a few minutes getting to know the basics by reading our New User Guide.

note

The 'take note' icon on the left is used throughout this help file and indicates advise that is of particular importance.

Three stage start

SyncBackSE can be up and running by following the following three stage process:

Step 1. When you first install SyncBackSE, the program will ask if you would like to:

· Evaluate the software

· Enter your Serial Number that you would have received by email after you have paid for SyncBackSE

Click the Buy button to visit our web store so you may pay for a license, or the Evaluate button to use the 30 day trial:

note

When in evaluation mode, the user can opt not to be reminded again until 7 days before the trial expires by clicking the box.

Step 2. The program will then ask if you would like to import any existing SyncBack freeware profiles. Please remember to ensure you browse to the correct folder if you chose to install a previous version of SyncBack freeware in a customized location. If you wish to import version 3 profiles, read our special guide .

Step 3. If you have not created any profiles in the past click the "New" button located on the lower left of the program window:

Creating your first Profile is a simple process with the help of the profile wizard. Once a profile has been created you need only click a single button to run that profile.

Need Help?

Read the Help Using SyncBackSE section of this help file which details the many ways you will find guidance and support when using the program.

note

Use the context sensitive help buttons that provide assistance by clicking the 'Help' button that you'll find on each program window. This will take you straight to the appropriate section in the help file.

SyncBackSE Evaluation Version

You have 30 days to evaluate SyncBackSE after which time you must uninstall it from your computer. You may buy SyncBackSE at any stage by visiting our web store.

Click to visit our Web Store


First Steps

Program Launch

When SyncBackSE is first launched, the evaluation window will be shown:

Do not try to manually enter the serial number as errors can easily be made.

The easiest way for you to enter your serial number is to copy your entire order email to the clipboard. SyncBackSE will find the serial number and automatically paste it into the text field. You can copy the email before SyncBackSE is running, or even when the serial number window is being displayed.

Click "OK" once the serial number has been entered.

note

The "OK" button will only appear once the serial number has been entered correctly.

How to Copy and Paste

Copying and pasting is the best way to ensure that you have entered the correct serial number, as it is easy to mistake the number zero '0', for the letter 'O'.

For those who are unsure on how to quickly copy and paste your serial number, here's how:

1. Run SyncBackSE or select 'Enter Serial Number' available via the Help menu:

The Evaluation window will open:

2. Run your email program and click once in the body of your confirmation order email.

3. Hold down the 'Ctrl' and 'A' keys on the computer keyboard. This will select the whole body of your email.

4. Copy by holding down both the 'Ctrl' and 'C' keys.

5. Paste by holding down the 'Ctrl' and 'V' keys.

Your serial number will be automatically pasted into the evaluation window:

6. Click the 'OK' button

Congratulations! You have now licensed SyncBackSE.

Safe Installation

All versions of SyncBackSE can be safely installed over an existing installation. By doing this, you will ensure any profiles you have created continue to be active.

Importing Profiles

To import a Profile use the 'Import Profile' menu item under 'Profiles'. Read the special section Importing V3 Profiles.


Importing V3 Profiles

Upgrading from SyncBack/SE V3 to SyncBackSE V5

If you've been using SyncBack/SE V3 you would have already created profiles. To import your profiles you will be asked to browse to the appropriate location on your computer. If you installed SyncBack/SE V3 using the default settings, SyncBackSE V5 will locate your profiles automatically for you, and you need only click 'OK' in the pop-up explorer-type window.

You may create a profile at any time by using the 'New' button on the lower menu, or selecting 'New' from the 'Profiles' main menu located at the top of the program window.

Learn more about Exporting/Importing Profiles in SyncBackSE.

'Difficult' to convert Profiles

Under certain situations the directory selections for a profile cannot be completely converted to the new format. Profiles that may not be converted correctly have the following characteristics in SyncBack V3 Freeware:

- The profile has the Let me choose which sub-directories to include option enabled (see point 1 below).

- The Ignore new directories (improves performance) option is not enabled (see point 2 below).

- A child directory (with no child directories of its own) has been selected but its parent directory has not been selected (see point 3 below).

SyncBack Freeware Screenshot

In the following situation when the settings are converted, two of the directory selections are lost (see point 4 below):

SyncBackSE V5 Screenshot

As you can see above, the directories sub-directory 1.1.1 and sub-directory 5.1.1 are no longer selected.

When SyncBackSE V5 is first run it will convert your profiles. If any of your profiles may have lost directory selections, then a warning message will appear listing the profiles that may be affected:

In the example above, a profile called Upgrading SyncBackSE which has the sub-folder "SyncBack Freeware" may be affected.

The new folder and file selections in V5 will now allow for complete control over what is to be copied and ignored. Unfortunately it is impossible to do a complete conversion of the old folder selection settings due to the storage method used in previous versions. We apologize for the inconvenience.


Creating Your First Profile

Creating Your First 'Profile'

A profile stores information about the folders or files you would like to backup or synchronize using SyncBackSE. Profiles can be very specific as to what, when, and how a given task is performed, but we are going to be concentrating on creating a simple backup profile.

The Profile Setup Wizard walks you though the process of setting up your profile. The default settings make setting up a Backup profile a very simple process.

Click the "New" button located on the lower left of the program window:

Alternatively, choose New from the Profiles menu:

The Profile Wizard window will appear. Enter a name for your new Profile:

Click Next located at the lower right of the window.

For this example we are creating a backup profile which is the default option:

The wizard will ask whether you wish to use FTP (File Transfer Protocol). FTP is used if you are backing up over the Internet. As the default No FTP option is selected by default, you need only click the Next button.

The wizard will now ask whether you wish to compress your files into a zip. Once again, the default option is being used in our walk through. The No Zip Files option has been selected:

Click the Next button on the lower right. The wizard will now request you enter a name for the source (where you are copying your files from), and that you select the location of the source by clicking the folder icon button:

When you click the folder icon a Browse For Folder window will appear in which you will locate your source. Click OK:

The folder selection field will now show the full path to your source:

Click the Next button. The Destination window will open.

Enter a name and select the location for where you wish to make a backup of your files to (the destination) in the new screen:

When you click the folder icon a Browse For folder window will appear in which you will locate your destination. Click OK:

After clicking the Next button on the destination screen you will be asked whether you wish to make a Fast Backup. Choose the No Fast Backup default option:

Click the Done button:

You have now setup your backup profile. A small informational window will appear informing you that the main Profile Setup Window will open:

The Profile Setup Window allows you to check your choices.

Click OK. A Window will open which asks whether you would like to perform a simulated run. This allows you to check the profile functions correctly without actually copying any files. Click Yes:

The Differences window will appear that shows all the files that would be copied in an actual run. Click Continue Simulation:

The main program window will now open. You may now run this backup profile at any time by selecting a profile and then clicking the Run button:

The final section of this Quick Start guide shows you how to Run Your Profile.


First Run

Running a Profile for the First Time

SyncBackSE processes files very quickly. Therefore, if you are only backing up or synchronizing a few files, you will may not see the progress bar at the bottom of the window.

note

Note the new icons of a window with a pause in the screenshot below that temporarily appear to the left of the profile being processed.

Clicking on an icon will either stop or pause a given task. The task is signified by the third icon, in this case a 'run' icon that appears to the left of Business.

A progress bar will appear at the bottom of the window as the files are being processed:

As the profile is being processed, an icon will also appear on the Windows Taskbar located on the bottom right of your screen:

SyncBackSE icon when a profile is not running

Animated SyncBackSE icon when a profile is running

Depending on your settings, the Differences Window may appear after the initial scan takes place. The Differences Window shows what will happen to the files (whether they will be copied, deleted, or moved). Once you have reviewed the differences, click "Continue":

note

Note how in the Differences Window, the toggle icon has been clicked to show more options:

note

In this example the Differences Window shows 2 collisions. A "collision" is when a file in the source and destination differ but have the same name. In other words, the file is in both the source and destination but is modified in some way, perhaps by date, size etc.

A notification of collisions occur in the Differences window which appears by default when making a backup (note however there are circumstances when the Differences window does not appear, for example when the user has chosen not to show the window).

Collisions are shown in red in the Differences window to highlight there are going to be changes made when you continue the profile task. If the user views the Differences window carefully, the user has the option to make choices about whether they want to accept the changes SyncBackSE will make. The user has the option to bypass these choices by selecting a specific item in the Differences window with a right click. A different action may then be chosen.

After the profile has been processed the main window will look slightly different as the temporary stop and pause icons are no longer viewable.

You have now successfully created a simple backup profile. To create a Group Profile you'll need to create two profiles or more. You'll then have the opportunity of running these profiles as one. To find out more about this feature go to Creating a Group Profile.


New User Guide

What SyncBackSE Does

SyncBackSE is designed to help you prevent data loss. This section of the help file aims to provide you with essential knowledge about what the program does to achieve this. There are four core tasks SyncBackSE does:

· Backup

· Synchronize

· Mirror

· Restore

SyncBackSE allows the user to make many, many decisions about how these core tasks are achieved.

note

Important: SyncBackSE copies, moves, and deletes data. Always ensure you test your settings, ideally with test files, before using them with your actual files. We try to make it very clear during the installation process that SyncBackSE is designed to be able to delete and replace files, so it must be used with caution. We also ensure the default options are set to a safe mode.

Good data processing procedure dictates that any program should be thoroughly tested with non-critical data before relying on it. SyncBackSE also features a 'Simulated Run' feature so that users can check to ensure the program is processing data in the way they expect before making an actual run.

The Simulated Run or Simulated Restore commands are available from the 'Task' menu or by right clicking on a profile:

Task Menu: Simulated Run

Right Click Menu: Simulated Run

What SyncBackSE can and cannot do

SyncBackSE can copy all of your files, but cannot make an exact copy of your system drive. SyncBackSE is designed to copy your important files, e. g. your pictures, documents, music, database, etc. You can always re-install the operating system and any programs, but you cannot recover your files unless you've made a backup. With SyncBackSE, making a backup of those files is quick and easy.

To make an exact copy of your system drive, you must use "disk imaging" software. With disk imaging, the entire disk (the parts that are used) is copied bit-by-bit. This means the copy will take up a lot of disk space and take much longer to copy.

Your Windows operating environment is constantly changing. Programs are installed, updated, uninstalled and settings are changed. Many important security specific applications are also regularly and automatically updated. Anyone who uses their computer to connect to the Internet should have in place Anti-Virus, Firewall and Anti-Spyware programs that are all readily available from within the Windows operating system. These issues, combined with the longer, costlier (more disks) and less convenient (more time consuming) disk imaging process inevitably means that for the average user, disk imaging is carried out far less frequently than the kind of backup SyncBackSE delivers.

SyncBackSE copies all your important files in a fast, up to date and reliable manner.


Source and Destination

Understanding the 'Source' and 'Destination'

SyncBackSE copies, moves and deletes digital files from one location to another. This helps you in your aim to prevent data loss.

To make the process of backing up simple to understand, we use the terms Source and Destination. The Source is a particular location and the Destination is a different location. In the example below, the Source is a workstation and the Destination is a Laptop:

You will create a Profile of both the Source and Destination, and define the Profile's actions (backup, synchronization, restore etc.).

You can also group profiles together so multiple actions occur, and then schedule these profiles to run automatically.

Backup

In the case of a simple backup operation, the Source is the place where files are copied from and the Destination is the place where files are copied to. For example, the Source could be the folder 'Your Computer Drive\My Documents\My Business Folder\' and the Destination could be a folder in an external USB drive 'My External Backup Drive\My Backup\My Business Folder\'.

SyncBackSE allows you to make choices about exactly what files are to be copied, moved, ignored or deleted during the backup, synchronization or restore process. You may decide, for example, to ignore certain files or folders when backing up. Therefore, it is not necessary to backup every file from the Source to the Destination.

When SyncBackSE first runs a backup, the program will copy all the files you require from the Source to the Destination. The next time you run the same backup task, SyncBackSE does not copy the unchanged files, but rather scans both the Source and Destination, notes what files have been changed and then asks you to confirm the action the program is about to take in the Differences Window. This makes subsequent backups a lot faster than the initial backup.

Synchronization

When it comes to Synchronization, viewing the source as a location where files are copied from is not accurate. Think of the source simply as a location, rather than as a location that always has a fixed task associated with it. The source can be thought of as the left side, and the destination as the right side.

In a synchronization operation for example, a file may be copied to the source rather than from the source, and at the same time another file may be copied to the destination. This may occur as you may have chosen options in SyncBackSE that request certain actions occur given certain criteria. For example, you may require that a file that is older on either the source or destination, must be replaced by the newer file (given they have the same name and file type).

As you can tell by the example above, synchronization is a more complex process than a backup process.

Mirror

Mirroring is used when you want the destination to be an exact copy of the source. It assumes that the destination is not changed by other programs or users, so it is not the same as a synchronization. Files are copied from the source to the destination, and not vice-versa. It is not the same as a backup because any files that are only on the destination are deleted. This means there are no 'orphaned' files in the destination.

Good data procedures

When you first use SyncBackSE, we advise you use the default options and simply backup, as this will prevent any unexpected and potentially unwanted actions to occur. As you become familiar with the program, you will begin to gain a deeper understanding of the Backup and Synchronization processes.

We have tried very hard to put as many checks and warnings in place in order to prevent you from accidentally losing data. We make it very clear during the installation process that SyncBackSE is designed to be able to delete and replace files, so it must be used with caution. We also ensure the default options are set to safe settings that will reduce the possibility of unwanted data loss to a minimum.

Good data processing procedures dictate that any program is thoroughly tested with non-critical data before relying on it. SyncBackSE also features a Simulated Run feature that you will be able to ensure the program is processing data in the way you expect before making an actual run. A Simulated Run does not move, copy, or delete any files, but will show the differences window for you to fully review what will occur in the case of an actual run.


Backup

An Explanation of the Backup Process

A backup copies files in one direction: from the source to the destination.

Note that a backup is not a synchronize process.

SyncBackSE can backup to the same drive; a different drive or medium (CDRW, CompactFlash, etc); an FTP server; a Network; or a Zip archive.

Backing Up

The examples on this page show different scenarios of when you might backup.

note

Note that the Destination needs to have enough free disk space to take all the backup data.

Here's an example of a local computer backing up to an external hard disk. The computer's drive is the Source, and the external hard disk is the Destination. Files will be copied from the source to the destination:

Usage: Backup files on your local C drive onto an external USB drive. This ensures you've got an accessible copy of your data, even if you experience problems with your main computer.

A second example shows a backup where the a laptop is the Source, and a workstation is the Destination:

Usage: Perhaps you've been on a business trip or on holiday and you've continued to update your documents. When you get back home you'll want to copy any new or changed files back onto your computer. A simple backup will achieve this.

The third example shows how a backup can run from one network computer to another:

Usage: You've setup a home network, and you use one of the computers on that network to work on, and another to backup to.

The example below shows a backup taking place from a local workstation to another remote computer using FTP (File Transfer Protocol):

Usage: You're on the move and work with a laptop. As you've got Internet access and FTP access to a website to upload files, you backup a copy of your data so you know if diaster strikes and your laptop is lost, breaks down, or is damaged in transit, your data is safe and easily retrievable.

The next example shows a backup to CD-R/DVD-R etc:

Usage: You want to backup all your family photos and movies to CD-R or DVD for archival purposes. Note that your CD/DVD must be formatted in UDF format before it can be used.

The final example shows a backup between a local computer and a memory stick:

Usage: You're at work and need to copy the documents that are located in different folders on your work computer to a memory stick. Once you've defined your profiles and grouped them using SyncBackSE, you'll click one button, and everything will be copied quickly and simply in a single action.


Synchronize

An Explanation of the Synchronize Process

A Synchronisation copies files in both directions: from the source to the destination, and from the destination to the source.

note

Note that the Destination and Source need enough free disk space to exchange the data.

SyncBackSE V4 introduced Smart Synchronization which copies files in both directions, but it also keeps a history of where files were during the last synchronisation. This allows for much finer control over what actions to take based on what has changed, and also allows it to detect changes such as the file only being modified in the source or destination.

It is advisable to use Smart Synchronization instead of the old style synchronization. By default any synchronization profile created using SyncBackSE will be a Smart Synchronization profile. However, a profile imported from older versions of SyncBackSE (or SyncBack freeware) may not be.

Note that the synchronization process is not the same as a backup process.

What is the difference between Synchronisation and Smart Synchronisation?

Smart Synchronization keeps track of what changed the last time the profile was run so that it knows if a file has been deleted, created, or changed since the last profile run. This helps you (and SyncBackSE) make an informed decision about what to do when something changes. It also gives you a comprehensive choice of options on what to do with a file when specific things happen, e.g. the file is deleted for the source but not the destination. Old style synchronization does not keep track of changes and has a limited set of options. Whenever possible you should use Smart Synchronization instead of the old style synchronization.

Synchronizing the Source and the Destination

Here's an example of a computer drive being synchronized with an external hard disk. Files will be synchronized between the source and the destination:

Usage: You use two separate drives, one for business, another for home use. Some files are on both drives, like your diary. Synchronization ensures that whatever drive you work on, the other drive is updated with your new diary items.

A second example shows a laptop (Source) and workstation (Destination) being synchronized:

Usage: You work on the move and at home and want to ensure both your laptop and workstation have the same up to date files. You achieve this by Synchronizing your two computers.

The third example shows a synchronization running from one network computer to another:

Usage: You work on a networked computer and often change files that others will also view and change during the course of a day. Synchronization helps to ensure that whoever is working on the file does so with the most up to date version.

The final example shows a local computer and a memory stick being synchronized:

Usage: You've updated many documents over the course of the day. At one point you used a memory stick to load some documents as you worked on a computer other than your usual one, but you can't remember the exact name of those documents. When you return to your main computer you run your synchronization profile. SyncBackSE copies files in both directions, ensuring that both the memory stick and your main computer have the same up to date documents.


Mirror

An Explanation of the Mirror Process

Mirroring ensures that one drive (or folder) contains the same files as another drive (or folder). It is not the same as a backup because it deletes files. It is also not the same as synchronization because it only copies files in one direction.

Mirroring

The examples on this page show different scenarios of when you might mirror files.

note

Note that the Destination needs to have enough free disk space to take all the data.

Here's an example of a local computer mirroring to an external hard disk. The computer's drive is the Source, and the external hard disk is the Destination. Files will be copied from the source to the destination and any files that are only on the Destination are deleted:

Usage: Mirror files from your local C drive to an external USB drive. This ensures you've got an identical copy of your data, even if you experience problems with your main computer. It is different from a backup because there are no 'orphaned' files in the destination.


Restore

An Explanation of the Restore Process

Being able to easily restore data is a core function of SyncBackSE. Here are some example scenarios of when you'll want to run a restore operation:

· You inadvertently delete a file and/or folder and need to recover it easily and quickly.

· As you're working on a document, the parent program unexpectedly crashes and your work is gone. If you've setup a backup to run in the background, you'll be able to restore to the last backup point.

· Your computer suffers a catastrophic failure, and you cannot access any files or folders. Having backed up onto an external drive or disk, you will be able to easily restore your valuable files onto a new computer.

A restore operation swaps the source and destination directories: i.e. the source directory becomes the destination directory and visa-versa:

Usage: You have inadvertently deleted the wrong files. You quickly restore your files from an external hard drive back onto your main computer, then continue to work with little impact on your time or overall stress levels.

Usage: Your main computer suffers a serious security attack and your document files have been badly affected. After reinstalling Windows you are able to also restore your valuable document files to the state they were prior to the attack.

note

Note that a restore may not work in the way you expect it to: e.g. some of the files in the destination directory may be older than their equivalent entries in the source, and therefore may not replace the source entries (depending upon what your settings are).

If in doubt use the 'Simulated Run' feature in SyncBackSE. A simulated run will show you what will happen to your files, without actually copying, moving, or deleting files.

Running a restore operation is not reversible.


Automating SyncBackSE

Scheduling and Background Tasks

SyncBackSE provides a number of ways to run a profile (see below for a complete list) however, there are two methods to run a profile based on the date and time:

· Scheduling with the Windows Task Scheduler.

· Have a profile configured to run in the background.

A profile can be both scheduled and set to run in the background.

Scheduled Tasks

window-gear

The Windows operating system comes with an integrated scheduler (the Windows Task Scheduler).

This scheduler lets the user configure Windows so that certain programs are run at certain times, e.g. every day at 9am. For example, most anti-virus software will prompt you to create a scheduled task to scan your computer for viruses every morning. There are a number of advantages to scheduling profiles:

· A scheduled profile can be configured to run even when you're not logged in or if someone else is logged in.

· A scheduled profile can switch the computer on (from hibernation or standby) to run the profile.

· The date & time of when the profile is run, and how often it is repeated (e.g. daily), is highly configurable.

· You do not need to have SyncBackSE running to have a profile run at the scheduled times.

This help file has a special section that shows you how to Create a Schedule.

Background Tasks

run-syncbackse

SyncBackSE has the ability to run profiles at periodic intervals,

e.g. every 2 hours.

This is different from scheduling a profile because it is not based on a specific date & time but instead the frequency. There are a number of disadvantages to having a profile run in the background:

· You must be logged in for the profile to run.

· SyncBackSE must be running for the profile to run.

· The profile can only be configured to run every x seconds/minutes/hours and not at a specific date or time.

If profiles are configured to run in the background then it's best to configure SyncBackSE so that it starts automatically when you login to Windows.

This help file has a special section that shows you how to Create a Background Task.

Which method should be used?

In general it is better to schedule a profile instead of having it run in the background. However, if you want a profile to run frequently (e.g. hourly) then it is advisable to both schedule the profile and have it set to run in the background. This gives you the best of both worlds: your backup will be performed even when you are not logged in, and your backups will be performed frequently while you are working so that if you need to restore a file the backup copy will be more recent.

Situations under which a SyncBackSE Profile can be run

The list below shows all the situations and configurations in which a SyncBackSE profile can be run:

· Manually run, e.g. profile selected in main window and the Run or Restore buttons are pressed
· Scheduled (note that schedules can also be set to run every x minutes, hours, etc. and not just once or daily, weekly, monthly etc.)
· Run when a hot-key is pressed (see When -> Hot-key)
· Run on Windows startup or shutdown/logoff (see When -> Login/Logout)
· When files or folders in the source or destination are changed (see When -> Changes)
· Run when a device is attached/inserted, e.g. a CD, a USB flash key, etc. (see the When -> Insert)
· Set to run in the background (see When -> Periodically)
· Run externally from the command line, a batch file, or another program
· Run as part of a Group Profile which is run by one of the above methods


Using SyncBackSE

A Guide to Using SyncBackSE

SyncBackSE is a powerful, easy to use commercial program that helps you backup and synchronize your files to: the same drive; a different drive or medium (CDRW, CompactFlash, etc); an FTP server; a Network; or a Zip archive. SyncBackSE can copy locked and open files as easily as the usual closed files. This allows you to backup, synchronize and restore any data you wish to.

Using SyncBackSE guides you through the essential functions and operation of SyncBackSE.


Basic Operation

Essential Knowledge

If you have never used SyncBackSE before, you are strongly advised to read this section of the help file:

Basic Operation

The Main Window

Exporting and Importing

Creating a Profile

Running a Profile

Creating a Group Profile

Restoring a Backup

Creating a Schedule

Preferences Main Menu

Columns Main Menu

Global Settings

Dialogs

Comparison Programs

Log Settings

Exploring SyncBackSE


The Main Window

SyncBackSE: The Program Interface

SyncBackSE is a simple program to use with many options and user definable parameters. The program is perfect for the novice and expert alike.

All the essential tasks in SyncBackSE can be carried out from the main window by clicking an icon on the lower toolbar:

SyncBackSE also has a main menu that provides easy access to all it's functions, and a right click pop-up menu that is available when a profile is highlighted:

The main window below shows SyncBackSE running a backup 'Profile' called 'Business':

Once a Profile has been defined, the user need only click the 'Run' or 'Restore' buttons to carry out the task. Alternatively the Profile can be scheduled to run at certain times and dates:


Exporting and Importing Profiles

Exporting and Importing Profiles

You can copy a profile from one installation of SyncBackSE to another by exporting and importing profiles. This also lets you make a backup of your profiles settings.

· To export a profile: select the profile (or profiles) in the main window and select Profiles -> Export Profile from the main menu. Then choose where to save the profile. To export all your profiles press Ctrl-A then select Profiles -> Export Profile from the main menu.

· To import a profile: select Profiles -> Import Profile from the main menu then choose the file(s) that contains the profile. You can import profiles from any current or previous version of SyncBackSE or SyncBack. When importing profiles exported from versions of SyncBack or SyncBackSE V3 then some directory selections may not be imported. It is recommend that group profiles are imported last to ensure the profiles in the group exist at the time the group is imported.

Important

· Profiles exported from Windows 2000 or later cannot be imported on computers running Windows 95, 98, 98SE, or Me.

· It is not recommended to import profiles exported from newer versions of SyncBackSE.

· Profiles exported from old versions of SyncBackSE or SyncBack (V3 and before) will import incorrectly if the Windows XP/2003 non-Unicode locale is different. For example, if you import a V3 profile exported from XP where Chinese was the non-Unicode locale, then you must set your non-Unicode locale to Chinese.

Importing SyncBackSE Version 3 Profiles

If you are upgrading from SyncBackSE V3 and wish to import your profiles, read our special guide to Importing V3 Profiles.


Creating a Profile

SyncBackSE Profile Types

Profile Types

Choose a Backup profile when you want to backup (copy) your new and modified files to another place, e.g. an external hard drive or an FTP server.

Choose a Synchronization profile when you have two directories in which files are changing and you want them both to contain the same files. For example, you may have a directory on your computer containing documents you are working on. A colleague may also be working on documents on his computer. If you want to copy his new and modified files to your local directory, and copy your new and modified files to his directory, then you need to use a Synchronization profile.

What is the difference between Synchronization and Smart Synchronization?

Smart Synchronization keeps track of what changed the last time the profile was run so that it knows if a file has been deleted, created, or changed since the last profile run. This helps you (and SyncBackSE) make an informed decision about what to do when something changes. It also gives you a comprehensive choice of options on what to do with a file when specific things happen, e.g. the file is deleted for the source but not the destination. Regular Synchronization does not keep track of changes and has a limited set of options. Whenever possible you should use Smart Synchronization instead of regular Synchronization. If you import a sync profile from SyncBack/SE V3 then it will not be using Smart Synchronization (as that feature was not available in older versions).

Choose a Group profile when you want to create a profile that contains other Backup or Synchronization profiles. This allows you to run many profiles at once.

So what is the difference between a backup process and a synchronization process?

note

A backup process copies files in one direction: from the source to the destination. A Synchronization process copies files in both directions: from the source to the destination and from the destination to the source.

Creating Profiles

A profile stores information about the folders or files you would like to backup or synchronize using SyncBackSE.

note

Once you've created a profile you'll be able to click a single button on the toolbar to carry out a specified task in the future.

Click the "New button located on the lower left of the program window:

Alternatively, choose "New" from the Profile menu:

The Profile Wizard window will appear. Enter a name for your new Profile:

Click "Next" located at the lower right of the window.

For this example we are creating a backup profile which is the default option:

The wizard will ask whether you wish to use FTP (File Transfer Protocol). FTP is used if you are backing up over the Internet. As the default "No FTP" option is selected by default, you need only click the "Next".

After clicking "Next" the wizard will ask whether you wish to compress your files into a zip. Once again, the default option is being used. Here is the screenshot of the "No Zip Files" option:

Click "Next". The wizard now requests you enter a name for the source (where you are copying your files from), and that you select the location of the source by clicking the folder icon button:

When you click the folder icon a "Browse For Folder" window will appear in which you will locate your source. Click OK:

The folder selection field will now show the full path to your source.

Click the "Next" button. The choose Destination window will open.

Enter a name and select the location for where you wish to make a backup of your files to (the destination) in the new screen:

When you click the folder icon a "Browse For folder window will appear in which you will locate your destination. Click OK:

After clicking the "Next" button on the destination screen you will be asked whether you wish to make a Fast Backup. Choose the "No Fast Backup" default option:

Click the "Done" button:

You have now setup your backup profile. A small informational window will appear informing you that the main Profile Setup Window will open:

The Profile Setup Window allows you to check your choices.

Click "OK". A Window will open which asks whether you would like to perform a simulated run. This allows you to check the profile functions correctly without actually copying any files. Click "Yes":

The Differences window will appear that shows all the files that would be copied in an actual run. Click "Continue Simulation":

The main program window will now open. You may now run this backup profile at any time by selecting a profile then clicking the "Run" button:

The next section of this help file shows you how to 'Run' the Profile.


Running a Profile

SyncBackSE in Action

To run the Profile select the profile in the main program window, then click the 'Run' button:

A progress bar will appear as the files are being processed:

As the profile is being processed an icon will also appear on the Windows Taskbar located on the bottom right of your screen.

SyncBackSE icon when a profile is not running:

Animated SyncBackSE icon when a profile is running:

Depending on your settings, the Differences Window may appear after the initial scan takes place. The Differences Window shows what will happen to the files (whether they will be copied, deleted, or moved). Once you have reviewed the differences, click "Continue":

note

Note how in the Differences Window, the toggle icon has been clicked to show more options:

note

In this example the Differences Window shows 6 collisions. A "collision" is when a file in the source and destination differ but have the same name. In other words, the file is in both the source and destination but is modified in some way, perhaps by date, size etc.

A notification of collisions occur in the "Differences" window which appears by default when making a backup (note however there are circumstances when the "Differences" window does not appear, for example when the user has chosen not to show the window).

Collisions are shown in red in the "Differences" window to highlight there are going to be changes made when you continue the profile task. If the user views the Differences window carefully, the user has the option to make choices about whether they want to accept the changes SyncBackSE will make. The user has the option to bypass these choices by selecting a specific item in the Differences window with a right click. A different action may then be chosen.

After the profile has been processed the main window will look slightly different as the temporary "stop" and "pause" icons are no longer viewable.

You have now successfully created a simple backup profile. To create a Group Profile you'll need to create two profiles or more. You'll then have the opportunity of running these profiles as one. To find out more about this feature go to Creating a Group Profile.


Creating a Group Profile

Group Profiles

Once you have created two or more profiles you may group them together. Group profiles are collections of profiles. This allows you to run multiple profiles in one go instead of having to run each profile one after another. This page of SyncBackSE Help runs through the simple procedure you'll need to follow.

Creating a Group Profile

Click the 'New' button from the Toolbar (or 'New' from the main menu or right-click menu).

Enter a name for your profile:

Select the fourth option 'Group' from the list:

Click Next. An informational window will open informing you that the Profile Setup window will open. You may click the "Do not prompt me again" if you do not wish to be notified of this in the future:

The Profile Setup window relating to Groups will now open. In the group profile below there are three profiles: "Business"; "Website"; and "Drafts". The "Personal" and "Photos" profiles are not in the group. You can add and remove profiles from the group using the <. <<. >, and >> buttons. You can order the profiles in the group by selecting one or more profiles and using the up and down buttons on the right. Profiles in the group are executed in the order displayed (first to last).

After you click "OK" the main program window will show the group. Note how in the screenshot below the small box to the left of the "Group" profile has been clicked to show what profiles are in the group:

To alter the profiles in a group, select a Group Profile in the main window (you may also select 'Profiles' > 'Modify' from the main menu or right click and select 'Modify'). The 'Group Profile' window will then appear so you may redefine or change your group choices.

Modifying Group Profiles

Select your group profile and click the Modify button. The Profile Setup Window will open. You can change what profiles are associated with a group and the settings for the group. For help on the other settings see the Easy Mode and Export Mode Configuration sections.

Run profiles in parallel: By default, the profiles in a group are run in the order you provide, from first to last. The next profile is started once the previous one finishes. You can choose to have all the profiles in a group run at the same time by enabling this option. It is not recommended you select this option because it will probably increase the time taken to run the profiles. If, however, you have more than one CPU or multiple drive controllers, then it could reduce the time.

Expert Options

Additional settings are available when choosing the "Expert" options from the Options drop down menu or by going to the Expert settings page:


Restoring a Backup

Backup Restoration

Restoring a backup in SyncBackSE is a simple matter of selecting a profile and clicking the 'Restore' button located in the lower menu (you may also select 'Restore' from the main menu under 'Task', or 'Restore' from the right-click menu).

When a profile is run as a Restore the following dialog appears (unless you kept the SHIFT key pressed while clicking the Restore button, or you have previously switched off this dialog):

Click Yes to continue. The Restore Wizard then analyzes your profile and will ask a set of questions related to how you want the files restored. Note that some of the question may not appear if your profile is configured in such a way that the question is not required or relevant. Once you have gone through all the steps (or click the Restore Now button to skip all the steps) the restore process will begin.

After these steps, and the source/left and destination/right are scanned, the Differences window will appear. This gives you another opportunity to abort and also examine and optionally changes which files will be restored and how they are restored.

note

If your backups are incremental or differential, i.e. you are using variables in your destination, then you'll need to think about what order to restore in.

For a differential backup you would restore the full backup first, followed by the newest differential backup. However, if your last backup run was a full backup then you only need to restore from the full backup.

For an incremental backup you would restore the full backup first, followed by oldest incremental backup to the newest incremental backup. However, if your last backup run was a full backup then you only need to restore from the full backup. For example, if your backups are stored at D:\My Backup\%DAYOFWEEK%\, and you do a full backup on Monday, and today is Wednesday (and today's backup has already run) then you'd restore Monday first (D:\My Backup\1\), then Tuesday, and finally Wednesday. This makes sure you have the newest files restored as they will overwrite older files already restored. It also makes sure you restore all your files because the incremental backup directories will only contain some of your files.

Last Run

If the last run of the profile was not a success then the following question will be asked:

Click Yes to continue to the next step, or click No (or Abort) to abort the restore.

Moving

If the profile, or one of the profiles in the group, is configured to move files then the following question will be asked:

Obviously when restoring you would not want your backup files moved as you would lose your backup files. It would be better to copy them so after the restore you still have the backup files. It is recommended that you abort the restore and reconfigure your profile to not move files. You can then restore and afterwards change the profile configuration back to its original settings.

Delete All Files

If the profile, or one of the profiles in the group, is configured to delete all the files in the source/left and/or destination/right then the following question will be asked:

Obviously when restoring you would not want your backup or original files deleted. It is recommended that you abort the restore and reconfigure your profile to not delete all the files. You can then restore and afterwards change the profile configuration back to its original settings.

Delete Files

If the profile, or one of the profiles in the group, is configured to delete files that are only in the destination/right then the following question will be asked:

When restoring you would probably not want files only in the source/left to be deleted (as this is a restore the source/left becomes the destination). It’s recommended you click Yes to skip the files instead of deleting them.

Newer Files

If the profile, or one of the profiles in the group, is not configured to keep newer files then the following question will be asked:

When restoring you probably do not want to replace any newer original files with older backup files. It’s recommended you click Yes to skip the older files.

Before/After Programs

If the profile, or one of the profiles in the group, is configured to run a program before and/or after the profile then the following question will be asked:

When restoring you may not wish to run those programs. Click Yes to still run the programs, or No to not have them run.

Restore To

You are given the opportunity to restore to a different folder. This is especially important if your source/left folder (where the files will be restored to) contains variables:

Restore From

You are given the opportunity to restore from a different folder. This is especially important if your destination/right folder (where the files will be restored from) contains variables:

Reverse Group

In some cases you may want the group to run in reverse. For example, if you have a group that does a backup to a Zip file then copies the Zip file to an FTP server you probably need to run this in reverse, i.e. first retrieve the Zip file then unzip.

Replace Prompt

If you are restoring from a spanned/split Zip file and the profile is configured to prompt if a file cannot be replaced because it is busy, then you are asked if you’d instead like to replace those files on reboot. The reason is because no prompt can be made in this situation.


Creating a Schedule

Scheduling SyncBackSE

SyncBackSE interfaces with the Windows Task Scheduler to allow you to run profiles automatically at certain times, e.g. run a backup profile every day at 5am. On Windows XP you can access the task scheduler via the Start menu (All Programs > Accessories > System Tools > Scheduled Tasks). On Windows Vista you can access the task scheduler via the Start menu (All Programs > Accessories > System Tools > Task Scheduler).

For an overview of scheduling and background tasks go to Automating SyncBackSE.

Creating a Schedule

To create a schedule for a profile, select the profile on the main screen and click the Schedule button (you can also click the Schedule button when modifying a profile). If there is no schedule for the profile, a dialog box will appear (if you have a schedule already then a different window will appear - see Modifying a Schedule below).

There is no schedule for the profile 'The Name of Your Profile'. Would you like to create one?

Click Yes.

On Windows, by default, you are not allowed to use blank/empty passwords when scheduling tasks. If this is the case on your installation of Windows then a prompt will appear asking you if you would like the restriction removed (no prompt is given if the restriction has already been removed):

Click Yes to remove the restriction. If you Windows login password is blank/empty, and this restriction is not removed, then your scheduled task will fail to run.

Users on Windows Vista

The following windows will appear if you are using Windows Vista or newer. For Windows XP, 2000, and 2003 see the section Users on Windows XP, 2000, and 2003 below.

In Windows Vista you can choose to run a profile daily, weekly, or monthly (for other repeating type you'll need to edit the schedule directly using the Task Scheduler):

· Run only when user is logged on: If this checkbox is ticked then the profile will only run at the scheduled times if you are logged into Windows. The benefit of this method is that you do not need to enter your Windows login password. The drawback is that you must be logged on for the profile to run.

· Run whether user is logged on or not: If this checkbox is ticked then the profile will run even if you are not logged in. You will need to enter your login password, unless the "Do not store password" option is ticked.

· Do not stored password: If you are performing a backup/sync with an internal drive, or an external drive, then you can tick this checkbox. In this case you do not need to enter your Windows login password. However, if you are performing a backup/sync with a network drive, or are accessing the network, you should not use this option otherwise the schedule may fail to run.

Note that if you have no password then SyncBackSE may not prompt you for your Windows login password (as it will test to see if your password is blank).

Users on Windows XP, 2000, and 2003

A dialog will then appear to remind you that you must set your login password for the schedule even if you do not have a password. This dialog box is a reminder to tell you to enter your password on the next screen (otherwise SyncBackSE will not run at its scheduled time). Click OK.

Please click the 'Set password...' button on the next screen to enter your login password.

Click "OK".

note

Note that by default a profile is run minimized (hidden) and will not prompt you.

If there is a 'Set password' button then click it. You must now enter your Windows login password twice, and then click OK. If you have no Windows login password then do not enter anything and click OK. You are then returned to the previous dialog box.

Click the Schedule tab.

By default, SyncBackSE will create a schedule to run the profile every day at 9am. You can change the schedule on this screen. There is also an "Advanced" button which provide additional scheduling settings:

See the Windows help file for more information.

Click the Settings tab. See the Windows help file for more information on this screen:

See the Important Scheduling Information section below for more information.

Modify a schedule

If you already have a schedule for a profile, when you click the Schedule button the following window will appear.

This window displays information on the schedule for the profile, e.g. what its schedule is and the current status. You can delete or edit the schedule by clicking Edit Schedule.

Important Scheduling Information

There are some important points to remember about the Windows scheduler:

· If you are using power saving features in Windows, e.g. your computer goes to stand-by or hibernate after a certain period of inactivity, then you must enable the 'Wake the computer to run this task' option in the scheduler. This will wake your computer to run the task at the appointed time.

· If you change your Windows login password then you must remember to change the password for your scheduled tasks

· SyncBackSE can accept a number of Command Line Parameters.

· To have SyncBackSE start with Windows you need to select Preferences > Options from the main menu, then tick the option Start With Windows.

Common Problems

There are a number of possible reasons why the scheduled task may not run:

· Check to see what error message is returned from the Windows Task Scheduler. On Windows XP you can do this by Start > Control Panel > Scheduled Tasks. You can now see a list of all scheduled tasks on your PC. Scroll to the right and look at the Status column. This will contain the error message. On Windows Vista you can do this by Start > All Programs > Accessories > System Tools > Task Scheduler. Expand the tree on the left so it is Task Scheduler (Local) > Task Scheduler Library > 2BrightSparks > SyncBack > [your username].

· You must use your Windows login password.

· You are using the wrong username and/or password. You must use your Windows login password.

· The scheduled task may not be set-up correctly to wake the computer if it is hibernating or in standby mode.

· The scheduler may be stopped or not installed. See your Windows documentation for details on how to start or install it. For Windows XP you can start the task scheduler by: Start > Control Panel > Scheduled Tasks then selecting Advanced > Start Using Task Scheduler from the main menu.

· The scheduler may be paused. For Windows XP you can resume the task scheduler by: Start > Control Panel > Scheduled Tasks then selecting Advanced > Continue Task Scheduler from the main menu.

· Profiles are user specific, they are not visible to every user on the computer. This means when you create a profile under a Windows username, and logout and login as a different Windows user, then you will not see the profile created as the other user. When scheduling a profile make sure your scheduled task is being run as the user who created the profile (this is the default when new schedules are created).

· If you are a member of a domain check that the correct username is being used for the scheduled task. By default your local (machine) username may be used, but it may be that you must use your domain username (domain\username).

· You should also make sure the user account has the necessary Windows user rights. To do this, run the Local Security Policy control panel applet (in the Administrative Tools section of the control panel). If you are using the home version of Windows then you may not have access to the Local Security Policy control panel applet (Microsoft have removed the feature from home versions of Windows).

Make sure that the user account has the following user rights:

* Act as part of the operating system

* Log on as a batch job

* Log on as a service

Make sure the user account is not listed in the following user rights:

* Deny logon as a batch job

* Deny logon as a service

Alternatives

Note that you are not forced to use the Windows Task Scheduler. You can use 3rd party schedulers instead, but the drawback is that SyncBackSE will not know the task is scheduled (it will still run as that is the job of the Windows scheduler), and the schedule options (to create and delete a schedule) will still use the Windows Task Scheduler. There are a number of free alternatives to the Windows Task Scheduler, e.g. Kirby Alarm.


Preferences Main Menu

Program Options

Only show groups and profiles not in a group

If ticked then profiles that are in a group profile are not shown (except as part of the group(s) they are in), groups are shown, and profiles that are not in a group are shown. If unticked then all profiles are shown.

Options

This opens a window where you can change settings that apply to the entire program. See this page of the help file for more details. The Options window is available from the main menu: 'Preferences' > 'Options':

Dialogs

This opens a window where you can change which dialog boxes appear. See this page of the help file for more details.

Scripts

sbpro-feature-16x16 Scripting is a Pro only feature. This opens a window where you can extend the abilities of SyncBackSE by using scripts. See this page of the help file for more details.

Comparison Programs

This opens a window where you can change which programs are used in the Differences window to compare the contents of files. See this page of the help file for more details.

Language

The language used can be changed using this menu. Note that only the translated languages installed are listed. By default the language selected during installation is used.

Font Selection

You can change the default font used by SyncBackSE. This font is used on all screens. Note that the style, e. g. bold, will be used when displaying filenames, but will not be used for text labels, buttons, etc. The font size is fixed at 8 (9 if you are using Windows Vista). Changing the font (and it's Script) is useful when using other languages with SyncBackSE.

· Use default Windows colours whenever possible: If you are visually impaired and use a special Windows colour scheme, e.g. High Contrast, then you should enable this option. It will force SyncBackSE to use the default colours whenever possible. Note that you must exist and restart SyncBackSE if you change this option.

Double-click Action

You can select what action SyncBackSE should take when you double-click on a profile.

Log Settings

This opens a window where you can change how profile log files are created. See this page of the help file for more details.

Open .sps files with SyncBackSE

Exported profiles have the filename extension of SPS. If another program has set itself as the default program for opening SPS files, then this menu item will appear allowing you to change it back to SyncBackSE.

Output Debug Information

If this menu item is ticked (enabled) then when profiles are run, or profiles modified, then a debug file is created. This debug file will contain detailed information that allows 2BrightSparks to pin-point any errors or problems with the program (it is used by the Technical Support Wizard). By default this item should not be ticked. Only tick this menu item when instructed to do so by 2BrightSparks technical support. When enabled it can significantly reduce performance.

Hide The Button Panel

If this menu item is ticked (enabled) then the button panel is hidden. To change where the button panel is displayed then right-click on it and choose from the pop-up menu.

Minimize To Tray

If this item is ticked then SyncBackSE will minimize to the system tray (also called the Notification area in Windows XP) instead of to the task bar.

Minimize On Close

If this item is ticked then SyncBackSE will minimize instead of closing (exiting) when the Close button (the X button in the applications title bar) is clicked. In this case you must click the Exit button to close SyncBackSE.

Minimize On Run

If this item is ticked SyncBackSE will minimize automatically when a profile is run.

Disable Hibernate/Standby

If this item is ticked then SyncBackSE will stop your computer from hibernating or going into standby power saving modes if any profiles are running. If your computer is using batteries this option is disabled and cannot be used. Note that if your computer is running on batteries, and your batteries are low, SyncBackSE will automatically pause all running profiles and display a warning message. SyncBackSE can put your computer into hibernate or standby mode after profiles are run. For more information, see the page Command Line Parameters.

Do not auto-pause profiles when computer is suspended

If this item is ticked then SyncBackSE will not pause all the profiles when the computer is suspended. Otherwise if the computer is suspended, e.g. you close the lid on a notebook computer, then SyncBackSE will pause all the profiles immediately. After the computer is woken it will automatically resume the profiles that were suspended.

Shutdown computer when all the profiles have finished

If this item is ticked then SyncBackSE will shutdown the computer as soon as all the profiles have completed. This can be useful if you need to leave the office and a long running profile is currently running.


Columns Main Menu

Program Options

The main window has a number of columns that provide information on the profiles. You can choose which columns to display via the Columns main menu.

· Stop: When a profile is running you can click on the icon shown in the Stop column to stop the profile. If you stop a profile that is being run as part of a group then all the other profiles in the group will also be stopped.

· Play/Pause: When a profile is running you can click on the icon shown in the Stop column to pause/continue the profile. Note that when a group profile is run (and it is not set to run the profiles in parallel) it will run the profiles in the group one after another. Those in the group waiting to run are paused until the previous profile in the group has finished. SyncBackSE will then automatically continue the profile when it is its turn to run.

· Type: The type of profile, e.g. Backup, Fast Backup, Smart Sync, etc.

· Last Run: When the profile was last run. If it has not been run yet then it will show Never.

· Result: The result of the last profile run. Note that if any file fails to be copied, moved, or deleted, for any reason at all, then the profile run is considered a failure. Success is when there were no errors.

· Next Run: When the profile will next be run. You can run the profile manually at any time (unless it is disabled or already running).

· Source / Left: The source/left folder.

· Destination / Right: The destination/right folder.

· Background: If the profile is set to run in the background, e.g. every 30 minutes or whenever there are changes in the source or destination, then this column will contain the details.

· Progress: When a profile is running this column shows the same information shown in the progress bar.

· Last Successful Run: The date & time the profile was last run without error. If it has not yet run without any errors then it will show Never.

· sbpro-feature-16x16 With the Pro version you can add your own columns by using scripting.


Global Settings

Program Options: Global Settings

Global Settings - Easy

· Stop background backups from starting: If ticked, any profiles set to run in the background (periodically, or via a file/folder change) will not be started. This does not affect scheduled tasks.

· Stop all running profiles when Windows is shutdown or restarted: If enabled then when you shutdown or restart Windows then all running profiles will be stopped.

· Prompt me to remove the blank password restriction on the Windows Scheduler: By default you cannot use a blank/empty password when scheduling tasks. If this item is ticked then whenever you schedule a profile, and you are using Windows with this restriction, you will be prompted to ask you if you'd like SyncBackSE to remove that restriction. Note that you will not be prompted if the restriction has already been removed.

· Check periodically for new versions: If ticked then SyncBackSE will check, every 30 days, if a new version of SyncBackSE is available. See also the Update Check button (to check for a new version immediately) and also the Help -> Update Check main menu item. Internet access is required to check for new versions.

· Start with Windows: If ticked, SyncBackSE will start after Windows is rebooted. It will start minimized. If you have profiles set to run periodically (not via a schedule), or to run whenever there are changes, it is recommended you use this option.

· Change the tray icon if any profiles have failed: If ticked, and any profiles fail when run, then the icon shown in the system tray will change to indicate this. To reset the icon, e.g. you have reviewed the failed profile(s) and are aware of the problem, then right-click on the SyncBackSE tray icon and select Reset tray icon.

o Reset tray icon when the newest log of a failed profile is displayed: If ticked then the tray icon is automatically reset when the newest log of a profile (that has failed) is displayed. Viewing older logs, or logs of profiles that haven't failed on their last run, will not reset the tray icon.

· Use the Windows Event Log: If ticked (the default) then errors are recorded in the Windows Event Log.

· Amount of time to pause after resuming from hibernation or sleep: If the computer is put into sleep or hibernate mode, then resumed, this is the number of seconds that SyncBackSE will pause (sleep) before it does anything. This gives Windows time to re-establish network connections etc.

· Amount of time to delay before background profiles are started…: When SyncBackSE is started it will wait this amount of time before the first background profile is started. This gives you time to disable background tasks or to exit SyncBackSE before they start.

· Highlight profiles that have not run successfully for…: If the value is above zero then any profiles that have not run successfully for that number of days will have an alarm clock graphic placed next to their name in the main window. This lets you clearly see which profiles are not running as expected. Note that disabled profiles are ignored and it does not apply to group profiles.

Global Settings - Expert

· Put new, imported, and copied profile settings files into...: SyncBackSE V4.0 and earlier stored settings in the Windows registry and also in the same folder as the program. Starting from SyncBackSEV4.1 the registry is no longer used and all settings are stored in files. This setting defines where to put the settings files for new profiles. It is recommended that Automatic is used as this will store new profiles in the same folder as SyncBackSE when it is run from removable media, or the C:\Documents and Settings\[username]\Local Settings\Application Data\2BrightSparks\SyncBack\ folder when not (if using Windows XP, for Vista it will be C:\Users\[username]\AppData\Local\2BrightSparks\SyncBack\).

· Backup all profiles when the program exits: By default a backup is made of all the profiles when SyncBackSE exits. This setting defines where to put those files (they are exported profile files). If you have a large number of profiles then you may wish to disable this option and backup your profiles manually (you can use the –export command line parameter to export all profiles).

warning

So as not to interfere with the Windows shutdown/restart/logoff process, profiles will not automatically be backed up if SyncBackSE is exiting due to a Windows shutdown/restart/logoff.

· Progress update frequency: If you move the slider to the far left then the progress bar will be updated very frequently. If you move it to the far right then they will be updated less frequently. Note that the more frequently the progress bar is updated then the slower the profiles will run. You can reduce the profile run time by reducing the update frequency.

· … after profiles have run when configured to run on shutdown/restart: If you have a profile that is set to run on Windows shutdown or restart, then this setting tells SyncBackSE what to do after that profile has run. Unfortunately Windows does not tell SyncBackSE whether the user wants to shutdown or restart, so this setting is used to define what to do.

note

This option is not required on Windows Vista as Microsoft have changed the shutdown/logoff process and corrected this flaw.

· Update Check: If this button is clicked a check is made to see if a new version of SyncBackSE is available for download. You can also check via the Help main menu. Internet access is required to check for new versions.


Dialogs

Program Options: Dialog Settings

Many dialogs displayed by SyncBackSE have the “Do not prompt me again” checkbox:

When ticked the dialog will not be displayed again and instead your answer will be used in future. Sometimes, however, you may want the dialog to be displayed again.

Profile: Some dialog boxes are profile specific, meaning whether they are displayed or not depends on the profile being run. This list-box lists all the profiles and *Program*, which is for dialog boxes that are not for profiles but for the program itself. When the selection is changed the items in Dialog text is changed.

Dialog text shows which dialog boxes have been configured not to be displayed again. It shows the text of the dialog box along with the result that is used instead of showing the dialog box, e.g. OK. If you want the dialog box to be displayed simply untick the item. If you want all dialog boxes for a profile to be displayed press Cltr-A (to select all items), right-click, and choose Untick selected from the pop-up menu.


Comparison Programs

Program Options: Comparison Programs

External File Comparison Tools

When the Differences window is displayed, which lists which files are going to be copied, deleted, moved, etc., then you have the chance to compare two files. For example, you may have changed the same Word document in both the source/left and destination/right. In this case you may want to visually compare the actual Word documents to decide what action you want SyncBackSE to take.

The External file comparison tools window lets you tell SyncBackSE which external programs to use to visually compare files of various types.

· Name: This is the unique name to give to the entry. You can use whatever name you wish, e.g. Compare Word Documents

· Description: An optional description of the program, e.g. Compares word documents

· Program: This is the filename of the program that will be used to compare the two files. You must enter a complete path and filename. Note that Windows environment variables can be used, e.g. %ProgramFiles%\WinMerge\WinMerge.exe. If the program does not exist then the text will be highlighted in red.

· Parameters: These are the command line parameters that are used with the comparison program. Check the documentation of the comparison program to see what parameters can be used and how they are used. There are two special strings that you must use in the parameters: %1 is used to donate the filename of the source/left file, and %2 is for the destination/right filename. SyncBackSE will automatically replace these two parameters with the correct filenames. Note that you will probably need to wrap the %1 and %2 strings with double-quotes, e.g. –left "%1" –right "%2", as Windows treats a space character as a break between parameters.

· File types that can be compared: A comma-delimited list of file types that the comparison program can compare. Do not use the initial period of the filename extension, e.g. use txt,c,h and not .txt,.c,.h


Log Settings

Program Options: Logging Settings

By default the log file, produced when a profile is run, is created in HTML format. By selecting this menu item you can change the log file format, or choose not to create a log file at all.

· Store all my log files in the following folder: This is the folder SyncBackSE will store the log files created after every profile run. You can use environment variables, e.g. %APPDATA%

· Use the following filename for my log files: This is the filename of the log files SyncBackSE created. Windows environment variables and SyncBackSE variables can be used here, including a special variable called %PAGE% which is replace with the page number of the log file.

note

Note that this setting is just the filename, not the path. The Store all my log files in the following folder setting is for the path.

· Keep a history of…: SyncBackSE can be configured to keep a certain number of log files, e.g. the log files of the last 3 profile runs.


Exploring SyncBackSE

Discovering SyncBackSE

Now you've gained the essential knowledge of using SyncBackSE, we'll turn to taking advantage of some of the options available in the program. SyncBackSE has two Modes that allow you to change the settings for any given profile: Easy Mode and Expert Mode.

SyncBackSE is a very flexible program. As you gain confidence in using the program you'll discover the power and ease that backing up and synchronizing can bring to your daily work at the computer. The default settings in SyncBackSE are defined to help you manage your data backup tasks in a simple straightforward manner.

note

Remember at all times that SyncBackSE copies, moves, and deletes data. Please ensure that you test your settings before running them. You can achieve this easily by using the Simulated Run or Simulated Restore commands available from the 'Task' menu:

The next section of this help file presents the settings and options available to you in Easy Mode.


Easy Mode

Easy Operation

SyncBackSE provides two modes to view and change your Profiles: Easy and Expert. Easy mode presents far fewer options to modify your Profile making the choices you make less complex than in Expert mode. The Easy and Expert Mode buttons can be found at the top left of the Profile Setup Windows (select a Profile, then click the 'Modify' button at the base of the main SyncBackSE window). You can also click the Easy or Expert items in the list.

The following screenshots show the option menus in Vista:

ps-options-easy | ps-options-expert
Easy Options | Expert Options

Profile Settings in Easy Mode

The following Settings pages detail the options available for each settings tab in Easy Mode:

Easy Mode Configuration

Searching the settings

Click For Options button

Simple Settings

Sub-directories and Files

When

Fast Backup

Decisions - Files

Smart Synchronization

Notes


Easy Mode Configuration

Easy Mode: Configuring SyncBackSE

After a profile has been created in SyncBackSE you may modify the settings for that profile at any time. If you haven't already defined a profile view Creating a Profile which will guide you through this simple process.

Easy Mode Overview

SyncBackSE has two Modes that will allow you to change the settings for any given profile: Easy Mode and Expert Mode.

note

Note that these modes affect a single profile and not all profiles.

To find out how Group Profiles may be modified go to Creating a Group Profile.

This help page details the options available in the Easy Mode. To modify a profile either use the 'Modify' button on the toolbar, or select 'Modify' from the 'Profiles' main menu located at the top of the program window.

The Easy Mode Profile Setup window is shown below with the default 'Simple' settings tabs:

note

Note how the text in the white informational area helps you decide what option best suits your requirements by summarizing your profile in a text statement.

Spend time getting to know what options are available under the four additional tabs in the Profile Setup window. The 'Simple', 'When', 'Fast Backup', 'Advanced', and 'Decisions - Files' options on the left hand tree contain a range of options that provide a great deal of flexibility in the way you can perform tasks:

Profile Settings in Easy Mode

The following Settings pages detail the options available for each settings tab:

Simple Settings

When

Sub-directories and Files

Fast Backup

Decisions - Files

Smart Synchronization

Copy/Delete Settings


Searching the settings

Easy Mode/Expert Mode: Searching the settings

At the top of the Profile Setup window is a text entry area which can be used to search for settings. For example, in the following the user has typed FTP. The search results are updated immediately after each key press. To go to the setting you want simply click on it in the search results as shown in the Vista screenshot below:

You can expand/hide the search results by clicking on the magnifying glass icon next to the search box.


Click For Options button

Easy Mode/Expert Mode: Click For Options

At the top-left of the Profile Setup window is a button labeled Click For Options. When pressed a menu appears below the button:

· Easy: When selected the window goes into easy mode. In easy mode a number of features are hidden.

· Expert: When select the window goes into expert mode. In expert mode all features are made available.

· Auto-collapse: By default, when a settings page is selected it will automatically collapse the previously selected page (if it was expanded). For example, if you are in Expert mode, and on the Simple page, then go to the Compression page, then it will automatically collapse the Simple page so that the Performance page is no longer in the list.

· Export profile: If clicked then the profile being edited is exported to a file.

· Save as default: If clicked then the settings for the current page as saved as defaults. This means whenever a new profile is created then those settings will be used in the new profile. Note that this is a page specific setting, meaning it does not save the whole profile as the default, just the settings on the current page.

· Copy settings from another profile: If clicked then the settings for the current page can be replaced with the settings from another profile. Note that this is a page specific setting, meaning it does not copy all the settings from another profile, just the settings for the current page.

· Load defaults: If clicked then the current pages settings are replaced by the default settings for this page. This is a page specific setting.

· Revert to factory settings: If clicked then the current pages settings are replaced by the factory default settings. Note that these are not the same as the default settings (which can be changed by using the Save as default menu item). This is a page specific setting.


Simple

Easy Mode/Expert Mode: Simple Settings

This page gives you an overview of what the profile is configured to do. It also lets you change where files are copied to and from, which files and folders are copied, and what name you want to give to the places where files are copied to and from.

Next to the source/left and destination/right paths there are two buttons (by default labeled Source or Left, and Destination or Right). You can click these buttons to change the name of that location. For example, you may be doing a backup from your desktop to an external hard drive. Instead of using the labels Source and Destination you may instead want them to be called Desktop and External Drive.

By default all your files and folders in the chosen folders are copied (with the exception of things like the swap file). However, if you'd like to not copy some specific folders or files, or choose which types of files not to copy (e.g. temporary files), then you can click the Choose sub-directories and files button to make those selections. Read more about choosing sub-directories in the Sub-directories and files section of this help file.

The Alternatives button can be used to change the source/left or destination/right paths to something that is more flexible and/or portable. For example, if the destination is a removable drive then you can have it changed so that the serial number of the drive is used instead of the drive letter. This means if you connect the drive, and it gets a different drive letter assigned to it by Windows, then the profile will still work as expected. Alternatives may also be given if part of the path can be substituted with Windows variables. A tick will appear next to the path that SyncBackSE suggests you use:

To filter out files and folders based on their name, e.g. you may not want to copy any .exe files, then click the Change Filter button. Read more about the filters in the Filter Settings section of this help file.


Sub-directories and Files

Choosing Sub-directories and Files Settings

To select exactly which folders and files you want to include in your profile, click the "Choose sub-directories and files" button on the Simple page. By default all files and sub-folders (with the exception of some folders and files you wouldn't want to copy, e.g. your swap file) are included. SyncBackSE always takes the approach that is better to include files than to exclude them.

The tree displayed is similar to the one used in Windows Explorer. You can collapse and expand the folders to see the files and folders within. A folder or file with a tick next to it is included in the profile.

Icons

When all the files and child folders in a folder are included in the profile, the color of the folders will be solid yellow. If any files or child folders are not included, then the folder will be half yellow. Note that in some cases it is not known if all files and child folders are included until the folder has been fully expanded.

If the profile is a Smart Synchronization profile then two icons are shown next to the files and folders: the one on the left refers to the source/left, and the one on the right refers to the destination/right. If the file or folder is ticked then the icons will be 'ghosted' if the file or folder does not exist. This lets you easily see if a file or folders exists in the source/left and/or destination/right.

New Files and Folders

On the right of the tree are two columns: New Files and New Folders. These options let you decide on whether the profile should include any new files or folders that are created within that folder. By default all new files & folders are included. If a folder is not ticked then no files or folders will be included in the profile. These options are not available until you expand the folder. This is because SyncBackSE cannot know what files and folders are new until a folder is expanded revealing what the current contents of the folder is.

As an example: you may have a folder in which you only want two specific files included and no other files or folders. You would tick those two files and untick all the other files and sub-folders. Then you would change the folder settings to ignore new files and folders. This way even if a new file is created in that folder it will be ignored, and so will any new sub-folders.

Do not use selections (can improve performance)

If this checkbox is ticked then file & folder selections are ignored. This can reduce a profiles run time, sometimes dramatically. To further improve performance you may also want to disable the filters.

Click here to see more options

If you click the bar (with the + sign at the left) at the top of the window then a number of options appear:

· Show files: This allows you to show or hide files in the tree.

· Show files and folders...: These options let you show or hide files and folders depending on whether they exist in the source/left or destination/right. If your profile is synchronizing files then the file icons also inform you if a file exists in the source/left and/or destination/right.

· Show files and folders that do not exist: You may have previously selected a file and/or folder to include in your backup. However, that file or folder may no longer exist, e.g. it has been deleted. In this case it will still appear in the tree but will be highlighted in red. If this option is unticked then those non-existent files and folders will be hidden. You can permanently remove them by clicking the Clean up button or ticking the Clean up automatically option.

· Clean up automatically: Files or folders that do not exist will be automatically removed from the tree. You can manually remove them by clicking the Clean up button.

· Do not display file icons: To improve performance on slower computers you can have file icons not displayed.

Pop-up menu

If you right-click on the tree then a pop-up menu appears with a number of options. These options apply to the selections you have made in the tree:

· Tick selected: All the items selected in the tree will be ticked.

· Untick selected: All the items selected in the tree will be unticked.

· Collapse all: All the folders in the tree will be collapsed.

· Collapse selected: All the selected folders in the tree will be collapsed.

· Exclude folders with this name: Folders with the same name as the ones you've selected in the tree will be added to the filters (folders not to copy) list.

· Exclude files with this name: Files with the same filename as the ones you've selected in the tree will be added to the filters (files not to copy) list.

· Exclude files with this extension: Files with the same filename extension as the ones you've selected in the tree will be added to the filters (files not to copy) list.

· Include folders with this name: Folders with the same name as the ones you've selected in the tree will be added to the filters (folders to copy) list.

· Include files with this name: Files with the same filename as the ones you've selected in the tree will be added to the filters (files to copy) list.

· Include files with this extension: Files with the same filename extension as the ones you've selected in the tree will be added to the filters (files to copy) list.

· Ignore new files: Any new files created in the selected folders will be ignored.

· Include new files: Any new files created in the selected folders will be included in the profile

· Ignore new folders: Any new sub-folders created in the selected folders will be ignored.

· Include new folders: Any new sub-folders created in the selected folders will be included in the profile.

You can select multiple items in the tree by clicking the mouse and using the Shift and Ctrl keys.

Buttons

At the bottom of the window are some options available via buttons:

· Clean Up: Files or folders that do not exist will be removed from the tree if this button is clicked. Files and folders that do not exist are highlighted in red.

· Change Filter: Clicking this button displays the filter window. This lets you choose which types of files to include or exclude, and also choose which folders to include or exclude based on their name. See the Filter Settings section for more information.


When

Easy Mode/Expert Mode: When Settings

This page shows you if a profile has been configured to run on a schedule, e.g. 9am every morning. To create or change the schedule click the Edit Schedule button. For details on scheduling, and solutions to scheduling problems, see the Creating a Schedule section of this help file. Click the Delete Schedule button to delete an existing schedule.


Fast Backup

Easy Mode/Expert Mode: Using Fast Backup

SyncBackSE can make backing up even faster if you choose the 'Fast Backup' option. Read this help page carefully before you continue as there are some important considerations to make when choosing this option. You'll also find some Frequently Asked Questions about Fast Backup below.

'Fast Backup' option is displayed when you create or modify a profile and select the option from the tree:

· Do not perform a fast backup: Enable this option to perform a standard backup, i.e. the source and destination will be scanned and compared to decide which files must be copied.

· Perform a fast backup: Enable this option to greatly improve the performance of a backup profile by not scanning the destination. Note that this option is only available when a profile is configured in a certain way (i.e. the source is not being changed by the settings). For more information, including side effects of fast backups, please see the section below.

· Perform a fast backup using the archive attribute: Enable this option to greatly improve the performance of a backup profile by not scanning the destination. This option is different from the one above because it uses the traditional backup method of using the archive attribute of a file to decide if a file should be copied or not. Note that this option is only available when a profile is configured in a certain way. For more information, including side effects of fast backups, please see the section below.

· Keep fast backup data based on the actual destination directory (each destination has a full backup): If this option is unticked then a fast backup works much the same as an incremental backup. This means that only new or modified files are copied from the source to the destination regardless of where the destination is. If you are not using variables, e.g. %DAYOFWEEK%, in the destination then you can leave this option unticked as it will make no difference. This option is not available when using a Fast Backup with the archive attribute.

If you are using variables in the destination then you should consider ticking this option. If this option is ticked then the fast backup works in a different way. It keeps track of which files and folders are in each destination. This means each destination directory will have a complete backup and not just contain the new/changed files.

· Differential backup (do not update the fast backup data): If this option is ticked then a fast backup works much as a differential backup. This means that only new or modified files since the last full backup are copied from the source to the destination. If you are not using variables, e.g. %DAYOFWEEK%, in the destination then you can leave this option unticked as it will make no difference.

For example, if your destination is X:\%DAYOFWEEK%\, and you force a rescan on Mondays, then your Monday backup will be a full backup. Your Tuesday backup will contain new and changed files since Monday, Wednesday’s backup will contain new and changed files since Monday, etc.

· Delete all the files and folders in the destination before the backup (only if it is not a rescan): If this option is ticked then all the files and folders (just the Zip file if compressing to one single Zip file) in the destination are deleted before the backup is made. The files and folders are not deleted if a re-scan has been forced or is required.

This option is best used when "Keep fast backup data based on the actual destination directory" is unticked. For example, if you keep 7 days worth of backups (using the %DAYOFWEEK% variable in the destination), and force a rescan each Monday, then by enabling this option you'll ensure that the Monday backup contains a complete backup and that the backups for all the other days just contain new/changed files since the previous day.

· Use a different folder for full (rescan) backups: If this option is ticked then you can define which folder should be used for full backups, i.e. where to backup to if there is a re-scan. This can be very useful when you always want full backups to go into one folder, and incremental/differential backups to go into the usual destination folder. If you tick this option then SyncBackSE will automatically set the full folder to your destination folder. However, it is unlikely this is the folder that you wish to use so you should modify it as appropriate.

For example, if your destination is X:\%DAYOFWEEK%\, and you have it set to rescan on Monday, then you probably want your full backup folder set to X:\1\. This means the full backups will always go into the Monday (1) folder even if you force a rescan on a Friday, for example.

· Force re-scan: Click this button to force SyncBackSE to scan the destination next time the profile is run. Please read the notes below about the consequences of forcing a rescan when using FTP. If the button is disabled it is either because the profile is not a Fast Backup profile or SyncBackSE will already be performing a rescan on the next profile run, e.g. the button has already been pressed.

· Force a re-scan when: This lets you define when SyncBackSE should perform a complete re-scan of the destination. For example, to force a complete re-scan every Monday you would select %DAYOFWEEK% from the list, select equals from the drop-down, and type in 1 (1=Monday, 7=Sunday) in the edit box. See the section below for details on why this may be required and what it does. Please read the notes below about the consequences of forcing a rescan when using FTP. Note that you cannot enter a list of values, for example you cannot use %DAYOFWEEK% and enter 1,3 to rescan on Mondays and Wednesdays. Only one value may be entered. With the sbpro-feature-16x16 Pro version it is possible to use scripting to decide when a rescan should occur, meaning far more complex evaluations can be made (see the IncVar.vbs example script).

Important Information About Fast Backups

Explaining Fast Backups

When you backup files to the destination it is assumed that no other application, or person, will be changing the files in the destination. For example, if you backup your files to another drive you are not going to be editing or changing those backup files (except using SyncBackSE to replace them as appropriate). Because of this SyncBackSE should be able to remember what files, and directories, are on the destination without needing to scan it to find out.

How 'Fast Backup' works

First, you need to enable a Fast Backup option on the Fast Backup tab. The Fast Backup option is not available if the profile is configured such that it cannot use the Fast Backup option, e.g. it's a Smart Synchronization profile.

How Fast Backup works depends on whether it's using the archive attribute or not:

· Not using the archive attribute: When the profile is next run, SyncBackSE will remember which files and directories it copied to (or deleted from) the destination directory. This means the first run of a profile, after Fast Backup is enabled, will take the same amount of time as without Fast Backup enabled. However, for the second and subsequent runs of the profile it will not need to scan the destination directory because it remembers what it did the last time the profile was run.

· Using the archive attribute: Each file has what is called an archive attribute (just like files have read-only, hidden, etc. attributes). Whenever a file is changed the archive bit is automatically set (by Windows), and when SyncBackSE copies a file it clears the archive bit. So when SyncBackSE needs to know which files are to be copied to the destination it just needs to see if the archive attribute is set. There is no need to scan the destination. The main advantage to using the archive attribute is that there is no need to keep information on the state of the files (so less disk space is used). It may also be very slightly faster (as it doesn't need to read and save the information on the files).

Using Fast Backup means the scan time is substantially lower (at least twice as fast, often far more) especially if the destination is on a slow device, e.g. networked drive, FTP server, etc.

Rescan with archival backups

If a rescan is done, either by clicking the Force Rescan button or by other means, then when the profile is next run it will scan both the source and destination, compare the files, then copy new and changed files. This has a side effect with archival backup in that it will not copy a file (even if it has its archive attribute set) if the source and destination files are the same. If the profile is run again (so it is not a rescan) then it will scan the source, see the file has the archive attribute set, and copy it to the destination regardless.

Can I use Fast Backups on all profile types?

No. The Fast Backup option is only possible when no changes are being made to the destination by other programs, profiles, or users. This means it cannot be used with backups from FTP or Zip files, synchronization profiles, or profiles that use prompting. It is for backup profiles only.

If you are using archival backups you must keep in mind SyncBackSE is relying on the archive attribute being set once a file is created or changed and is not reset by anything else other than that profile in SyncBackSE. Once the archive attribute is set then SyncBackSE knows the file needs to be backed up. However, some other programs, e.g. other backup software, may also use and reset file archive attributes. You must also be careful not to have more than one profile that copies the same files and resets the archive attribute.

Sometimes SyncBackSE scans the destination directory even though I've enabled Fast Backups. Why?

There are a number of reasons why SyncBackSE may scan the destination directory:

· The Force Re-scan button has been pressed for that profile.

· The settings on the Fast Backup tab specify a re-scan should be performed under certain conditions.

· The –full command line parameter was used.

· The fast backup data has been deleted.

What options does using Fast Backup disable?

When using Fast Backups you cannot enable the following options in your profile:

· Reset the archive file attribute on files once they have been copied.

· Files cannot be moved, and files cannot be copied to the source or deleted from the source (this option can be used with archive attribute fast backups)

· The destination cannot be watched for file changes.

What side effects are there with using Fast Backups?

Because a Fast Backup will not scan the destination (except on the first run after it is enabled for that profile) that means only the changes will be applied to the destination without regard to what is actually on the destination. For example, you could change the destination directory, run the profile, and then only the new/modified files would be copied to the destination (and not all the files as would normally be the case).

This has important consequences when your destination directory is dynamic, i.e. it uses environment variables that can change in value. For example:

· Create a normal backup profile and set the source directory to C:\My Documents\ and the destination directory to D:\Backup\%DAYOFWEEK%\

· Enable Fast Backup for the profile.

· On the first run of the profile (let's assume it's Monday and the destination directory is empty) all the files will be copied to D:\Backup\1\

· When the profile is run on Tuesday then only the new or modified files will be copied to D:\Backup\2\

· On Wednesday new and changed files will be copied to D:\Backup\3\ and so on until Monday.

· When it is run again on the following Monday then only the new and changed files will be copied to D:\Backup\1\

· Enable the option "Keep fast backup data based on the actual destination directory". This will create full backups for each day and not just incremental backups for Tuesday to Sunday.

Or

· Enable the option "Delete all the files and folders in the destination before the backup" and force a rescan on Mondays. There are three ways to do this (using this example):

1. The best and easiest option is to configure the "Force a re-scan when:" settings to force a re-scan every Monday (select %DAYOFWEEK% from the list, select equals from the drop-down, and type in 1 (1=Monday, 7=Sunday) in the edit box).

2. You can do this manually by clicking the Force Re-scan button on the Mondays.

3. Use the -full command line option (for Monday only when scheduling).

This will mean that the Monday backup is a complete backup, and the backups on Tuesday to Sunday contain just the new/changed files since the previous days backup.

Note about "Delete all the files and folders in the destination before the backup"

This option should be used with care because it will delete all the files and folders in the destination before running the profile. However, if you are compressing to a single Zip file it will just delete that Zip file and no other folders or files.

An important detail to remember about this setting is that the destination files are not deleted if the profile run is doing a rescan. For example, if you've configured your profile to rescan on Mondays (%DAYOFWEEK% equals 1) then when the profile is run on a Monday it will not delete the destination files. However, it will delete them if there is no rescan. This has consequences if you run your profile more than once and also if you do not ever do a rescan. For example, if you configured your profile to rescan on Mondays then when the profile is run on a Tuesday it will delete the destination files and copy over the new or changed files since the last profile run. However, if you run it again immediately (and assuming it is still Tuesday) it will delete those files and then copy over any new or changed files since the last run, which may be no files at all.

Versioning

As an alternative to doing incremental or differential backups, you may want to consider using Versioning instead. With versioning you can keep a defined number of versions of a file. This means you can keep old versions of files that have been changed or deleted. Note that you can use versioning with Fast Backup, but it can become complex and will slow down a Fast Backup (as SyncBackSE must scan the destination to know what versions are available).

Example Fast Backup Configurations

The following section provides example backup configurations.

To keep 7 days worth of backups, and have a full-backup on Mondays and incremental backups on all the other days of the week:

· Create a backup profile

· Configure your source as appropriate

· Set the Destination to something (the %DAYOFWEEK% is required) like D:\My Backups\%DAYOFWEEK%\

· Go to the Fast Backup tab and enable the options: Perform a fast backup and Delete all the files and folders in the destination before the backup, and set the full-backup folder to D:\My Backups\1\

· In the "Force a re-scan when:" box select the %DAYOFWEEK% item, select Equals from the drop-down list to the right of the box, and enter 1 into the box to the right of the drop-down list (we use 1 because Monday is day 1, Tuesday is day 2, etc).

· You should schedule the profile to run just once every day

To keep 7 days worth of backups, and have a full-backup on Mondays and differential backups on all the other days of the week:

· Create a backup profile and configure your source as appropriate

· Set the Destination to something (the %DAYOFWEEK% is required) like D:\My Backups\%DAYOFWEEK%\

· Go to the Fast Backup page and enable the options: Perform a fast backup, Differential backup (do not update the fast backup data), Delete all the files and folders in the destination before the backup, and set the full-backup folder to D:\My Backups\1\

· In the "Force a re-scan when:" box select the %DAYOFWEEK% item, select Equals from the drop-down list to the right of the box, and enter 1 into the box to the right of the drop-down list (we use 1 because Monday is day 1, Tuesday is day 2, etc).

· You should schedule the profile to run just once every day

To keep 7 days worth of backups and have full-backups for each day:

· Create a backup profile

· Configure your source as appropriate

· Set the Destination to something (the %DAYOFWEEK% is required) like D:\My Backups\%DAYOFWEEK%\

· Go to the Fast Backup tab and enable the options: Perform a fast backup and Keep fast backup data based on the actual destination directory

· Go to the Decisions - Files page and configure the profile to delete files from the destination that do not exist on the source. This ensures that your backups don't get cluttered with redundant files.

· You should schedule the profile to run just once every day

To keep full-backups on a set of disks:

· Create a backup profile

· Configure your Source as appropriate

· Set the Destination, e.g. X:\%SERIAL%, where X: is a drive that accepts removable media, e.g. a CD/DVD drive, Zip drive, floppy disk drive, etc.

· Go to the Fast Backup tab and enable the options: Perform a fast backup and Keep fast backup data based on the actual destination directory

· Go to the Decisions - Files page and configure the profile to delete files from the destination that do not exist on the source. This ensures that your backups don't get cluttered with redundant files.

· Each time you run the profile use a different disk. You could keep 10 days worth of backups by rotating a set of 10 disks. Each disk will have a complete backup.

What about FTP and Fast Backups?

One of the benefits of using Fast Backup and FTP is that it can really improve the backup time. Apart from not having to scan the FTP server to find changes, SyncBackSE also does not need to set the date & time of the file on the FTP server to match that of its equivalent file on your PC. This can further reduce the backup time.

If you don't care if the date & time of the files on your FTP server match those on your PC then you can untick the "If the FTP server cannot set a files date & time then change the local files date & time to match that on the server" option on the FTP tab.

There are important consequences to doing this: the date & time the file should be set to (on the FTP server) is kept in the Fast Backup data. Therefore, if you force a re-scan (so erasing that data) then the last date & time information is permanently lost. What does this mean?

· When you do a restore all the files will be retrieved from the FTP server along with their last modification date & time, which is not the original value. As the date & times won't match, all the files will be restored unless you've configured your profile to ignore file date & times.

· When you next run a backup all the date & times will be mismatched so forcing a complete backup (unless you've configured your profile to ignore file date & times).


Decisions - Files

Easy Mode/Expert Mode: Decisions - Files Settings

Define how SyncBackSE will perform its task under different circumstances.

For example, what SyncBackSE will do if the same file is in the destination but not the source.

The Decisions - Files page lets you tell SyncBackSE which files to copy, delete, or move. If this is a new profile then these settings have already been correctly chosen for you and there is no need to change them. Which options are displayed depends on whether you have a Smart Synchronization profile or not.

There are three different situations in which SyncBackSE must decide which file to copy or delete:

1. When there is a file (with the same name and in the same directory) that is both in the source and the destination but their contents are not the same. For example, you may have changed the file in the source.

2. When there is a file that is in the source, but not in the destination. For example, you may have deleted the file in the destination.

3. When there is a file that is in the destination, but not in the source.

Pre-configured Settings

At the top of the window is a bar that when clicked shows several buttons:

Clicking on these buttons will change the settings on this page to perform that task. For example, if you want to reset the settings so it’s a backup then click the “Backup source to destination” button.

Non-Smart Synchronization Options

For Smart Synchronization profiles please see this section of the help file.

First Advanced Settings Group

The first group of settings on this page let you decide what SyncBackSE should do for situation 1, i.e. when a file is in the source and destination, but they are not the same file:

· Source overwrites destination always (backup): A file from the source directory will always replace a file in the destination directory. Choose this option when doing backups.

· Destination overwrites source always (restore): A file from the destination directory will always replace a file in the source directory.

· Newer file overwrites older file (synchronize): The newer file will replace the older file, i.e. the file last modified replaces the older file. Choose this option when synchronising directories.

· Older file overwrites newer file: The older file will replace the newer file. This is the exact opposite of the previous option.

· Larger file overwrites smaller file (skip if same size): The larger file will replace the smaller file (and no copy is made if they are the same size).

· Smaller file overwrites larger file (skip if same size): The smaller file will replace the larger file (and no copy is made if they are the same size). This is the exact opposite of the previous option.

· Prompt me (skips file if run from command line): If both files have been changed then you are prompted and will be able to decide what to do. Note that if SyncBackSE is run from the command line, or from the Windows Task Scheduler, then no prompt will appear and the file will not be copied.

· Do nothing, skip the file: In this case no file is copied and nothing is done.

· Move the file instead of copying it: The file will be moved from the source to the destination. Note that this option is not always available, e.g. if your profile is a Fast Backup profile.

Second Advanced Settings Group

The second group of settings on this page let you decide what SyncBackSE should do for situation 2, i.e. when a file is in the source but not the destination:

· Copy file to destination: The file is copied from the source to the destination.

· Move file to destination: The file is moved from the source to the destination. Note that this option is not always available, e.g. if your profile is a Fast Backup profile.

· Delete file from source if it hasn't been modified within the last x days: The file is deleted from the source. If the days value is greater than zero then the file is deleted from the source only if it has not been modified in that number of days.

· Prompt me (skips file if run from command line): You will be prompted on what action to take. Note that if SyncBackSE is run from the command line, or from the Windows Task Scheduler, then no prompt will appear and the file will be ignore.

· Do nothing, skip the file: Nothing will be done and the file will be ignored.

Third Advanced Settings Group

The third group of settings on this page let you decide what SyncBackSE should do for situation 3, i.e. when a file is in the destination but not the source:

· Copy file to source: The file is copied from the destination to the source.

· Move file to source: The file is moved from the destination to the source. Note that this option is not always available, e.g. if your profile is a Fast Backup profile.

· Delete file from destination if it hasn't been modified within the last x days: The file is deleted from the destination. If the days value is greater than zero then the file is deleted from the destination only if it hasn’t been modified in that number of days.

· Prompt me (skips file if run from command line): You will be prompted on what action to take. Note that if SyncBackSE is run from the command line, or from the Windows Task Scheduler, then no prompt will appear and the file will be ignore.

· Do nothing, skip the file: Nothing will be done and the file will be ignored.


Smart Synchronization

Using 'Smart Synchronization'

Smart Synchronization Options

With Smart Sync you are given a large number of options of what to do in each situation. Although the list and options appear daunting, taking the default values is nearly always the best option.

note

Smart Synchronization cannot be used when compressing all files into one single file or when burning to a CD/DVD.

In the description of the options below an example follows about how this option may be triggered when you do a Smart Sync.

Example Scenario

You have a local copy of the files on your laptop computer. In your profile setup this is the Source directory. There is also a copy of those files on the company network. In your profile setup this is the Destination directory.

People in the company are making changes to the files on the network, and when you are out of the office you are changing your files on your laptop. Once you return to the office you are connecting your laptop to the company's network and synchronizing your files using SyncBackSE.

Note that when you first run a Smart Sync profile it has no history of data to look at and so, for example, cannot know if a file was only changed in the source but not the destination.

What to do if...:

· sync1 ...the same file has been changed in both the source & destination: You have changed a file on your laptop and someone has also changed the same file on the network. In this situation, it's best to be prompted on what to do. You may need to manually merge the file contents. Tick the Move the file instead of copying it checkbox to move the file.
· sync2 ...the file has only been changed in the source (unchanged in destination): You have changed a file on your laptop and nobody changed that file on the network. In this situation the default is to copy your changed file to the network (Source overwrites destination always). Tick the Move the file instead of copying it checkbox to move the file.

· sync3 ...the file has only been changed in the destination (unchanged in source): A file was changed on the network and you didn't change your local copy of the file. In this situation the default is to replace your local copy with the changed one (Destination overwrites source always). Tick the Move the file instead of copying it checkbox to move the file.

· sync4 ...a file is deleted from the source (but was changed or created in the destination): You have deleted a file on your laptop but someone has changed that file on the network or created a file with the same name on the network. In this situation the default is to be prompted as you may either want to delete the network file, or copy the network file to your laptop.

· sync5 ...a file is deleted from the source (but is unchanged in the destination): You have deleted a file on your laptop and the file on the network was not changed. In this situation the default is to also delete the file from the network (Delete file from destination).

· sync6 ...a file is deleted from the destination (but was changed or created in the source): Someone has deleted a file from the network but you've changed your local copy of that file (or created a new file with the same name). In this situation the default is to be prompted as you may either want to delete your local copy of the file, or copy the local file to the network.

· sync7 ...a file is deleted from the destination (but is unchanged in the source): Someone deleted a file on the network and the file your laptop was not changed. In this situation the default is to also delete the file from your laptop (Delete file from source).

· sync8 ...a new file has been created in both the source & destination and are different: The same file has been created on the network and your laptop. This happens when you first run a Smart Sync profile. The default is to be prompted, and usually you would choose to copy the newer file over the older file (Newer file overwrites older file). Tick the Move the file instead of copying it checkbox to move the file.

· sync9 ...a new file has been created in the source only, or is only in the source: You have created a new file on your laptop and it doesn't exist on the network. This happens when you first run a Smart Sync profile. The default is to copy the file to the network (Copy file to destination).

· sync10 ...a new file has been created in the destination only, or is only in the destination: Someone has created a new file on the network and it doesn't exist on your laptop. This happens when you first run a Smart Sync profile. The default is to copy the file to your laptop (Copy file to source).

· Detect file renames on Source (note this may reduce performance): If this option is ticked then SyncBackSE will try to detect files that have been renamed/moved in the source. If a file has been renamed on the source then it will rename the destination file to match it. Note that this option requires that file contents be compared, which means this option could be very slow when there are many files or very large files. It will only compare files when it needs to.

· Detect file renames on Destination (note this may reduce performance): If this option is ticked then SyncBackSE will try to detect files that have been renamed/moved in the destination.


Notes

Easy Mode/Expert Mode: Notes

In some situations you may want to record some free-format notes about a profile, e.g. what the profile does, what needs to be done before the profile is used, etc. This settings page lets you enter those notes and optionally have them displayed when the profile is imported. Note that the notes are rich-text, which means you could copy & paste the notes from Microsoft Word, for example, and it will retain the font styles, sizes, colors, etc. Images cannot be used. The Notes feature is not intended to be a full blown text editor and is intended for entering a few simple notes.

· Show these notes when this profile is imported: If this checkbox is ticked, and the profile is exported and imported into another installation of SyncBackSE, then this note is displayed. This is useful when distributing profiles and you want to tell the user what the profile does or if they need to change something before using it, for example. Note that if a profile is imported in unattended mode the the note is not displayed.


Expert Mode Configuration

Expert Mode Overview

To modify a profile either use the 'Modify' button on the toolbar, or select 'Modify' from the 'Profiles' main menu located at the top of the program window. Spend time getting to know what options are available under the many pages in the Profile Setup window.

SyncBackSE provides two modes to view and change your Profiles: Easy and Expert. Easy mode presents far fewer options to modify your Profile making the choices you make less complex than in Expert mode. To access the Expert mode, when modifying a profile, you'll need to select the 'Expert' mode item located in the 'Click For Options' menu.

ps-options-expert

Click For Options Menu

The Click For Options menu allows you to:

· Select Easy or Expert mode
· Save profile settings as a default profile
· Copy profile settings from an existing profile
· Load defaults
· Revert to factory settings

menu-expert

Expert Options

The left hand Options Tree contains a range of settings and choices that provide a great deal of flexibility in the way you can perform and control tasks, many of which are not available in the default Easy Mode.

Spend time getting to know what options are available.

The screenshot on the left shows all the options in Expert mode that are available. In practice only the selected branch of the Option Tree will show its associated branch:

Profile Settings in Expert Mode

The following Settings pages detail the options available for each settings tab (some of the headings are also available in Easy Mode):

Simple (also available in Easy Mode)

Sub-directories and Files (also available in Easy Mode)

Simple, Performance

When (also available in Easy Mode)

When, Hot-key

When, Login/Logout

When, Changes

When, Insert

When, Periodically

Fast Backup Settings (also available in Easy Mode)

Decisions - Files (also available in Easy Mode)

Smart Synchronization (also available in Easy Mode)

Decisions, Folders

Copy/Delete

Copy/Delete, Folders

Copy/Delete, Advanced

Compare Options

Compare Options, File Size

Compare Options, Date & Time

Compare Options, Attributes

Compression

Compression, Encryption

Compression, Advanced

Compression, NTFS

Compression, Compressed

Encryption

FTP

FTP, Advanced

FTP, Proxy

FTP, Firewall

Misc.

Misc., Media

Programs - Before

Programs, After

Auto-close

Email

Email, Advanced

Log

Log, Email

Log, Advanced

Network

Network, Advanced

CD/DVD Burner

CD/DVD Burner, Advanced

Variables

Notes (also available in Easy Mode)

Scripts


Simple, Performance

Expert Mode: Simple, Performance Settings

Simple | Performance

This page shows you which settings may be affecting the performance of your profile. It is important to keep in mind that speed is not everything, and that what is more important is that the files are copied correctly. For example, verifying that your backup files are correct will slow down the profile but will guarantee your backup files are not corrupted at backup time. The safe copy option is enabled by default for most profiles and it is strongly recommended that you do not switch off this option just to slightly reduce the backup time.

You can jump directly to the appropriate settings page by simply clicking on the items listed in the "The following settings are slowing down the profile:", etc., sections.


When, Hot-key

Expert Mode: When, Hot-Key Settings

When | Hot-key

· Run the profile when this hot-key is pressed: To run the profile when a certain key combination is pressed, click this edit box and press the hot-keys you want to assign. For example, if you want to run the profile whenever you press Ctrl-Shift-P, then press those keys. Now whenever you press Ctrl-Shift-P, no matter what application you are using, and even if SyncBackSE is minimized, the profile will be run. Please note that SyncBackSE must be running for hot-keys to function (you may want to configure SyncBackSE to start automatically when you login to Windows). To remove a hot-key, click the hot-key edit box and press the Backspace key.

· Run unattended, i.e. do not prompt me: If a profile is run via the hot-key, by default it is run attended, i.e. dialog box and prompts related to the profile will be displayed when required. If this option is ticked then the profile will be run silently without any prompting. Note that if this is a group profile then all the profiles in the group will be run attended or unattended, i.e. for a group this setting overrides the profiles setting.


When, Login/Logout

Expert Mode: When, Login/Logout Settings

When | Login/Logout

· Run this profile on Windows shutdown/logoff: If this option is enabled, the profile will run when you shutdown, restart, or logoff from Windows. Please note that when using Windows 2000, XP, or 2003, then SyncBackSE cannot differentiate between a shutdown and a restart (there is no problem with logoff). So after the profile has run, the computer will shutdown even if you selected to restart, which is the default. This is due to a limitation in the way Windows informs applications of a Windows shutdown. You can change this via the Global Options settings. This is not an issue with Windows Vista or newer versions of Windows.

· On shutdown/logoff run &unattended, i.e. do not prompt me: If a profile is run on shutdown/logoff, by default it is run attended, i.e. dialog box and prompts related to the profile will be displayed when required. If this option is ticked then the profile will be run silently with any prompting. Note that if this is a group profile then all the profiles in the group will be run attended or unattended, i.e. for a group this setting overrides the profiles setting.

· Run this profile when I login to Windows: On Windows 2000, XP, or 2003, a shortcut to SyncBackSE is created in the Windows Startup folder so when you login the profile will be run. For Windows Vista and newer a special entry is created in the Windows Task Scheduler (this avoids receiving UAC elevation prompts). Note that a profile set to run on login will be run unattended. Due to the nature of this setting it cannot be exported/imported, copied to another profile, or set to be on by default.


When, Changes

Expert Mode: When, Changes Settings

When | Changes

A profile can be configured to watch for changes to files, and when any changes are made, the profile will be run. There are some important points to keep in mind:

1. SyncBackSE must be running for it to be able to detect changes. You may want to configure SyncBackSE to start with Windows (see Preferences -> Global Settings).

2. If you make changes to those files while SyncBackSE is not running it will not detect them and so when you start SyncBackSE it will not run the profile. Because of this you may still want to schedule the profile to run periodically.

3. Changes cannot be detected on FTP or email servers. It will probably also fail to detect changes on NAS devices that are not running Windows (many NAS devices use a version of Linux).

· Run this profile when any files or directories are changed on source: If this option is enabled then the source/left folder will be watched, and if any changes are made to any files (including files in sub-folders), or if any files are deleted, then the profile will be run.

· Run this profile when any files or directories are changed on destination: As per the above setting but the destination/right is watched. If you using a backup profile then there is no point watching the destination for changes. Also note this option is not available with Fast Backup profiles.

· Run interactively, i.e. prompt me if required: If a profile is run when changes to the files are made, by default it is run unattended, i.e. dialog box and prompts related to the profile will not be displayed. If this option is ticked then you will be prompted as and when required.


When, Insert

Expert Mode: When, Insert Settings

When | Insert

A profile can be configured to run a profile whenever an external device is attached, e.g. a USB key is inserted. If Windows is assigning a random drive letter to the device when inserted please use the %LABEL% or %SERIAL% Variables. If you use these options you may want to configure SyncBackSE to start automatically when you login to Windows.

· Run this profile when…: This set of options enables this profile to be automatically run whenever an external device is connected or a CD/DVD, USB memory key, etc. is attached to your computer. You can configure it to be broad, e.g. any device into any drive, or very specific, e.g. a drive with a specific label, serial number, and with a certain drive letter.

· Run unattended, i.e. do not prompt me: If a profile is run via a device insert, by default it is run attended, i.e. dialog box and prompts related to the profile will be displayed when required. If this option is ticked then the profile will be run silently with any prompting. Note that if this is a group profile then all the profiles in the group will be run attended or unattended, i.e. for a group this setting overrides the profiles setting.


When, Periodically

Expert Mode: When, Period Settings

When | Periodically

Running profiles in the background is similar to running profiles via the Windows Task Scheduler, except SyncBackSE must be running for background profiles to run. Also background profiles usually run much more frequently than scheduled tasks, e. g. every 30 minutes. If you use these options you may want to configure SyncBackSE to start automatically when you login to Windows.

For example, you could create and configure a profile to run in the background every 30 minutes that makes a backup of the documents you are working on. This helps ensure that you lose the least amount of work possible if, for example, there was a power cut. For more details see the Automating SyncBackSE section.

· Run this profile every...: This is the interval at which the profile will be run, e. g. every 30 minutes.

· Run interactively, i.e. prompt me if required: If a profile is in the background by default it is run unattended, i.e. dialog box and prompts related to the profile will not be displayed. If this option is ticked then you will be prompted as and when required. Note that if this is a group profile then all the profiles in the group will be run attended or unattended, i.e. for a group this setting overrides the profiles setting.

· Warn me when exiting SyncBackSE...: If this option is enabled, and you exit SyncBackSE while a background profile is waiting to run, then you will be prompted as a reminder.


Decisions, Folders

Expert Mode: Folders Settings

Decisions - Files | Decisions, Folders

These settings are related to how folders are created and deleted. By default it is handled automatically (based on your file decisions).

What to do if a directory exists on source/left but not on destination/right

· Create directory on destination/right: Folders only on the source/left will be created in the destination/right.

· Delete directory from source/left (if empty): If the folder is empty it will be deleted from the source/left. Note that the folder will not be deleted if it has files in it, including any hidden files or file versions. You can configure which files SyncBackSE can automatically delete to make a folder empty on the Copy/Delete Advanced page.

· Delete directory from source/left only if a file is moved/deleted from it: In some cases you may only want a folder to be deleted if a file was deleted/moved from it. As above, the folder must be empty for it to be deleted.

· Prompt me (skips folder if run unattended): You will be prompted on what action to take.

· Do nothing: Nothing will be done.

· Automatic: SyncBackSE will decide the best action to take based on your profile type. This is the default.

What to do if a directory exists on destination/right but not on source/left

· Create directory on source/left: Folders only on the destination/right will be created in the source/left.

· Delete directory from destination/right (if empty): If the folder is empty it will be deleted from the destination/right. Note that the folder will not be deleted if it has files in it, including any hidden files or file versions. You can configure which files SyncBackSE can automatically delete to make a folder empty on the Copy/Delete Advanced page.

· Delete directory from destination/right only if a file is moved/deleted from it: In some cases you may only want a folder to be deleted if a file was deleted/moved from it. As above, the folder must be empty for it to be deleted.

· Prompt me (skips folder if run unattended): You will be prompted on what action to take.

· Do nothing: Nothing will be done.

· Automatic: SyncBackSE will decide the best action to take based on your profile type. This is the default.

Automatic

The decision SyncBackSE makes for the Automatic option depends upon the type of profile:

· Backup (copying files from source/left to destination/right): Folders only in the source/left will be created in the destination/right. Folders only in the destination/right are deleted (if empty).

· Restore (copying files from destination/right to source/left): Folders only in the destination/right will be created in the source/left. Folders only in the source/left are deleted (if empty).

· SmartSync: Folders only in the source/left will be created in the destination/right, and vice-versa. However, if a folder was deleted from the source/left then it will be deleted from the destination/right, and vice-versa.

· Mirror Right (copying files from source/left to destination/right, deleting files only in destination/right): Folders only in the source/left will be created in the destination/right. Folders only in the destination/right are deleted (if empty).

· Mirror Left (copying files from destination/right to source/left, deleting files only in source/left): Folders only in the destination/right will be created in the source/left. Folders only in the source/left are deleted (if empty).

· Old-style Synchronize (copying files to and from source/left and destination/right): Folders only in the source/left will be created in the destination/right, unless files only in the source/left are being deleted. If files only in the source/left are being deleted then folders only in the source/left are deleted (if empty). Folders only in the destination/right will be created in the source/left, unless files only in the destination/right are being deleted. If files only in the destination/right are being deleted then folders only in the destination/right are deleted (if empty).


Copy/Delete

Expert Mode: Copy and Delete Settings

Define how SyncBackSE will handle the copying, deleting, and moving of files.

SyncBackSE can optionally use the exact same routines for copying, deleting, and moving files that Windows Explorer uses. This ensures that files are copied as expected, e.g. the file attributes are also copied which provide benefits such as putting deleted files in your Recycle Bin.

File copying method: Three different methods of copying (and deleting and moving) files are provided to allow for maximum compatibility and flexibility:

· Standard Windows file copying: This is the default method for copying files. It is the most efficient and quickest way to copy files. Not using the shell (see next item) may fix network problems, especially when using Novell networks.

· Windows Explorer method of file copying: The Windows Shell (Explorer) is asked to copy, delete, and move files on behalf of SyncBackSE. When using this method you have the benefit of moving deleted files to the recycle bin. Using the shell may cause problems when SyncBackSE is used on non-standard versions of Windows, e.g. BartPE.

· Backup read/write file copying: This method (which can only be used by Windows users who have the necessary backup access rights – if not then the Standard method is silently used) can be used to copy files that the user has no access rights to. So if you are receiving Access denied error messages you may want to try this method. Note that the backup copy method cannot be used with Zip files, FTP, backup to email, or backup to CD/DVD/ISO (the Standard method will be used silently).

 | Standard | Explorer | Backup
Copies extended attributes (1) | Yes | Yes | Yes
Copies OLE structured storage (1) | Yes | Yes | Yes
Copies NTFS file system alternate data streams (1) | Yes | Yes | Yes
Copies file attributes | Yes | Yes | Yes
Copies security attributes (2) | Yes (3) | Yes | Yes (3)
Copies encrypted files (5) | Yes | Yes | Yes (4)
Can copy files user has no access to | No | No | Yes (4)
Deleted files can be moved to Recycle Bin (8) | No | Yes (6) | No
File deletions or overwrites can be confirmed first (8) | No | Yes (6) | No
Directory creation can be confirmed first | No | Yes (6) | No
Copy Performance | Fast | Fast | Slow
Copy progress feedback (7) | Yes | No | Yes

(1) The destination must be an NTFS formatted volume.

(2) The destination must be an NTFS formatted volume, and if not a local volume then the security attributes may not be copied.

(3) The destination must be an NTFS formatted volume, and security attributes are only copied if the profile is configured to copy file security permissions. By default they are not copied.

(4) The Standard method is automatically used to copy NTFS encrypted files.

(5) The copy may not be encrypted, e.g. if the destination is not NTFS.

(6) Not enabled by default.

(7) This means the copy progress is shown, meaning you can abort a file copy. With progress the profile can only be aborted after a file has been copied, not during the copy.

(8) If you would like to keep files that are deleted or replaced then consider using versioning.

Shell File Copying & Deleting: The following options are only displayed if the 'File copying method' is set to Windows Explorer method of file copying:

· Move deleted files to recycle bin: If a file is deleted from a local drive (not a removable drive or network drive) it can be moved to the recycle bin instead of being deleted. This is identical to what would happen if you deleted the file using Windows Explorer.

· Confirm file deletions, replacing files, etc.: When a file is to be deleted or replaced by another file then you can be prompted on whether you want SyncBackSE to delete or replace the file. An important point to remember is that if you are using the recycle bin (see the previous item) then you will not be prompted when a file is deleted (instead it is silently moved to the recycle bin). Also, if you are running the profile in unattended mode, e.g. from the Windows Scheduler, then you will not be prompted and the file will be deleted or replaced. If you would like to keep files that are deleted or replaced then consider using versioning.

· Confirm directory creation: If a new directory must be created then you can be prompted on whether you want the directory to be created or not. If you are running the profile in unattended mode, e. g. from the Windows Scheduler, then you will not be prompted and the directory will be created. This option is only available if "Do not display a progress dialog box" is unchecked and "Display error messages and prompts" is enabled.

· Display error messages: If an error occurs when a file is copied or deleted then you can choose to be prompted with an error message. Note that these error messages are also recorded in the profiles log file. If you are running the profile in unattended mode, e.g. from the Windows Scheduler, then you will not be prompted with any error messages.

· Do not display a progress dialog box: When copying large files, using a slow network connection, or slow storage devices, it can sometimes take a long time to copy a file. If this option is enabled then the standard Windows file copy progress dialog box will be displayed (it is only displayed if a file copy will take more than a few seconds). The benefit of this dialog box is that you can cancel the file copy, for example it may be taking too long, and you can see how long it will take to copy the file. If you are running the profile in unattended mode, e.g. from the Windows Scheduler, then the progress dialog box will not be displayed. Please note that on some systems disabling this option may drastically reduce performance.

· Verify that files are copied correctly: After a file is copied, SyncBackSE can check to guarantee that the newly created file is identical to the original file.

note

Note that this option will not work if you are using an FTP server that does not support the XCRC extension. Enabling this option can significantly increase the time taken for a profile to run. When moving files, if the copy cannot be verified, then the source file is not deleted, i. e. it becomes a copy not a move. The verification option is best used with the "Make safe copies" option also enabled as it ensures that your backup doesn't contain corrupted files. If both these options are enabled then when a file is copied it is first copied to a temporary file, i. e. the destination file is not yet overwritten. If the temporary file does not match the original file then the temporary file is deleted and an error is recorded. Without the safe copies option you will know the copy is corrupt but by then it is too late as the file has already been replaced with a corrupted file.

· Warn me if all my files are going to be deleted due to my settings (aborts profile if unattended): In some situations you may have wrongly configured your profile or made a mistake. For example, you may have set the source folder incorrectly to an empty folder and configured your profile to delete all files in the destination that are only in the destination. In this case when you run the profile all your destination files would be deleted. This setting is to avoid situations like this. If SyncBackSE sees that it is going to delete all your files then it will automatically abort the profile and do nothing. This setting is enabled by default.

· Automatically create the source/left and destination/right folders if they do not exist: By default the source/left and destination/right folders will be created automatically if they don't exist. However, in some situations you may not want this, e.g. if using a SmartSync profile, and instead want the profile to fail if either folders don't exist.


Copy/Delete, Folders

Expert Mode: Copy/Delete, Folders Settings

Define how SyncBackSE will manage folders (directories).

· Copy sub-directory and file security permissions (only valid for NTFS): If ticked then NTFS folder security is copied when new directories are created. Note that if the security is changed on a folder then the new security is not copied over. NTFS file security will also be copied with files.

· Copy sub-directory attributes and creation date (only when new directories are created): If ticked then folder attributes and the creation date are copied when new directories are created. Note that if the attributes or creation date are changed on a folder then the new settings are not copied over.

· Delete all empty directories in destination/right: If ticked then all empty directories in the destination/right will be deleted at the end of the profile run. Note that a folder will not be deleted if it has files in it, including any hidden files or file versions. You can configure which files SyncBackSE can automatically delete to make a folder empty with the “If a folder cannot be deleted because it's not empty…” setting below.

· Do not delete the empty directories if the profile run fails: By default empty folders are not deleted in the profile run was not a success.

· Delete all the empty directories on source/left: If ticked then all empty directories in the source/left will be deleted at the end of the profile run. Note that a folder will not be deleted if it has files in it, including any hidden files or file versions. You can configure which files SyncBackSE can automatically delete to make a folder empty with the “If a folder cannot be deleted because it's not empty…” setting below.

· Do not delete the empty directories if the profile run fails: By default empty folders are not deleted in the profile run was not a success.

· Ignore NTFS junction points (reparse points): If ticked then junction/reparse points are ignored. This is the default and recommended.

· When the desktop.ini file (used by Explorer) is copied configure the folder it is copied to to use it: The desktop.ini file is a special file created and managed by Windows Explorer. It helps define what a folder looks like when viewed in Windows Explorer. It is only used if the folders attributes are set correctly. You can tell SyncBackSE to automatically set the correct folder attributes if a desktop.ini file is copied to it. If you have desktop.ini filtered out, then desktop.ini is shown in yellow in the filters window. Note that the desktop.ini file does not entirely define the appearance of a folder in Windows Explorer.

· If a folder cannot be deleted because it's not empty…: Only empty folders can be deleted. Windows Explorer often creates special hidden files in folders that contain settings related to that folder but contain no user created information. This setting defines which files can be deleted to make a folder empty. By default the thumbs.db and desktop.ini files will be deleted. Note these files are only deleted if they are the only files in the folder.


Copy/Delete, Advanced

Expert Mode: Copy/Delete, Advanced Settings

· Automatically update shortcuts when they are copied or moved: SyncBackSE can be configured to automatically change shortcuts that are copied so that the copy points to the correct file. For example, if your source is C:\ and your destination is D:\ and you copy a shortcut that points to C:\abc.txt then you may want it to be changed (in the destination) to instead point to D:\abc.txt. In this example you would set the root folder for shortcuts on the source/left to C:\ and the root folder for shortcuts on the destination/right to D:\. In general the shortcut root folder is the same the source and destination folders, except when you are copying to UNC paths or network drives. In that case the shortcut root folder should be based on the drive on that remote computer.

· Make safe copies (copy files using a temporary filename and then rename the file if the copy is successful - reduces performance): When this option is ticked then SyncBackSE will copy files in a two stage process: first it will copy the file and use a temporary filename, then it will then replace the destination file with the temporary copy if the copy was a success. This avoids problems where the destination file may be deleted because the original file could not be copied, e.g. because it is locked and cannot be replaced. With FTP it is actually a three stage process as it must delete the file being replaced before renaming the temporary copy. This option is enabled by default and is recommended. If you have enabled versioning, on either the source or destination, then you cannot change this setting as safe copies must be used when versioning is used.

· Prompt to retry if a file is locked or cannot be copied: If this option is enabled then SyncBackSE will prompt you if it cannot copy or delete a file, e.g. because it is locked, no access rights, etc. The prompt gives you the opportunity to close the program that has the file locked so the file can be copied or deleted by SyncBackSE. If you are running the profile in unattended mode, e.g. from the Windows Scheduler, then no prompt is made and the file will be skipped (an error message will be recorded in the log file). There is another option in SyncBackSE to close certain programs before a profile is run (see the Auto-close page).

note

Note that if you've also enabled the option to replace/delete after a reboot then you will not be prompted.

· If a file cannot be replaced/deleted because it is locked then replace/delete it after a reboot: If a file cannot be replaced/deleted because it is locked then SyncBackSE can configure Windows so that on the next reboot the file will be replaced/deleted. This option must be used with care because it cannot be guaranteed that the file will actually be replaced/deleted and there is no way to know if it did or did not.

note

Note that if you've also enabled the option to prompt to retry if a locked file cannot be copied then you will not be prompted.

These features cannot be used to replace in-use files on FTP servers. Also, if NTFS compression is being used the replaced file will not be NTFS compressed.

· Prompt to retry if source/left or destination/right drives do not exist: If a drive does not exist, e.g. because it has not been connected or the network connection is not available, then a prompt will be displayed. Note that if the profile is run unattended then no prompt is displayed and the profile will fail.

· If a file cannot be copied because of security (Access Denied) then try Backup Read/Write copy method: The Backup Read/Write file copying method lets a user (who is a member of the Backup Operators user group) backup files that they have no access to. When this option is enabled if a file cannot be copied because you have no access rights to it then the backup method is used to try and bypass the file security.

· Do not replace newer files with older files: If ticked then new files are not overwritten (replaced) by older files. This option is only available under certain conditions.

· Force the file modification date & time to be correct: Sometimes the file system that files are copied to cannot correctly record the files last modification date & time. For example, when using SAMBA shares (or some NAS devices) there can be occasions when the file will have the current date & time as it's last modification date & time. To resolve this SyncBackSE can forcibly change the new files last modification date & time to be correct. Note that this option is not available when using compression. There is another option (see the Compare Options, Date & Time page) to ask SyncBackSE to ignore small date & time differences. This can also be useful in avoiding problems where the file system cannot accurately record dates & times.

· Copy file creation date & times: By default copies of files are given the current date & time as their creation date & time. If this option is enabled then the creation date & time is copied. Note that FTP servers cannot store file creation date & times.

· Reset the archive file attribute on files once they have been copied: When enabled the archive attribute on a file, both on the source/left and destination/right, will be cleared once the file has been copied. Enabling this option will slightly decrease performance. This option is not available when doing Fast Backups. Note that when doing a backup to CD/DVD, the archive attribute is cleared before the file is burned to disk. This means the archive attribute could be cleared even if the file failed to be saved to CD/DVD.

· Remove the read-only attribute from copies of files (useful when copying from a CD-ROM): In some situations, when a file is copied to a CD/DVD, then the file may automatically be marked as read-only (not by SyncBackSE, but by the file system driver in Windows). If this option is enabled then any read-only flag put on the copy of the file will be removed automatically.

· Do not overwrite read-only files (ignored when file to be replaced is on an FTP server): If the file to be replaced is read-only, and this option is enabled, then the file will not be overwritten.

· Do not delete read-only files (ignored when file to be deleted is on an FTP server): If the file to be deleted is read-only, and this option is enabled, then the file will not be deleted.

· Do not use the Volume Shadow Copy service (VSS) to copy open files: SyncBackSE can copy open/locked files by using the Volume Shadow Copy service that is part of Windows XP, 2003, and Vista. However, if you cannot or don't wish to use this service then you can enable this option.

· Copy all files from the shadow volume (snapshot): SyncBackSE can optionally copy all files from the shadow volume (by using the Volume Shadow Copy service). This is useful when you want all the files to be copied at exactly the same time so you have a consistent file state across the backup set. A snapshot is taken of the drive at a single point in time so that essentially the files are frozen at that point. This does not stop users and other programs from modifying and deleting those files because they are changing files on the actual volume and not the shadow volume. It is recommended that this setting be used when doing a backup to CD/DVD or in situations where you have a set of files that are related to each other, e.g. backup of a set of database files.

· Delete ALL the files and folders in source/left before scanning for changes: This option should be used with extreme care! It will delete all files and folders in the source/left folder before it scans for changes. Be extremely careful with this option as you could very easily delete all your files, e.g. if your source/left is C:\ then you will delete every single file on your C: drive. You have been warned.

· Delete ALL the files and folders in destination/right before scanning for changes: This option should be used with extreme care! It will delete all files and folders in the destination/right folder before it scans for changes. Be extremely careful with this option as you could very easily delete all your files, e.g. if your destination/right is C:\ then you will delete every single file on your C: drive. You have been warned.

· Silently fail if source/left cannot be reached through the network, drive does not exist, or there is no disk: When enabled, and the source/left drive cannot be accessed, then the profile will silently fail when run. No log file will be produced, and no failure result will be recorded. This option is useful when you have a profile scheduled to run periodically but are not always connected to the source/left.

· Silently fail if destination/right cannot be reached through the network, drive does not exist, or there is no disk: When enabled, and the destination/right drive cannot be accessed, then the profile will silently fail when run. No log file will be produced, and no failure result will be recorded. This option is useful when you have a profile scheduled to run periodically but are not always connected to the destination/right, e.g. you backup to a network drive via a wireless network connection.

· Limit the bandwidth usage: If a value above zero is entered then when copying files the local network bandwidth usage is limited to what is specified (kilobytes per second). Note that there are some cases where the bandwidth usage cannot be limited, e.g. when using compression. There is a separate setting to limit the FTP bandwidth usage on the FTP, Advanced page.


Copy/Delete, Versioning

Expert Mode: Copy/Delete, Versioning

For a description of versioning see the section What Is Versioning below. Versioning cannot be used (on the destination) when compressing to a single Zip file, or when doing a backup to an email server.

· Enable versioning on source/left/destination/right: If enabled, versions of files will be kept in that location. You can, for example, choose to only keep versions in the destination/right.

· Keep a maximum of x versions: The number of versions of a file to keep can be specified here. Note that obviously the more versions of files you keep the more disk space will be used. When the profile is next run it will automatically delete any excessive versions (starting with the oldest version). If the value is set to zero then versions are never deleted based on the number of versions.

· Keep versions for a maximum of x days: When a version of a file is made the date & time when the version was made is recorded. Note that this is not the last modification date & time of the file, nor is it the creation date & time of the file, it is the date & time when the version was made. Using this option you can specify how long a version should be kept. Once the version is older than the specified number of days it is automatically deleted when the profile is next run. If the value is set to zero then versions are never deleted based on their age.

· Change Filter: When this button is clicked you can choose what types of files are versioned or not. The filter applies to versions on the source/left and destination/right. For example, the following will not version any EXE files, or any files in sub-folders called \temp\:

Versioning is available in Expert Mode and is associated with the Copy/Delete settings as shown in the screenshot below:

What is versioning?

A version of a file is automatically created when:

· A file is to be replaced (a copy of the file to be replaced is made before it is replaced)

· A file is to be deleted (a copy of the file to be deleted is made before it is deleted)

· A file is to be moved (a copy of the file to be moved is made before it is moved, which is essentially the same as being deleted)

Assuming versioning is enabled, here are some examples of how it works:

· You choose to delete a file. SyncBackSE makes a version of the file and then deletes the file. At a later time you may decide that you actually wanted to keep that file. If so you can run the profile and retrieve the version and so restore the file.

· You make some modifications to a document then make a backup of it. SyncBackSE will make a version of the backup file that is about to be replaced then make the backup. At a later time you may decide that you did not want those changes. If so you can run the profile and retrieve the version and so restore the file to before the changes were made.

Where are the version files kept?

The versions of files are kept in a special sub-folder called $SBV$. Each folder will have this special sub-folder if there any versions of files in that folder. SyncBackSE will automatically mark the folder as hidden when it creates it. You should not rename the folder or the files inside it otherwise the versions files cannot be used. You are free to delete the folder and the version files in it (you will obviously lose those versions) but it will not affect SyncBackSE as no database of those versions files is kept (it is always built at profile run time).

How to restore versions

Versions can be restored from the Differences window (or from the File Prompt window). When a profile is run as a Restore, and versioning is used, the Differences window will automatically show skipped files. This allows you to restore old versions of files that no longer exist, and restore versions of files where there is no change.

If you wish to restore versions without using Restore (e.g. you are using a SmartSync profile and so cannot run it in Restore mode) then select the profile in the main window, hold down the Ctrl key, keep it pressed, then click the Run button. This will ensure the Differences window is shown. You then need to enable it to show skipped files (click the bar at the top of the Differences window to see the options).

See the Differences help page for details on retrieving versions of files.

Frequently Asked Questions

Q: Can versioning be used with Fast Backups?

A: Yes, but it can greatly reduce the performance gains you get with Fast Backup. If your profile is configured to display the Differences window then it is recommended you switch off this option as displaying the Differences window forces SyncBackSE to scan every folder to see which versions are available for each file.

Q: Can versioning be used with SmartSync profiles?

A: Yes.

Q: Can versioning be used with single zip files?

A: No.

Q: Can versioning be used with email servers?

A: No.

Q: What if I switch from not using compression to compressing each file into its own zip file (or vice-versa)?

A: You will be warned that you can no longer use the existing versions. This is because if compression is used then the old versions are also stored compressed (and encrypted, if configured so). If no compression is used then the versions are not stored compressed.

Q: What if I switch off versioning? What happens to the versions files?

A: Nothing, you will be warned that the versions files are not deleted. You must manually delete the versions files, or configure your profile to ignore the $SBV$ folders.

Q: Are the versions stored compressed or encrypted?

A: Only if the files themselves are.

Q: Why aren’t the versions stored compressed?

A: Because it would slow down the profile considerably.

Q: What if I decrease the number of versions to keep, or how long they are kept?

A: When the profile is next run any excess versions will be automatically deleted.

Q: Can I choose to store the versions somewhere else?

A: No.

Q: What if I change the source/left and/or destination/right path? Are the versions files automatically moved?

A: No (this is the same as using variables).

Q: What if I used variables in the source/left and/or destination/right path?

A: Versions are kept in a sub-folder of where the original file actually is, so using variables has no effect, except obviously the versions files will be scattered across various folders based on the variable values.

Q: If a folder is filtered out (or unselected) does SyncBackSE still manage the versions in that folder?

A: No, because the profile is specifically configured not to use that folder.

Q: If a file is filtered out (or unselected) does SyncBackSE still manage the versions in that folder?

A: Yes. When looking at file versions it ignores any filtering or selection rules. This makes sense because the original file may no longer exist anyway, for example.

Q: Does versioning affect performance?

A: Normally it has a very small effect on performance. SyncBackSE has been developed to make versions as quickly as possible. However, there are cases where a version cannot be made quickly (i. e. the file to be replaced or deleted has to be copied, instead of being moved, in which case it can affect performance if the file is large).

note

Note that if you are using Fast Backups then enabling versioning on the destination can greatly reduce the performance gains you get with Fast Backup.

Q: My log file has the error “The profile "profile name" was automatically disabled: reason why disabled.” What do I do?

A: What happened is that a version of the file was made (i.e. it was moved into the versions sub-folder, called $SBV$), but the copy failed. SyncBackSE then attempted to move the file back from the versions sub-folder to where it was originally. However, something went wrong and the file cannot be moved back. You must manually move the file back from the $SBV$ folder to its parent folder and rename it. Once done you should re-enable the profile via the main window (right-click on the profile and select Enable from the pop-up menu). This situation is extremely unlikely to happen.


Compare Options

Expert Mode: Compare Options Settings

Fine tune the way SyncBackSE handles file change detection.

When a profile is run, SyncBackSE only copies files that have been changed and new files. It uses four different methods to check if a file is different in the source and destination:

Last file modification date & time: All files record the date & time of when they were last changed.

File size: All files record the number of bytes they contain.

Hash value: A unique value can be computed based on the contents of a file. These values can be used to check if a files contents is the same as another's.

File attributes: Files have special attributes, e.g. read-only, hidden, etc., and SyncBackSE can optionally check for changes in these attributes

You have the option to not use some of these methods, and also change how they are used.

· Skip the Differences screen when this profile is run (it is never shown when unattended): Whenever you run a profile, it will compare the source and destination, and display the results in the Differences window. However, you can skip this window by enabling this option. Note that the Differences window is never displayed if you run SyncBackSE with command line parameters (e.g. from the Windows Task Scheduler), or if a profile is run in the background, or if there are no differences. In most cases there is no need to display this window, except if you want to check to see what the differences are. The Differences window is always displayed when doing a Simulated Run, Simulated Restore, or Restore.

· Use slower but more reliable method of file change detection: By default, SyncBackSE will not compute the hash value of a file. The reason is that it can dramatically increase the time taken for a profile to run. However, if you want to be absolutely certain that SyncBackSE detects if a file has changed, so that it is copied, then you can enable this option. The only reason to enable this option is if you do not trust the last file modification date & time of the files, and the file size may not change. For example, TrueCrypt drive files never change size or last modification date & time (however in this case it would be faster to simply set the profile to delete the destination files first so that the file will always be copied).

· Display a message if the profile run is a success (never shown when unattended): If the profile runs without error then a dialog box is displaying stating that. Normally no message is shown after a profile is run except when simulated or an error occurs.


Compare Options, File Size

Expert Mode: Compare Options, File Size Settings

Note that SyncBackSE has no limitation in regards to the size of files. However, some file systems, e.g. FAT32, do have limits on the size of files.

· Ignore file size changes: You can tell SyncBackSE to completely ignore any differences in file sizes. Ignoring the file size has no impact on performance except in some circumstances when using FTP servers.

· Ignore files less than…: To ignore files of a certain size, or within a size range, set these options as appropriate. A value of zero is ignored, e.g. you cannot ignore all files over zero bytes in size.


Compare Options, Date & TIme

Expert Mode: Compare Options, Date & Time Settings

· Ignore file modification date & time changes: You can tell SyncBackSE to completely ignore the last modification date & time of a file. Ignoring the date & time has no impact on performance. Note that this option is not available if your profile is a Smart Sync profile.

· Ignore file date & time changes that are because of Daylight Savings Time (DST) changes: By default if a file's last modification date & time is exactly one hour different then it is ignored. This avoids problems with changes in the time due to Daylight Savings Time.

· Ignore date & time changes of x seconds or less: In some situations, the file system itself may not accurately record the correct date & time when a file was last modified. This can occur when using SAMBA shares (e.g. on NAS devices) and FAT formatted file systems. With this option, you can tell SyncBackSE to ignore small differences in the date & times, e.g. ignore differences of 2 seconds or less. Note that the difference is rounded down to the nearest second, so a difference of 2.99 seconds is treated as 2 seconds. To avoid inaccuracies in file systems, and differences between file systems, SyncBackSE will ignore differences of 2 seconds by default. You can of course change this if you require finer accuracy.

· Ignore files that have/have not been modified/created…: This setting allows you to ignore files that were modified (or newly created) within a certain date range, e.g. within the last x days, or since January 1st 2004.


Compare Options, Attributes

Expert Mode: Compare Options, Attributes Settings

· Do not copy read-only files: If enabled then read-only files are not copied. This option is useful when a source code control system is used, for example.

· Do not copy hidden files: If enabled then hidden files are not copied.

· Do not copy system files: If enabled then system files are not copied.

· Only copy files that do have the archive attribute set: If enabled then only files which have the archive attribute set (on) will be copied.

· Attributes to watch: SyncBackSE can be configured to watch for file attribute changes. Note that some attributes are not supported on some file systems. Only the NTFS file system supports all the attributes. FAT32/FAT16 file systems support only the Archive, Hidden, Read Only, and System attributes.

note

Note that SAMBA and non-Windows file systems may not support some of the attributes, or may require further configuration to support them.

When a files attributes are changed, SyncBackSE will copy the file. If hashing is used, then the file is not copied if the files contents are identical, and instead only the files attributes are changed.


Compression

Expert Mode: Compression Settings

SyncBackSE has the ability to compress files using the industry standard ZIP format as well as the newer BZip2 format. Compression reduces the size of the file and has the potential to save a lot of disk space, especially when files such as text and office documents are being copied. Two methods of compression are supported: all the files can be placed into one single compressed file, or each file can be placed into it's own individual compressed file. The first option uses the least amount of disk space, but has the disadvantage that "all the eggs are placed in one basket", so to speak. Also, versioning cannot be used if all files are placed into a single compressed file.

To increase compression performance SyncBackSE can be configured not to try and compress already compressed files, e.g. MP3's, JPG images, etc. Instead of compressing files of these types it will instead store them (without compression) in the Zip file. Note that they are still stored in a Zip file but are not compressed within the Zip file.

warning

SyncBackSE is Unicode enabled, so it can store files and folders with names in any language, e.g. Chinese, in a Zip file. However, some compression programs, e.g. WinRAR, are not Unicode enabled. Because of this if you open a Zip file produced by SyncBackSE using a non-Unicode enabled compression program then it will show the filenames incorrectly (probably with question marks). The problem is with the compression program, not the Zip file produced by SyncBackSE. The solution is to use a compression utility that is Unicode enabled, such as 7Zip, for example.

Also note that if you open a split Zip file created by SyncBackSE in a compression program, e.g. WinZip, then it may give an error saying the file is corrupted. The problem is that it is expecting the split filenames to be named differently. See this section for details.

Compression Settings

· Compress the files on destination/right into a Zip file: Enable this option to compress files copied to the destination/right into a Zip file.

· Put all files in the destination folder into a single compressed file: If this option is enabled, then the files will be put into a single compressed Zip file. If this option is not enabled (the default), then each file will be placed into it's own Zip file.

· Try and compress files that are being used: By default any file that is being used will not be copied. This is done to avoid corruption, i.e. a file could be changed by another program while a compressed version of it is being created. Enable this option to ignore this safe-guard.

· Type of compression: There are three types of compression: Deflated (which is the default), Deflated64, and Burrows Wheeler.

Deflated provides the normal type of compression used by the older Zip format (traditional PKZIP 2.04g compression method).

Deflated64 (also know as Enhanced Deflate) provides a greater level of compression, but note that it will increase the compression time and is not compatible with older Zip compression programs. Deflate64™ is a trademark of PKWARE Inc.

Burrows Wheeler (popularized by the UNIX and Linux BZip2 program) offers significantly better compression than Deflate but takes longer to compress and decompress data. Tests have shown BWT (Burrows Wheeler Transform) to often achieve between 20% to 30% better compression than Deflate on many popular file types such as databases, pictures, text and executable files. BWT is considered to be one of the most efficient compression algorithms for compressing XML data. In comparison to BWT, Deflated64 is slightly faster but does not compress as well.

BZip2 is similar to the Burrows Wheeler compression method except that it is compatible with some compression programs, e.g. WinZip 11. Note that in some cases, e.g. with highly random data, the compression speed can be very slow as compared to the other compression methods. However, it generally provides the best compression level.

warning

Note that the BWT compression method is not supported by any other compression program. Only SyncBackSE can be used to restore BWT compressed files.

· Level of compression: There are ten levels of compression ranging from level 0 (no compression, files are stored in a compressed file but are not actually compressed) to level 9 (highest compression). The more a file is compressed, the slower it takes to compress the file (it will also use more memory). This option allows you to make a trade-off between speed and file size. The Type of compression setting also influences the compression speed and file size.


Compression, Encryption

Expert Mode: Compression, Encryption Settings

· Encryption method: If you wish to password protect the contents of the files in the Zip file then choose the encryption method to use. AES encryption is more secure but not as portable. For example, "Old style" encrypted Zip files can be decrypted and extracted using practically any 3rd party Zip program. However, AES encrypted Zip files can only be decrypted and extracted using newer 3rd party Zip programs, e.g. WinZip 9.

· Password: If you want to password protect the files in the compressed archive then enter a password here. It's important to note that if you change the password then the existing files in the destination will still use the old password. Each file in a compressed archive has its own password.

note

Note that you are entirely responsible for remembering the password used. It is not possible under any circumstances for 2BrightSparks to recover lost passwords.


Compression, Advanced

Expert Mode: Compression, Advanced Settings

Advanced Compression Settings

· Create self-extracting Zip files: If ticked then a self-extracting Zip file will be created. A self-extracting Zip file is an executable program, that when run, will extract its contents. The benefit is that a 3rd party Zip program is not required to uncompress the files.

· Enable disk spanning (note that this is not possible if unattended): If you are performing a backup to a removable media, e.g. a floppy-disk, etc. then it may be that the backup cannot fit onto one disk. If this option is enabled then the Zip file will be split across each disk. An important point to note about spanned/split Zip files are that they cannot be modified once created. The existing Zip file will be automatically deleted and rebuilt. For this reason you may wish to use a Fast Backup profile that does full and incremental backups.

· Limit the disk usage to…: If Enable disk spanning is enabled then this is the maximum amount of disk space to use on each disk.

· Create a multi-part Zip file with each part having the maximum size of…: If Enable disk spanning is not enabled then setting a value means you want a split zip file with each part being no more than the size specified. An alternative to disk spanning is to split a Zip file into several files. These separate parts can then be copied manually to a disk, FTP server, etc. An important point to note about spanned/split Zip files are that they cannot be modified once created. The existing Zip file will be automatically deleted and rebuilt. For this reason you may wish to use a Fast Backup profile that does full and incremental backups. Note that the naming standard used by SyncBackSE is not compatible with some Zip programs. See the section below for more details.

· Filename extension: This option is only available when compressing each file to its own file. Enter the filename extension to use for the destination compressed files. By default '.zip' is used.

· Temporary directory: By default, temporary files produced during compression are stored in your standard Windows temporary directory. You can however change this using this option. For example, you may be using a small RAM disk as your temporary directory and so when using compression you would like the temporary files stored on your RAM disk. It is recommended you leave this setting empty so that the default temporary directory is used.

Split Zip Files

note

The naming standard used by SyncBackSE for split Zip files is different from that used by WinZip and possibly other compression utilities. For example, the following files may be created:

Test.zip

Test.z02

Test.z03

If you attempt to open the Zip file using WinZip it will incorrectly report that the Zip file is corrupt. If you wish to open the Zip file using WinZip you must rename the files as follows:

Rename test.zip to test.z01

Rename test.z03 to test.zip (i.e. change the extension of the last file to .zip)


Compression, NTFS

Expert Mode: NTFS Compression Settings

· Use NTFS compression on files copied to the source/left (only valid on NTFS volumes): If enabled, and the source/left is on a volume formatted with the NTFS file system, then files copied from the destination/right to the source/left will be compressed using NTFS compression.

· Use NTFS compression on files copied to the destination/right (only valid on NTFS volumes): If enabled, and the destination/right is on a volume formatted with the NTFS file system, then files copied to the destination/right from the source/left will be compressed using NTFS compression.


Compression, Compressed

Expert Mode: Already Compressed Files Settings

To increase compression performance SyncBackSE can be configured not to waste time trying to compress already compressed files, e.g. MP3's, JPG images, etc. Instead of compressing files of these types it will instead store them (without compression) in the Zip file. Note that they are still stored in a Zip file but are not compressed within the Zip file.


Encryption

Expert Mode: Encryption Settings

Please review the Compression Encryption page in this help file.


FTP

Expert Mode: File Transfer Protocol Settings

SyncBackSE uses a modern FTP engine that takes advantage of newer FTP standards and extensions, e.g. SFTP ( sbpro-feature-16x16 Pro version only), FTPS, XCRC, MODE Z transmission compression, UTF8, and SSL/TLS transmission encryption. This increases performance and compatibility with FTP servers.

This tab is only displayed in Expert mode. The FTP options are not available when the destination/right is using compression, email, scripting, or a CD/DVD.

FTP Servers and File Dates and Times

When SyncBackSE transfers a file to an FTP server it will try and set the last modification date & time of the file so that it matches the date & time of the local file. However, many older or basic FTP servers are simply do not provide the functions to perform this. There are standards for communicating with FTP servers, but not all FTP servers follow those standards, or they implement them incorrectly. There are also many FTP features which are optional, and one of those optional features is setting the last modification date & time of files on the FTP server. This is not a limitation of SyncBackSE, but of the FTP server.

SyncBackSE has an advanced FTP engine that will try several methods to set the last modification date & time of files on an FTP server:

1. If the server supports the MFMT extension then that will be used.

2. If the server supports the SITE UTIME extension then that will be used.

3. If the server supports the MDTM extension then that will be used. Note that there are two forms of the MDTM extension: one to get a files date & time, and one to set a files date & time. Many FTP servers support retrieval of a files date & time, but fewer also support setting of a files date & time using MDTM.

4. If the server supports none of the above then there are two options: have SyncBackSE change the date & time of the local files to match the date & time of the file on the FTP server (which will be the date & time the file was transferred to the FTP server), or change the profile to a Fast Backup profile. With a Fast Backup profile it will not set the date & time of the files on the FTP server, but it will avoid any problems with the dates & times being different.

FTP Server Connection Details

· Destination/right files are on an FTP server: If ticked, then the destination/right is an FTP server, i.e. you are backing up to or synchronizing with an FTP server. If the destination is an SFTP server, or an SFTP server ( sbpro-feature-16x16 Pro version only), then define this on the FTP -> Advanced page.

· Hostname: This is the hostname of the FTP server that has the destination directory on it, e. g. ftp.myserver.com. Note that you must just use the hostname or IP address. Do not enter an URL, e.g. ftp://ftp.myserver.com/folder/

· Username: Your server login username.

· Password: Your server login password. If you are using an SFTP server with key authentication ( sbpro-feature-16x16 Pro version only) then you can leave this blank.

· SFTP Key: If you are using an SFTP server with key authentication then this is the filename of the key file.

· SFTP Key Password: If the key file requires a password to be used then enter the key file password here.

· If the FTP server cannot set a files date & time then change the local files date & time to match that on the server: SyncBackSE will force the date & time of the file on the FTP server to match that of the file on your PC. If it cannot set the time of the file on the server, and this option is ticked, then it will change your local files date and time. However, if this option is not ticked (the default) then the date and time of the file on the FTP server is not changed and neither is the local files date & time. If the FTP server cannot set a files date & time, and you do not want to change your local files dates & times, then the solution is to use a Fast Backup profile.


FTP, Advanced

Expert Mode: Advanced FTP Settings

· This is an SFTP server (port 22): sbpro-feature-16x16 SFTP support is a Pro only feature. If the FTP server is an SFTP server then tick this checkbox.

· Port: The port number of the FTP server. Most FTP servers use port 21, except when using Implicit SSL/TLS encryption in which case most FTP servers use port 990. Most SFTP servers users port 22.

· Reconnect Attempts: Whenever the connection to the FTP server is lost, for whatever reason, SyncBackSE will reconnect and resume from where it left off. This is done in the background and does not require any user intervention. This setting specifies the number of attempts SyncBackSE should make to reconnect to the FTP server before it gives up. Note that this number refers to sequential attempts, not the total number of attempts that may be made over the entire profile run (i.e. once a reconnection is made the attempt counter is reset back to zero).

· Seconds Between Attempts: The number of seconds SyncBackSE should pause before making another attempt to reconnect to the FTP server.

· Read timeout (seconds): In some situations, e. g. when the connection is dropped, an FTP server may not respond to requests from SyncBackSE. This setting tells SyncBackSE how long to wait (in seconds) for an answer from the server whenever one is required. By default SyncBackSE will wait for 60 seconds before disconnecting and reconnecting to try again.

Encryption and compression options

Note than none of these options are available when using an SFTP server as they are not applicable.

· Encryption method to use: Select the encryption method from the drop-down list. With most FTP servers it is suggested that the 'SSL v2 or v3' option is selected. This provides the most compatibility. If the FTP server does not support SSL encryption then this option and all the SSL settings are ignored.

· Client certificate to use: If FTP encryption is being used then you can use this setting to specify which certificate SyncBackSE should use (or if one should be used at all). The certificate list is taken from the Personal certificates installed on the computer.

· Encrypt the data channel: If enabled the data channel will also be encrypted. Note this will significantly slow down the profile.

· Use implicit connection (port 990): If enabled an implicit SSL connection will be made (most FTP servers use port 990 for implicit connections). If disabled, an explicit SSL connection is made (most FTP servers use the standard FTP port 21 for explicit connections). This option is not available when using an SFTP server.

· Reduce bandwidth by using compression (MODE Z): To increase performance on slower networks enable this option. It will transmit data to and from the server in compressed form to reduce the send and receive time. Note that this option requires that the FTP server supports the MODE Z FTP extension. If not, this option will be ignored. Also note that enabling this option when the FTP server is on a LAN will actually decrease performance.

Misc.

· Limit bandwidth usage to…: This option lets you restrict the amount of bandwidth used for the FTP connection. For example, you may also be using the network for other things the same time the profile is run and do not want the profile to use all available bandwidth on the network.

· Quote Character: If your FTP server supports wrapping quotes around filenames, e.g. if they have spaces, then enter the quotation character here. If your FTP server does not require or support quoting (most do not) then leave this empty. In most cases uses any value here will cause problems. This option is not available when using SFTP.

· Server timezone: If the FTP server is in a different timezone then enter the number of minutes difference from GMT/UTC, e.g. +120 (meaning 120 minutes ahead of GMT/UTC), -60 (meaning 60 minutes behind GMT/UTC). Generally you do not need to enter a value, but in case the FTP server is incorrectly changing the date & times of files then you can correct it here. See also the MDTM syntax setting. This option is not available when using SFTP.

· Use Unicode (UTF8): This setting tells SyncBackSE to either use or not use the UTF8 extension on the FTP server. Some FTP servers do not correctly support UTF8 so you may wish to tell SyncBackSEnot to use it. Also, some FTP servers do support it but don't tell FTP clients that they can and do support it.

· MDTM syntax: In most situations it's best to leave this setting as Default. However, some FTP servers may require that a different command format be used. The MDTM command is used to set the last modification date & time of a file on the FTP server. See also the Server timezone setting. This option is not available when using SFTP.

· Server requires Allocate command: Some (old) FTP servers require that the FTP client reserve disk space before transferring files to the server. In general, the majority of FTP servers do not require or support this. This option is not available when using SFTP.

· Force binary transfers: To increase performance SyncBackSE will not tell the FTP server it wants to transfer files in binary mode before every file is transferred. If this option is not enabled (default) then it will tell the FTP server to use binary mode immediately after the connection is made, and it will not tell it again. If this option is enabled then SyncBackSE will force the FTP server into binary mode before every file transfer. This will increase profile run times but may be required for some FTP servers. This option is not available when using SFTP.


FTP, Proxy

Expert Mode: FTP, Proxy Server Details

Note that none of these settings are available when using SFTP.

· I use a proxy server: If you must use a proxy server to connect to external FTP servers then you must enable this option.

· Hostname: This is the hostname of the proxy server, e.g. proxyserver.com

· Username: Your proxy login username.

· Password: Your proxy login password.

· Port: The port number of the proxy server. This value varies depending upon the type of proxy server software used. Although "1" is the default, it will almost certainly not be this number.

· Proxy Type: This setting defines what type of proxy server you are using. It is important the correct setting is used otherwise SyncBackSE will not be able to login to your proxy server. Check with your Network Administrator on which proxy setting to use.


FTP, Firewall

Expert Mode: FTP, Firewall/Router Settings

Note that none of these settings are available when using SFTP as they are not applicable.

· Passive: If the FTP server is behind a firewall then you may need to enable this option. If SyncBackSE can login to the FTP server, but cannot transfer files or retrieve a folder listing, then try enabling this option to see if it fixes the problem.

· Try to keep the connection alive during file transfers: It is not recommended that this option is used. Use of this option with many FTP servers can cause odd errors (because the commands sent to the FTP server, and the replies given by it, can become "out of sync"). If this option is enabled then when files are sent to, or received from the FTP server, a NOOP command is sent to the FTP server every 30 seconds. In some rare cases this can stop the FTP server from assuming the connection has been broken during long file transfers. However, in the majority of cases the use of this option instead causes more problems.

· Use Clear Command Channel (CCC): Choose this option if you are behind a firewall or router that uses NAT (Network Address Translation) and you are having connection problems. Some routers can dynamically change the FTP communication to translate I.P. addresses but this can only be done if that part of the FTP communication is not encrypted.

· External I. P. address: If you are behind a router, and are using NAT (Network Address Translation), then you may need to enter your external I.P. address here. This is usually the I.P. address of your router and is not a local I.P. address. This option is not required (or enabled) when using passive connections.

· Use ports ranging from...: If you are behind a firewall then this is the range of TCP ports that you must open on your firewall to allow the FTP server to contact SyncBackSE. If the ports are not open then files cannot be transferred. This option is not required (or enabled) when using passive connections.


Miscellaneous

Expert Mode: Additional Options in SyncBackSE Settings

Miscellaneous Settings in Expert Mode

This page is for miscellaneous settings that don't fit into other categories.

· Priority: These are the priorities used when running this profile. You can define the priority used when run manually, and also when run automatically. A profile with a higher priority will run faster than a profile with a lower priority, if both the profiles are run at the same time. There are seven levels of priority from Idle (the slowest) to TimeCritical (the fastest). It is not recommended that you use TimeCritical as it may cause your entire computer to slow down or lock up. If you want a profile to use the least amount of CPU time, then select Lowest. If Idle is used the profile may never be run. Note that the -priority command line parameter will override this setting.

· Flush all open files before running profile: If enabled then all changes to files that are still in the cache are written to disk. This will add a few seconds to the time taken to run a profile.

· Pause for…: In some cases you need to give Windows time to reinitialize network connections and devices (or spin-up CD's) once it comes out of hibernate or standby. This option lets you have the profile pause for a number of seconds before the profile starts running. You can achieve something similar by using the command line parameter -countdown

· Password protect this profile from modification or deletion: To protect the profile from modification or deletion enter a password here. If a password is entered then whenever any attempt is made to modify or delete the profile then the user will be prompted for the password. Important: It is your responsibility to remember the password.

· Speech: You can configure SyncBackSE to speak (or to play a .WAV sound file) when certain events occur. To play a .WAV file use the filename of a .WAV file. If the file exists then it will attempt to play it. Note that it must be a .WAV file and not any other type of file, e.g. MP3. To play other sound file formats you must convert them to .WAV files using 3rd party programs. You can use variables. For example, if you used %DATE% then it would say the current date.


Miscellaneous, Media

Expert Mode: Miscellaneous, Media Settings

· Eject source/left media after the profile has run: If enabled, the source/left media will be ejected once the profile has completed. For example, if your source/left directory is on a CD then the CD will be ejected. Note that this option may not work with USB devices.

· Eject destination/right media after the profile has run: If enabled, the destination/right media will be ejected once the profile has completed. Note that this option may not work with USB devices.

· Load source/left media before the profile is run: If enabled, the source/left media will be loaded/inserted before the profile is run. For example, if your source/left directory is on a CD then the CD will be loaded.

· Load destination/right media before the profile is run: If enabled, the destination/right media will be loaded/inserted before the profile is run.

You can click the Test Eject and Test Load buttons to test if the media can be ejected or loaded. It will work with most removable media, e. g. CD's, DVD's, Compact Flash cards, etc.


Programs Before

Expert Mode: Programs Before Settings

Define what programs will run before and/or after the profile runs.

You have the option of running an external program before the profile starts and/or after the profile has finished. This useful option allows you to prepare the files being copied before the profile has run, for example. There are many possible uses for these settings in SyncBackSE, so read through the following and consider how they may be applied to your own computer setup.

· Run before profile: To have a program run before the profile is run, type the name into 'Run before profile' edit-box or click the folder icon next to it. For example, you could type notepad.exe so whenever the profile starts Notepad will be run. You can use variables to define the program name, path, etc. See the section below for more details.

note

Note that if the program name, or the folder it is in, contains spaces then you must wrap the entire program name with double-quotes otherwise the return value will always be 1. For example, C:\Program Files\Company Name\A Program.exe must be specified as "C:\Program Files\Company Name\A Program.exe". Any parameters passed to the program should also be wrapped in their own pair of double-quotes, especially if they contain spaces, e.g. "C:\Program Files\Company Name\A Program.exe" "param 1" "another param"

· Wait until the program has finished before running profile: If this option is enabled, then when the program is run, SyncBackSE will pause the profile until the program has finished. The program must exit/close before the profile will continue. If you do not enable this option then the program will be run and the profile will carry on running without waiting for it to finish.

· Wait for a maximum of...: If this option is enabled, then you can choose how long SyncBackSE should wait for the program to finish before it continues. If the program does not finish within the specified time then SyncBackSE will continue with the profile. Note that it is advisable to set a maximum waiting time otherwise SyncBackSE may get "stuck" waiting for a program that is not going to exit.

· Abort the profile if the program fails to execute: If enabled, and the before program fails to start (because the program doesn't exist or cannot be run), then the profile will not run. By default the profile will continue to run with a failure.

· Abort the profile if the programs return value is not …: Most programs, batch files, and scripts, have a numeric return/exit value. This usually indicates if it ran without error, and if there was an error, what kind of error occurred. If you tick this checkbox then you can specify which return values the program must return for the profile to be run. A comma-delimited list of values can be entered, and a hyphen used to specify a range of values. For example, if the program returns 0, 1, or a value between 10 and 50 (inclusive) if it was run successfully, and any other value on failure, then in the edit box you would type 0, 1, 10-50.

o ...but do not create a log or record it as a failure: If this option is ticked then if the program does not return the expected value then the profile will stop. No log will be created, and the last run result will remain unchanged. An example is when you need to connect to something that may not always be available, and if it isn't available then it can be safely ignored, e.g. connecting to a network from a laptop.

· Run the program when simulating: By default the program is not run when doing a simulated run. This is advisable as the program may change or delete files, which is not something you generally want to do during a simulated run.

Variables and switches

As with the Source/Left and Destination/Right directories, you can use Windows environment variables. For example, if you typed “Notepad %HOMEPATH%\test.txt” then this would run notepad and open a file in your home directory called test.txt. You can see a list of what typical Windows environment variables are available on the following web page:

http://windowsitpro.com/article/articleid/23873/what-environment-variables-are-available-in-windows.html

By default all external programs are run in a normal window. You can have the program instead run minimized so that they do not appear as a window on the screen. To do this prefix the program with one of the following:

/min This will run the program minimized and will not make it the currently active window. For example: /min "C:\Program Files\Company Name\A Program.exe"

/hide This will run the program minimized and will also hide the window. For example: /hide "C:\Program Files\Company Name\A Program.exe"

Unlike the Source/Left and Destination/Right directories, you can also use special SyncBackSE variables. These are used in the same way as environment variables, except they have a leading underscore character, e.g. %_Source%. The value returned is for the profile being run. Below is a list of the most common variables that you can use:

_Compression = Returns 1 if the destination/right is compressed

_Destination = Destination/right directory/filename

_DestIsFTP = Returns Y if the destination/right is an FTP server

_Priority = Run priority of the profile

_SingleFile = Returns 1 if compressing to a single file (ignore if _Compression returns 0)

_Source = Source/left directory

For a full list see the profile settings INI file.


Programs, After

Expert Mode: Programs, After Settings

· Run after profile: To have a program run after the profile has finished, type the name into 'Run after profile' edit-box or click the folder icon next to it.

note

Note that the special variable %PROFILEFAILED% can be used to pass the result of the profile run. If the value is 1 (one) then the profile failed (or was aborted), if the value is 0 (zero) then the profile run was a success.

· Wait until the program has finished before running next profile or exiting: If this option is enabled, then when the program is run, SyncBackSE will pause and not finish the profile until the program has finished. The program must exit/close before the profile will complete running. If you do not enable this option then the program will be run and the profile finish as per normal without waiting.

· Wait for a maximum of...: If this option is enabled, then you can choose how long SyncBackSE should wait for the program to finish before the profile run ends. If the program does not finish within the specified time then SyncBackSE will end the profile run. Note that it is advisable to set a maximum waiting time otherwise SyncBackSE may get "stuck" waiting for a program that is not going to exit.

· Run the program even if the profile fails: Select this option to run the after program even if the profile fails. By default the program is not run if the profile fails, e.g. a file could not be copied. If the source or destination cannot be connected to then the Run After program is not run.

· Run the program when simulating: By default the program is not run when doing a simulated run. This is advisable as the program may change or delete files, which is not something you generally want to do during a simulated run.

· Run the program after the log file has been closed (any failure will not be recorded in the log): By default the after program is run before the log file is closed and created. This is so the result of the program run can be recorded. It also means the log file has not yet been created. In some situations you may want the after program to use the log file, and if so, you need to enable this option. The variable %LOGFILENAME% can be used to get the filename of the first page of the log file.

· Run the program only if any file changes were made: If you only want the program to run if any files were copied, deleted, or moved, then tick this option.


Auto-close Settings

Expert Mode: Auto-Close Settings

Define what programs will close before running a profile by entering the contents of their title bar.

Although SyncBackSE can copy locked files (under the correct circumstances) it sometimes cannot copy files that are being used by other programs. For example, you cannot copy a Word document while it is being edited in Microsoft Word and the file is on a network drive. One option available is to automatically close those programs so SyncBackSE can copy the files being used. These settings allow you to choose which programs to automatically close before the profile is run.

To add a program to the list, click the Add button. You are then prompted to enter the words that appear in the application title bar of the program you want closed, or select one from the drop-down list. For example, if you want to close Microsoft Word then type Microsoft Word. An important point to remember is that it is case sensitive. For example, if you use microsoft word then it would fail. You only need to enter a fragment, i.e. you do not need to type in the exact title but just a portion of it. To be sure the setting is correct try running the program you wish to close then click the Test button.

To remove entries from the list, click on them and click the Remove button.

Before a profile is run, SyncBackSE will try and close all the programs with those words in their title bar. If you are using Microsoft Word at the time then Word will prompt you to save the document before it closes. However, some programs may not prompt you and refuse to close, or you may want them closed even if they prompt. In this case you must tick the Forcibly close programs that will not close gracefully option. If this option is enabled then SyncBackSE will forcibly close those programs if they don't close gracefully.

note

Note that this will very probably result in you losing data, so this option should not be used without careful consideration.


To Email

Email

Expert Mode: Email

In SyncBackSE V4 the Email settings page referred to emailing of the log file. From V5 those settings have now been moved to the Log -> Log Email settings page. This settings page is now for backup to an email server. sbpro-feature-16x16 These options are only available in the Pro version.

Using these settings it is possible to backup (or synchronize) your files with an email server. This is not to be confused with synchronizing emails. SyncBackSE allows you to store your files on an email server. For example: you may be in the office working on some important documents and want to leave the office and work on them at home. You could copy them to a USB key (for example) and take that home, but if you don't have any external storage medium you could instead send them to your email server. At home you would then retrieve them from your email server, work on them, back them up to the email server, go to work in the morning, and restore them from your email server. It's similar to using an FTP server, except you are using your email server. The advantage is that there are numerous free email servers, e.g. Gmail, Yahoo!, etc., on which you could store your files.

A tutorial on backing up files to a Gmail account is available for viewing online:

http://www.2brightsparks.com/howto/sbpro/backupgmail/index.htm

SMTP Server Connection Details

· Destination/right files are on an Email server: Tick this checkbox to backup/sync your source/left files with an email server.

· Hostname: The hostname (or IP address) of your SMTP server, e.g. mail.server.com. Check with your email provider or systems administrator on what that is.

· To: The email address of where to send the files on the SMTP server. Note that some email servers require a full email address, e.g. name@email.address.com. In today's world of junk email, many email servers are configured to reject any email that appears to be spam. If your email server is rejecting your email please make sure you have filled out the settings correctly, e.g. valid To and From addresses are used.

· From: The email address of the sender. This is usually a full email address, e.g. name@email.address.com. It is usually the same as the To email address, however, for debugging purposes (e.g. to check if your email is being rejected) you may want to use a different email address.

· Subject: The subject of the emails that store your files. Note that you can use a range of variables to help you see which files are in which email message, although you don't strictly need to know this (as you should use SyncBackSE to restore/sync the files).

· Must login to SMTP server: If you must login to your SMTP email server then tick this checkbox and enter your login username and password. Note that some servers require a login whereas others may fail if you do attempt to login. Check with your email provider or systems administrator.

POP3/IMAP4 Server Connection Details

· POP3 or IMAP4: Choose the type of server used to retrieve emails. Typically it is a POP3 email server. Check with your email provider or systems administrator.

· Hostname: The hostname (or IP address) of your POP3 or IMAP4 server. Check with your email provider or systems administrator on what that is. Note that in some cases, e.g. Gmail and other web based email services, you may need enable access to your emails via a POP3 (or IMAP4) server.

· IMAP Folder: If you are using an IMAP4 email server then you can optionally enter the name of the folder to store your files in. Note that you can use variables here. Also, you may need to first create the folder on your IMAP4 server.

· Must login to POP3/IMAP4 server: If you must login to your POP3/IMAP4 email server then tick this checkbox and enter your login username and password. Note that some servers require a login whereas others may fail if you do login. Check with your email provider or systems administrator.

Important notes about using backup to email

· Backup to email should not be your primary backup location!
· Use a dedicated email account to store your files. This allows SyncBackSE to delete any non-backup related emails, e.g. spam.
· There can be a potentially long delay between sending an email and it being stored in your email inbox, so do not run the backup too frequently.
· Email servers may have flood control to stop many emails from one address/server.
· Most email servers have a limit on the size of attachments. This means you may not be able to backup large files. To get around this it is recommend you use single Zip compression with splitting (not spanning).
· Use Deflate64 and maximum compression level. This reduces the amount of space used on your email server and also reduces the time it takes to send and receive files.
· Use 256-bit AES encryption (with compression) if your files contain private/sensitive information.
· If you use splitting with compression then note that a split Zip file cannot be updated. This means it will be a full backup every time.
· If you have very large files you should use single Zip compression with splitting (set the split size as appropriate).
· If you have many small files it is recommended you use multi-zip compression.
· When using single zip, if the Make safe copies option is not enabled, then it will delete the existing Zip file(s) before uploading the new one(s).
· It is recommended to match the attachment filename to avoid the email from being blocked.

Gmail

If you are using a Gmail account, the following explains how to configure it so it can be used with SyncBackSE:

· Login to your Gmail account
· Click Settings link in top-right
· Go to Forwarding and POP tab in Settings
· Enable Enable POP for all mail (even mail that's already been downloaded)
· Change When messages are accessed with POP to keep Gmail's copy in the Inbox
· Click Save Changes

The problem with Gmail is that it sometimes forgets these settings and so you may have the problem of SyncBackSE saying there are no emails. This is because the Gmail POP server is saying there aren't any emails because the Enable POP for all mail setting is sometimes "forgotten" by Gmail. Also, sometimes Gmail doesn't appear to delete emails that SyncBackSE asks it to delete.


To Email, Advanced

Expert Mode: Email, Advanced

sbpro-feature-16x16 These options are only available in the Pro version.

· This email account is only used by this program. Delete any emails not created by this program: If you are using a dedicated email account then it is highly recommend that you enable this option. When enabled SyncBackSE will automatically delete any emails that have not been created by SyncBackSE, e.g. spam. This ensures your email account is only storing your files. Warning: if you are using the email account to receive emails not from SyncBackSE then do not enable this option.

· Mask the attachment filename to attempt to avoid it being blocked, e.g. by Gmail: Some email providers, e.g. Google Gmail, will block attachments of a certain kind, e.g. executable programs, pictures, etc. SyncBackSE can bypass this by using a different filename as the attachment filename, e.g. attachment.txt. This does not affect SyncBackSE as it does not depend on the filename of the attachment. However, if you are restoring files manually, for example, then you may wish to keep the original filename. Please note that you could put the original filename in the email body (as well as the email subject) for reference. To help avoid problems, new profiles will have this option enabled by default.

SMTP Server Connection Details

· Port: The port number of your SMTP email server. It is recommended you leave it as zero (then SyncBackSE will use the default port number based on your settings).

· Local computer name: Leave this blank unless you are familiar with the EHLO SMTP command. SyncBackSE tells the SMTP server that this is the name of the computer (the hostname).

· Reply To: The email address any replies should be sent to. You can leave this blank.

· CC: Carbon-copies of the email can be sent to other email addresses. You can enter multiple email addresses by separating them with semi-colons, e.g. you@email.com; you@yahoo.com

· BCC: Blind-carbon-copies of the email can be sent to other email addresses. You can enter multiple email addresses by separating them with semi-colons, e.g. you@email.com; you@yahoo.com

· Receipt: If you require a delivery receipt to be sent then enter the email address of the person to receive that receipt. Note that a receipt is only sent if the email client or email server supports this feature.

· Must use SSL/TLS connection: If your SMTP server requires an SSL/TLS encrypted connection, or it supports one and you want your email to be transmitted to the server in encrypted form, then enable this option. Note that if your server must support SSL/TLS encryption.

· Direct SSL/TLS connection (usually using port 465): If your SMTP server supports a direct encrypted connection then select this option.

· Use STARTTLS command: This is different from the above setting in that it connects to the SMTP server then requests that the connection be encrypted by sending the STARTTLS command to the email server. Choose this option is your SMTP server does not support a direct encrypted connection.

POP3/IMAP4 Server Connection Details

· Port: The port number of your POP3/IMAP4 email server. It is recommended you leave it as zero (then SyncBackSE will use the default port number based on your settings).

· Must use SSL/TLS connection: If your POP3/IMAP4 email server requires an SSL/TLS encrypted connection, or it supports one and you want your email to be transmitted to the server in encrypted form, then enable this option. Note that if your server must support SSL/TLS encryption.

· Direct SSL/TLS connection (usually using port 995 for POP3, 993 for IMAP4): If your POP3/IMAP4 server supports a direct encrypted connection then select this option.

· Use STLS command (POP3 only): This is different from the above setting in that it connects to the POP3 server then requests that the connection be encrypted by sending the STLS command to the email server. Choose this option if your SMTP server does not support a direct encrypted connection. This option is not available if an IMAP4 server is being used.

· I want to customize the email body: If ticked then you are able to create a custom email body instead of using the default. The email body can use Windows environment variables, e.g. %HOMEPATH%, as well as all the SyncBackSE Variables and some special variables that are only available when using an email server to store your files.


Log

Expert Mode: Log Settings

In SyncBackSE V4 the Email settings page referred to emailing of the log file. From V5 those settings have now been moved to this page, and the To Email page is for backup to email.

· Display log after running a profile: Once a profile has finished, if this option is enabled then the log file will be displayed.

note

Note: when the profile is run via a schedule, and Windows Vista or newer is being used, then the log may not be displayed. This is due to security changes introduced in Windows Vista (basically when SyncBackSE is run from a schedule it cannot interact with the user interface).

· Only when errors occur: If this option is enabled, then the log file will only be displayed if any errors occurred during the profile run, e.g. a file could not be copied.

· Log the reason why files/folders on source/left are ignored: In some cases you may want to know why a file or folder was not copied from the source/left. If this option is enabled then the log file will state the reason. Note that this is the reason why SyncBackSE did not wish to copy the file/folder. The file/folder may still have been copied if you told SyncBackSE to do so in the Differences window.

· Log the reason why files/folders on destination/right are ignored: In some cases you may want to know why a file or folder was not copied from the destination/right. If this option is enabled then the log file will state the reason. Note that this is the reason why SyncBackSE did not wish to copy the file/folder. The file/folder may still have been copied if you told SyncBackSE to do so in the Differences window.

· Do not log skipped files or folders: If ticked then skipped files are not recorded in the log. Files are skipped, for example, if you have a backup profile and there is a file that is just in the destination, and your settings are to ignore those files.

· Log the drive serial numbers (internal and external drives only): If ticked then the drives hardware serial number is recorded in the log file. The hardware serial number is not the same as the serial number given to a partition when you format it. Drive serial numbers cannot be changed.

· Log the S.M.A.R.T. information to check for possible drive failure (internal drives only): sbpro-feature-16x16 S.M.A.R.T. support is a Pro only feature. S.M.A.R.T. is an acronym for Self-Monitoring, Analysis, and Reporting Technology. If ticked a check is made to see if the drive may fail in the near future (or if it has already failed). This feature only works if your computers BIOS supports the SMART standard (most do), and it has also been enabled in your BIOS, and the drive supports SMART (most do). Note that there are countless types and versions of BIOS's available so please refer to your BIOS manual for information on how to do this. Although using this help detect impending drive failure, it is not a perfect technology. It should not be relied upon to always detect an impending drive failure.

· If a file cannot be copied because it was deleted before it could be copied then make it a warning and not a failure: In some cases you may get run failures because a file (usually temporary files) cannot be copied because they have been deleted (or moved) by something else before they could be copied. If you prefer to have these errors instead recorded as warnings (so they don't cause a profile run failure) then enable this option. Care should be taken when using this option as you are telling SyncBackSE that it should not treat an error as an error. Note that this option is ignored when running a profile as a restore, and it is also ignored when copying from FTP, email, or single zip files, and is also ignored when copying to or from a script location ( sbpro-feature-16x16 Pro only).


Log, Email Log

Expert Mode: Log, Email

After a profile has been run, SyncBackSE can email the log file. This is especially useful when SyncBackSE is located on a remote machine. The log file can optionally be sent as an email attachment.

In today's world of junk email, many email servers are configured to reject any email that appears to be spam. If your email server is rejecting your log email please make sure you have filled out the settings correctly, e.g. valid To and From addresses are used.

· Email the log file after the profile has run: To email the log file, enable this option. If the profile is disabled then no log will be sent.

SMTP Server Connection Details

· Hostname: This is the hostname of your SMTP email server, e. g. smtp.mailserver.com. Note that it is the SMTP server (which is used for sending email), not the POP3 or IMAP4 server (which is used for receiving email).

· To: The email address to send the log file to. You can enter multiple email addresses by separating them with semi-colons, e. g. you@email.com; you@yahoo.com

· From: The email address from which the log file has been sent. Typically you would put your own email address here. Note that some SMTP servers may reject the email if it is not from a valid email address or an email address on that server.

· Subject: The subject to use for the email, e.g. SyncBackSE Log File. Note that you can use environment variables in the subject. You can also use the special variable %PROFILENAME% to put the profiles name in the subject, e.g. Log file for %PROFILENAME%

· Must login to SMTP server: If you must login to your SMTP server then enable this option. Due to spam, most email servers now require you to login. SyncBackSE can login to SMTP servers that require a username and password in clear-text, NTLM, CRAM-MD5, or MSN.

o Username: The username to use to login to your SMTP server.

o Password: The password to use to login to your SMTP server.


Log, Advanced

Expert Mode: Email, Advanced Settings

· Only send the email if an error occurs: If you only want the log file to be emailed if the profile failed then tick this check box, otherwise the log file will be emailed after every run. The email subject will be prefixed with [Failed] if the profile run failed.

o …or there are differences: If you only want the log file to be emailed if the profile run failed, or differences were found between the source and destination, tick this check box.

· Do not attach the log file, just send the email body: If you only want the email body, and not the log files attached, then tick this option.

· Only attach the log file if an error occurs: Tick this option if you only want the log file attached to the email if the profile run fails.

· Compress the attached log file and give the attachment a filename of …: This option is enabled by default. When enabled the log file will be compressed into a single zip file and attached to the email. Some email programs, or corporate environments, will not allow attachments of certain types. If this is the case try changing the filename to log.txt, for example. You can use variables in the filename, e.g. %PROFILENAME%.zip

SMTP Server Connection Details

· Port: The TCP/IP port number which your email server uses. Most SMTP email servers use port 25.

· Local computer name: Leave this blank unless you are familiar with the EHLO SMTP command. SyncBackSE tells the SMTP server that this is the name of the computer (the hostname).

· Reply To: The email address any replies should be sent to. You can leave this blank.

· CC: Carbon-copies of the email can be sent to other email addresses. You can enter multiple email addresses by separating them with semi-colons, e.g. you@email.com; you@yahoo.com

· BCC: Blind-carbon-copies of the email can be sent to other email addresses. You can enter multiple email addresses by separating them with semi-colons, e.g. you@email.com; you@yahoo.com

· Receipt: If you require a delivery receipt to be sent then enter the email address of the person to receive that receipt. Note that a receipt is only sent if the email client or email server supports this feature.

· Must use SSL/TLS connection with SMTP server: If your SMTP server requires an SSL/TLS encrypted connection, or it supports one and you want your email to be transmitted to the server in encrypted form, then enable this option. Note that if your server must support SSL/TLS encryption.

o Direct SSL/TLS connection (usually using port 465): If your SMTP server supports a direct encrypted connection then select this option. Usually port 465 (instead of port 25) is used in this case. To change the port number you must go to the Email - Advanced page.

o Use STARTTLS command: This is different from the above setting in that it connects to the SMTP server then requests that the connection be encrypted by sending the STARTTLS command to the email server. Choose this option if your SMTP server does not support a direct encrypted connection.

· I want to customize the email body: If ticked then you are able to create a custom email body instead of using the default. The email body can use Windows environment variables, e.g. %HOMEPATH%, as well as all the SyncBackSE Variables and some variables that are used especially in the subject and email body.


Network

Expert Mode: Network Settings Settings

If your source/left and/or destination/right directory are on a network, and you are using a UNC path, e.g. \\machine\share\directory, then this page allows you to set the username and password required to connect to the network shares. You can only edit the values if you are using a UNC path.

· Username: Your network username for the source/left or destination/right (as appropriate).

· Password: Your network password for the source/left or destination/right (as appropriate).

· Test Connection: Click this button to test if SyncBackSE can connect to the source/left and/or destination/right using the supplied username and password.

If you use the Network settings in SyncBackSE take account of the following Windows issues:

· To use a network for the source/left or destination/right you must specify a valid UNC path, e.g. \\Machine Name\ShareName\Folder\

· Your current username and password are used before the supplied username and password (unless the option Use this username and password before trying my current username and password is ticked).

· For Windows XP Home you may need to supply the Guest password and not enter any username.

· The username may need to be in the form Domain\Username or MachineName\Username for it to work correctly.

· Windows networking has many quirks and problems. Please experiment with various settings before seeking help.


Network, Advanced

Expert Mode: Network, Advanced Settings

· Use this username and password before trying my current username and password: If enabled then SyncBackSE will try the supplied username and password before using your current username and password. By default SyncBackSE will use your current username and password before trying the ones supplied.

· Do not disconnect from the network after the profile has run: By default SyncBackSE will not disconnect the network connection once the profile run has finished. In some situations, e. g. when using Novell, you may not want SyncBackSE to disconnect.


CD/DVD Burner

Expert Mode: CD/DVD Burner

sbpro-feature-16x16 These options are only available in the Pro version. SyncBackSE can backup to the following types of CD/DVD (your CD/DVD drive also needs to support these types):

· BD-R / BD-RE (Blu-Ray)
· DVD+R Dual Layer
· DVD-R Dual Layer
· DVD+R / DVD+RW
· DVD-R / DVD-RW
· DVD-RAM
· CDR / CDRW
· HD-DVD

It can also backup to an ISO image file which can be mounted as a virtual drive (using 3rd party software, e.g. DAEMON tools) or burned to disk using 3rd party burning software. SyncBackSE also performs automatic disk spanning, i.e. if your files do not fit onto the CD/DVD then it will split the files and continue onto another CD/DVD. Disk spanning does not require the use of compression, but using compression means less disks are used.

SyncBackSE can only backup to disks pre-formatted in the UDF format. It also does not support the automatic disk spanning feature. SyncBackPro does not require UDF, and supports automatic disk spanning. If you import a profile from an older version of SyncBackSE (or SyncBack freeware) that copies to a UDF formatted CD or DVD, and you want to make use of the new disk burning features in SyncBackPro, then you must modify the profile and enable the option Destination/right is a CD/DVD burner, burn the files to the disk in this drive. Note that the contents of the CD/DVD is entirely replaced, i.e. it does not update the existing files on the CD/DVD but instead overwrites everything. Anything already on the disk will be deleted.

note

Backing up to CD/DVD is not recommended for use as your primary backup. It is cheaper, faster, and more reliable to backup to an external drive or USB key. However, if you must backup to CD/DVD, e.g. for offsite storage, it is highly recommended that you check to see if you have the latest firmware for your CD/DVD drive and that you use quality media that is compatible with your drive.

note

If you are using single Zip compression then note that the Zip file is entirely created on the hard drive first, and then copied to the CD/DVD. It is then deleted from the drive once entirely copied to CD/DVD. This means you must have the necessary free hard disk space.

· Destination/right is a CD/DVD burner, burn the files to the disk in this drive: If enabled then the files are copied to a CD/DVD. Note that the contents of the CD/DVD is entirely replaced, i.e. it does not update the existing files on the CD/DVD but instead overwrites everything. Anything already on the disk will be deleted.

· Create an ISO file on destination/right, do not burn the media: If enabled then the files are copied to an ISO file. Note that SyncBackSE cannot restore or read from an ISO file. You need to use 3rd party software to access the ISO file. The ISO file can be mounted as a virtual drive (using 3rd party software, e.g. DAEMON tools) or burned to disk using 3rd party burning software.

· Limit the disk usage (or ISO file size) to: You can optionally limit how much disk space on the CD/DVD that SyncBackSE uses. If the files will not fit onto the CD/DVD then you will be prompted to insert a new disk so the backup can continue. This means you must be physically present to change the disks, i.e. it cannot be an unattended profile run. If the profile run is unattended then it will not prompt you and the backup will fail. If you are copying to an ISO file then this is the maximum size of the ISO file. If the files will not fit into the ISO file then a new ISO file is created to put the remainder of the files into.

· Format: This is the file system type to use on the CD/DVD or ISO file. It is recommended you leave this setting as default. Each format type has different restrictions on the filename lengths and what characters they can contain. SyncBackSE records the original filename of a file so when you restore it will restore using the correct filename, even though the filename on the CD/DVD may be different. If you use compression then the Zip file will contain the original filename. Also note that if you are creating an ISO file then some formats may not be compatible with the 3rd party software used to read or burn the ISO file. Check the documentation of that software for its format requirements.

· If a file or folders name is changed due to the formats requirements then...: As explained in the Format setting, the filename stored on the CD/DVD may not be the same as the original filename. This is a limitation of the file system used, not of SyncBackSE. SyncBackSE gets around this limitation by recording the original name of a file so when it is restored the correct filename is used. However, you may wish to know if a filename has been changed, and can do so with this setting.


CD/DVD Burner, Advanced

Expert Mode: CD/DVD Burner, Advanced

sbpro-feature-16x16 These options are only available in the Pro version.

· Make the disk/ISO bootable: Enable this option to make the CD/DVD bootable. This means you can insert the disk into a drive and boot the computer using it (assuming the computer can boot from a CD/DVD disk). To boot from a CD/DVD you must supply a boot image. SyncBackSE does not provide boot images as they are typically copyrighted software and not free.

· ISO9660 Level: This defines the filename limitations and affects the compatibility of ISO files. If you are copying to an ISO file then note that most 3rd party software can only use level 1. This Wikipedia entry has detailed information on the levels.

· Use ISO file delimiters (';1') (less compatible): This defines if delimiters are used in the filenames. It is not recommend that this setting be enabled.

· Use long Joliet names: This defines the filename limitations and affects the compatibility of ISO files. If you are copying to an ISO file then note that some 3rd party software may not be able to read ISO images if this option is enabled.

· Cache the files (useful when there are many small files or copying from the network): If enabled then part of your hard drive is used to cache files. If you are copying many small files, copying from a network, or copying from a slow device, then it is recommended you enable this option.


Variables

Expert Mode: Variables

Variables are strings that are replaced by something else when the profile is run. For example, you may want to backup to a folder that has the current date in its name. To do this you would use the variable %DATE%, e.g. set the destination to X:\Backup\%DATE%\. This section has more details on what variables are available.

As well as Windows environment variables, SyncBackSE variables, and the getting values from the registry, you can also define your own variables. Those variables can reference other variables. For example, you could create a variable called THEDATETIME and set it to The current date is %DATE% and the time is %TIME%

The variables defined for a profile are only available to that profile. However, if you define a variable in a group profile then it is available to all profiles in that group (but only when the a profile is run as part of the group).

In SyncBackPro sbpro-feature-16x16 , this setup window also displays any variables that are defined by scripts that are run as part of the profile.

To add a variable simply click the Add button. You then enter a unique name for the variable, e.g. MyVariable, and then enter a value (the value can use variables itself).


Scripts

Expert Mode: Scripts

sbpro-feature-16x16 Scripting is only available in the Pro version. Using this window you can specify which Runtime scripts will be used with the profile, and also if the destination/right files are managed by a location script. You must first install the script into SyncBackSE.

· Destination/right files are managed by the following script: If the destination/right should be managed by a location script then tick this checkbox and then select the location script.

· Scripts that should be used when this profile is run (and in the order specified): Tick the runtime scripts you wish to use when the profile is run. You can define the sort order by clicking on a script then using the up and down buttons to move it.

note

The order in which the scripts are set to run is important. This is because, in some cases, only one script can perform an action. For example, if you have a runtime script that renames a file then obviously a file can only be renamed once. This means the first script to rename a file is the one that will rename it. Any following scripts cannot rename the file.


Runtime Help

Run SyncBackSE

Runtime Help refers to operations which occur as SyncBackSE is performing a task like a backup. This section of the help file covers the Differences and and File Collision Windows which allow you a great deal of flexibility in fine tuning your profile task.


The Differences Window

Differences

When you run a profile, if there are any differences detected, e.g. files have changed, this differences window will appear. You can configure your profile never to show this window (see the Compare Options page when creating/modifying the profile).

note

The Differences window is not shown for unattended runs, e.g. scheduled tasks, if you run SyncBackSE with command line parameters, if the ‘Skip the Differences screen' option is enabled for the profile, or if there are no differences. The Differences window will always be shown when doing a restore or simulated run.

If your profile contains tens of thousands of files (or more) then it is not recommended that the Differences window be displayed. This is because displaying so many files uses a lot of CPU time and RAM, and takes a long time to sort.

When a profile is run, SyncBackSE will compare the source/left and destination/right files to find the differences. There may be files in the source/left that are not in the destination/right, for example. After it has made the comparison it will display the Differences window that lists all the differences between the source/left and destination/right. This gives you a chance to see what will happen and change what actions will be taken. For example, a file may be marked for deletion but you may decide not to delete that particular file.

At the bottom left of the window are details on the currently selected files. It shows the differences between the file on the left and the file on the right. Newer dates & times, and large file sizes, are shown in green, older dates & times, and smaller file sizes, are red.

The bottom right panel gives details on the number of files, and the amount of data, that will be copied, deleted, and skipped.

note

Note that the free disk space shows the estimated free disk space on the source/left and destination/right based on the actions made. For example, if you choose to delete files from the right then its free disk space will increase.

Mirror all the files to the right: When this button is clicked all the files on the left will have their action changed so that they are copied to the right. Any files on the right which are not on the left will have their action changed so they are deleted. This button lets you quickly tell SyncBackSE that the right should have exactly the same files as the left. Note that you can mirror a selection of files via the pop-up menu.

If you keep the SHIFT key pressed while clicking the button, then the files will be moved instead of copied.

Mirror all the files to the left: This does the opposite of the above button, i.e. the left should have the same files as the right. Note that you can mirror a selection of files via the pop-up menu. You cannot mirror files to the left if you have a traditional fast backup profile.

Between the Left and Right columns is the Action column. This shows what will happen to that file. Note that not all the options are available for each file as it depends on what the situation is with that file. For example, you cannot copy the left file if it doesn't exist:

 | Skip: Ignore the file and do nothing.
 | Copy to right: Copy the left file to the right. This will overwrite the right file, if it exists.
 | Copy to left: Copy the right file to the left. This will overwrite the left file, if it exists.
move-to-dest | Move to right: Move the left file to the right. This will overwrite the right file, if it exists, and delete the file from the left.
move-to-source | Move to left: Move the right file to the left. This will overwrite the left file, if it exists, and delete the file from the right.
unchanged | Unchanged: This option is only available when running a Fast Backup profile. By selecting this option you are telling SyncBackSE that the file actually has not changed and nothing should be done. This is useful, for example, when you have a copy of a file on an FTP server but the date & times do not match. However, you know the file is identical.
 | Delete: Delete both the source and destination files.
 | Delete from left: Delete the file on the left.
 | Delete from right: Delete the file on the right.
 | Collision, prompt me: You will be prompted what choice to make after you close this window.
 | Missing, prompt me: You will be prompted what choice to make after you close this window.
 | Details differ, prompt me: If the files are identical, but their attributes are different, then you can choose to be prompted on which files attributes to use.
 | Use details from left: The files are identical, but their attributes are different, so copy the attributes from the left file to the right file.
 | Use details from right: The files are identical, but their attributes are different, so copy the attributes from the right file to the left file.

There are three ways to change the Action for a file:

· Click on the Action item and select the new action from the drop-down list

· Right-click on the row and select the new action from the pop-up menu

· Use hot-keys

You can change the action for multiple files by clicking on the rows and pressing the Shift and Ctrl keys. You can press Ctrl-A to select all the files. Right-click on the selection and choose the action from the pop-up menu. Only actions that are available for all the selected files are shown.

You can use the following hot-keys to change the action of the selected items:

· Ctrl-S: Skip the files

· Ctrl-L: Copy files to the source/left

· Ctrl-R: Copy files to the destination/right

· Ctrl-D: Delete the files from both the source/left and destination/right

· Ctrl-U: Mark the files as unchanged (Fast Backup profiles only)

· Ctrl-N: The newer file will replace the older file (any version changes are lost)

To be prompted immediately on what to do with a file you can select the file (by clicking on its row) and pressing Ctrl-P (or by double-clicking the row, or selecting 'Prompt me now' from the pop-up menu). The File Collision Window will appear from which you can make a choice. Note that nothing is done with the file until after the Differences window is closed.

There is a roll-out bar at the top of the Window. Click on it to display other options:

· Show files/folders not on left: If not selected then files and folders that are only on the right are hidden.

· Show files/folders not on right: If not selected then files and folders that are only on the left are hidden.

· Show changed files: If not selected then files that are on both the left and right, and are different, are hidden.

· Show skipped files/folders: If not selected, then skipped files and folders are not shown.

· Only show action icons, not text: If selected then the Action column will just show icons and not text. This reduces the width of the Action column giving you more space.

· Keep window on top of all others: If selected then the Differences window will be placed above all other windows on your desktop.

· Do not display this window again for this profile: If ticked then this window will not be displayed again when this profile is next run. This is identical to the "Skip the Differences screen when this profile is run (it is never shown when unattended)" option in the Compare Options page in the profiles configuration. Note that this checkbox is not shown when the run is a simulation or a restore (as the Differences window is always shown when a profile is run in simulation or restore mode).

After you have reviewed the differences, made whatever changes are required (if any), and are ready to continue with the profile run, you can click either the 'Continue' button or the 'Abort' button. Aborting will stop the profile run immediately and no files will be copied, deleted, or moved.

Comparing Files

SyncBackSE can tell you files are different, and using third party programs, you can ask SyncBackSE to show you the actual differences between the files. Click the Comparison Programs button to tell SyncBackSE which programs to use to compare which types of files.

To compare files simply click the file (or files to compare multiple files) and press Ctrl-M, or select Compare from the pop-up menu. You can also configure the double-click action to compare files.

note

Note that the files must be retrieved to the local drive for comparison. If you have large files on FTP servers, or slow networks, then there may be a delay while retrieving the files.

Opening Files

To open (view) a file simply click the file (or files to compare multiple files) and press Ctrl-O, or select Open from the pop-up menu. You can also configure the double-click action to open files.

You can also drag & drop files from the Differences window onto your desktop, for example. Click on the file, keep the left-mouse button pressed, drag it to your desktop, and release the mouse button.

note

Note that the files must be retrieved to the local drive to be opened. If you have large files on FTP servers, or slow networks, then there may be a delay while retrieving the files.

Collisions

A "collision" is when a file in the source and destination differ, yet have the same name. That is, the file is both in the source and destination but is modified in some way, perhaps by date, size etc.

A notification of collisions occur in the "Differences" window which appears by default when making a backup (note however there are circumstances when the "Differences" window does not appear, for example when the user has chosen not to show the window):

Collisions are shown in red in the "Differences" window to highlight there are going to be changes made when you continue the profile task. If the user views the Differences window carefully, the user has the option to make choices about whether they want to accept the changes SyncBackSE will make, or bypass them with a right click and choose a different action. For more read about the Collision Window.


The File Collision Window

File Collision

When you run a profile, and you have enabled prompting, then the File Collision window will appear when a decision is required from you on what to do with the file. Note that for unattended profile runs, e.g. when scheduled, this window does not appear and instead the file will be skipped.

On the Decisions Files and Folders pages, in Profile Setup, you have the option of asking SyncBackSE to prompt you under certain circumstances, e.g. if a file is in both the source/left and destination/right, but the files are not the same. For example, if you created a backup profile, then run the profile, and edit a file in the source, you would then have a file in the destination that is not the same as the one in the source. On the next run of the profile, if you have configured your profile to be prompted, then a window will appear asking you what action to take for this file.

The window has the filename at the top. If the filename is too long to fit in the edit box, you can resize the window. Information is also shown on where the file is in the source/left and destination/right, the size of the file, it's last modification date & time, it's attributes, and it's hash value (if you have configured the profile to use hashing for file comparisons). When there are differences the values are highlighted in green or red. For example, if the left/source file is newer than the right/destination file then its date & time is shown in green where as the right/destination files date & time is shown in red.

There are two sets of information: for the file on the left, and for the file on the right. Between the left and right files details is a box listing what actions you can take. There are a number of options available to you, some of which may not be shown depending on how you've configured your profile and what the differences are:

 | Skip: No action will be taken with this file. The file will not be copied or deleted, and it will be ignored. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the files will be skipped.
 | Copy to left: The file on the right will replace the file on the left. If you click the Always button then you won't be prompted, during this profile run and in this kind of situation, and instead the left file will be replaced by the right file.
 | Copy to right: The file on the left will replace the file on the right. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the right file will be replaced by the left file.
move-to-dest | Move to right: Move the left file to the right. This will overwrite the right file, if it exists, and delete the file from the left. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the file on the left will be moved to the right.
move-to-source | Move to left: Move the right file to the left. This will overwrite the left file, if it exists, and delete the file from the right. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the file on the right will be moved to the left.
unchanged | Unchanged: This option is only available when running a Fast Backup profile. By selecting this option you are telling SyncBackSE that the file actually hasn’t changed and nothing should be done. This is useful, for example, when you have a copy of a file on an FTP server but the date & times do not match. However, you know the file is identical.
 | Delete: The file will be deleted from the left and right. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the files will be deleted.
 | Delete from left: The file on the left will be deleted. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the file on the left will be deleted.
 | Delete from right: The file on the right will be deleted. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the file on the right will be deleted.
 | Missing, prompt me: The file is either not on the left or right, and you want to be prompted later on what to do when the profile run continues. Note that this option is only available when prompted from the Differences screen. After that screen is shown (or if you've configured the profile not to show that screen) then this option is not available.
 | Collision, prompt me: The file is both on the left and right, and you want to be prompted later on what to do when the profile run continues. Note that this option is only available when prompted from the Differences screen. After that screen is shown (or if you've configured the profile not to show that screen) then this option is not available.
 | Details differ, prompt me: The files are identical but the attributes and/or last modification date & time are different, and you want to be prompted later on what to do when the profile run continues. Note that this option is only available when prompted from the Differences screen. After that screen is shown (or if you've configured the profile not to show that screen) then this option is not available.
 | Use details from left: The files are identical but the attributes and/or last modification date & time are different, but you want to copy the attributes and date & time from the file on the left to the file on the right. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the details from the file on the left will be used.
 | Use details from right: The files are identical but the attributes and/or last modification date & time are different, but you want to copy the attributes and date & time from the file on the right to the file on the left. If you click the Always button then you won't be prompted again, during this profile run and in this kind of situation, and instead the details from the file on the right will be used.

After making your decision you can click the OK or Always button. If you click the Abort button then no action is taken and the profile run is immediately stopped.

Always

What other files are affected when you click the Always button is dependent on the situation. There's an Always action each for:

· Collision (file on both sides and they are not the same)
· The file details differ (same file contents but different file attributes)
· File only on the left/source
· File only on the right/destination

For example: if you had a file on both sides, and they are different (i. e. it's a collision), and you selected an action and clicked Always, then that action will be automatically used for files that are on both sides and are different (instead of you being prompted). If, for example, there is a file only on the left/source then the action does not apply to that. Note that the Always decision applies only for the current profile run, i. e. it doesn't apply the next time the profile is run, or the next profile in a group.

Compare

SyncBackSE can tell you files are different, and using 3rd party programs, you can ask SyncBackSE to show you the actual differences between the files. To compare the files simply click the Compare button. Only when there is a file both on the left and right can the files be compared.

Note that the files must be retrieved to the local drive for comparison. If you have large files on FTP servers, or slow networks, then there may be a delay while retrieving the files.

Shortcut Keys

A number of shortcut keys are available to help users who are familiar with the program make choices quickly:

L - Copy the file to the left

R - Copy the file to the right

D - Delete the file Note both files will be chosen for deletion, but if that option is not available, then the file on the right will be chosen for deletion, and if that option is not available, then the file on the left will be chosen for deletion.

P - Prompt later for what action to be taken

S - Skip the file

U – The file is unchanged (available only with Fast Backup profiles)

note

Note that if you use the Ctrl key with these shortcut keys then the action is immediate. For example, if you press Ctrl-R then the action to copy the file to the right is chosen, and the prompt window is closed.


Technical Reference

Technical Articles

The Technical Reference of this help file provides detailed information about:

Command Line Parameters

Filter Settings

Open and Locked File Copying

Variables

The Progress Bar

Expression Filters

Uninstalling SyncBackSE

U3 Enabled Version


Command Line Parameters

Command Line

A Definition of the Command Line

A Command Line is a space provided directly on the screen where users type specific commands. A CLI (command line interface) is a user interface to a computer's operating system or an application in which the user responds to a visual prompt by typing in a command on a specified line, receives a response back from the system, and then enters another command. The MS-DOS Prompt application in the Windows operating system is an example of the provision of a command line interface. Today, most users prefer the graphical user interface (GUI) offered by Windows or Macs.

SyncBackSE Command Line Parameters

SyncBackSE accepts a number of command line parameters. Some of these are used when SyncBackSE is called from the Windows Task Scheduler. Note that when SyncBackSE is run with command line parameters, by default it will run in Unattended mode and be minimized, which means that it will not prompt the user and will not be visible on screen.

· r: The profiles following this parameter are run in restore mode. By default profiles are run as backups/Synchronizations.

· i: The profiles following this parameter are run in interactive mode. By default profiles run from the command line are run unattended, i.e. no prompts are displayed.

· m: The profiles following this parameter are run in minimized mode, i.e. nothing is displayed on the screen. This is the default.

· n: The profiles following this parameter are run in normal mode, i.e. dialogs and windows are displayed on the screen. By default profiles run from the command line are run in minimized mode.

· p: The profiles following this parameter are run in parallel, i.e. they are all run at the same time. Normally the profiles are run in serial (one after the other).

· s: The profiles following this parameter are run in simulated mode, i.e. no files are actually copied or deleted.

· hibernate: Place the computer into hibernate mode (if the computer supports it).

· standby: Place the computer into standby mode (if the computer supports it).

· shutdown: Logoff, shutdown, and switch off the computer (if the computer supports it) (not supported on Windows 95/98/98SE)

· reboot: Reboot the computer (if the computer supports it).

· rebootifreq: Reboot the computer (if the computer supports it) if a profile was run that required a reboot for a file to be replaced/deleted.

· full: Perform a full backup, i.e. rescan the destination for changes. This is only for profiles using the "Fast Backup" setting.

· countdown [seconds]: When used this parameter will cause a small window appear with a countdown timer in it. For example, if you passed -countdown 10 then a window will appear counting down from 10 seconds. Once it reaches zero then the profiles following it in the command line will be run. You can abort the countdown (and exit the program) and so abort running of the profiles by clicking the Cancel button. If you click OK then the countdown is cleared and the program continues (and so the profiles are run). A countdown is also useful if you want to shutdown the computer after the profiles have run, but also want to abort the shutdown just in case you are using the computer at the time, e.g. -countdown 10 -shutdown. If you use this command line parameter in a scheduled task then make sure the -m parameter is not also used. If the task is scheduled in Vista (or newer versions of Windows) then you must enable the checkbox "Run only when user is logged on" for the scheduled task otherwise the countdown window will not appear (this is due to the new security in Vista and newer versions of Windows).

· countdownmsg [message] [seconds]: This is the same as the countdown parameter, except you can define what message you want to appear in the countdown window. Remember to wrap the message is double-quotes, e.g. -countdownmsg "Shutdown in 10 seconds" 10 -shutdown

· Export [profile name] [filename]: This parameter is used to export a profile, or export all profiles. For example: -export "My Profile" "C:\Profiles\My Profile.sps" will export the profile called My Profile to the file C:\Profiles\My Profile.sps. To export all profiles you must use an asterisk for the profile name and supply a directory instead of a filename, e.g. –export * "C:\My Profiles" will export all profiles to the directory C:\My Profiles. The filenames will be the same as the profile names (with the .SPS filename extension).

· source: Set the source folder for all the following profiles to use. Variables can be used, but please see the important information at the end of the Variables section on how Windows expands environment variables.

· dest: Set the destination folder for all the following profiles to use. Variables can be used, but please see the important information at the end of the Variables section on how Windows expands environment variables.

· nosplash: The splash screen will not be displayed.

· delete [profile name]: The named profile is deleted.

· donotexit: By default SyncBackSE will automatically exit after performing the tasks given on the command line (that is unless the user interface is used while performing those tasks). To stop it exiting use this parameter.

· password [password]: When deleting or importing profiles, an existing profile may exist with that name and be password protected. Use this parameter to provide the password. The password parameter must come before the import filename or –delete parameter, e.g. –password “the password” –delete “profile name”

· priority [priority]: The profiles following this on the command line will be run at this priority. 1 (Idle) is the lowest priority, and 7 (Time Critical) is the highest. The default is 4 (Normal).

· affinity [CPU mask]: This function is only of use on computers that are multi-core or multi-CPU. It ties the SyncBackSE process to one or more specific processors. This can be very useful if you want to limit the CPU resources SyncBackSE can use. The parameter is a bitmap mask (in decimal) with each bit representing a CPU. For example, to force SyncBackSE to only use processor 1 then pass 1, to force SyncBackSE to only use processor 2 then pass 2, to force SyncBackSE to use both processor 1 and 2 then pass 3, to force SyncBackSE to only use processor 3 then pass 4, etc.

· posreset: This will reset the positions of all windows.

All other parameters are assumed to be profile names. If a profile name has a space in it use double quotes around the profiles name, e.g. "All Profiles". The profile names are not case sensitive. So for example:

SyncBackSE profile1 -i profile2 profile3 -n -r "profile 4" -hibernate

This command will run profile1 as a backup/sync in unattended and minimized modes, profile2 and profile3 as a backup/sync in interactive and minimized modes, profile 4 as a restore in interactive and normal mode, and once all the profiles have finished the computer will hibernate.

If SyncBackSE is run with no command line parameters then it will first check to see if any other instances of SyncBackSE are running which also started with no command line parameters. If so, it will not start. This helps ensure only one instance of SyncBackSE is running.

However, whenever SyncBackSE is run with command line parameters, it will run regardless of whether any other instances of SyncBackSE are running or not. Also, if run with command line parameters, SyncBackSE will exit once it has finished its tasks, but if you use any part of its user interface while it is running then it will not exit.

Importing Profiles

You can automatically import profiles by passing the filename of the exported profile on the command line. For example, if you exported a profile and saved it as 'MyProfile. SPS' then if you pass this on the command line to SyncBackSE it will automatically import the profile. The filename extension must be .SPS otherwise it is assumed to be the name of a profile to run.

Importing Scripts

You can also automatically import scripts by passing the filename of the exported script on the command line. The filename extension must be .SBS otherwise it is assumed to be the name of a profile to run. For security reasons scripts are always imported interactively and with the users consent. There is no way to bypass this.

Exit Codes

When running SyncBackSE from the command line, a batch file, etc. then it will return an exit code that gives an indication of whether the task was completed successfully or not. As a number of tasks can be done via the command line at the same time, e.g. import a profile, run it, then delete it, the exit code relates to the last task done on the command line. Also note that if a group profile is run then the exit code is undefined. In the list below, the value shown in brackets, e.g. 0xFFFFFF97, is what the Windows Task Scheduler will show in the Last Result column.

0: Success

100: SyncBackSE did not close because of user interaction or the donotexit parameter was used

-100: The countdown parameter was used and the user aborted it (0xFFFFFF9C)

-101: An attempt was made to import a profile from the command line and it failed (0xFFFFFF9B)

-102: The export parameter was used and a profile export failed (0xFFFFFF9A)

-103: The delete parameter was used and the profile failed to be deleted (0xFFFFFF99)

-104: The user aborted the profile run (0xFFFFFF98)

-105: The profile name given does not exist (0xFFFFFF97)

-106: The profile was not run because it is disabled (0xFFFFFF96)

-107: The profile run failed (note that the result of a group profile run is unknown) (0xFFFFFF95)

-108: An attempt was made to import a script from the command line and it failed (0xFFFFFF94)


Filter Settings

Filter Settings

Define what file types and directories are copied and which are not. Note that if you filter out the desktop.ini file, and have the option to use the desktop.ini file set, then it will be highlighted in yellow in the filter settings window.

· Roll-out: If you click the bar (with the + sign at the left) at the top of the window then a number of options appear.

· Style of filter to use: SyncBackSE supports three different types of filters: Old V3 style filters, Regular expressions, and DOS expressions. See the help below for details on how to use these. Note that you should not use semi-colons (;) if you are using DOS expressions. This is due to a limitation in the Windows operating system call that is used to compare filenames using filters.

· Make these the defaults: If selected then the filters you have set for this profile will become the default filters for all newly created profiles.

· Add (Files/folders to copy): If clicked a dialog box appears letting you enter a filter expression for files to include. You can enter a filename, a folder name, a complete path, etc. Anything matching this expression will be copied. You can enter multiple filters at the same time by using the forward slash (/) to separate them, e.g. item1/item2/item3. You can also press the Again button to immediately enter another filter item.

· Remove (Files/folders to copy): If clicked then the selected items will be removed from the list.

· Do not use filters (can improve performance): If this checkbox is ticked then no filtering is performed. This can reduce the run time of a profile, sometimes substantially. To further improve performance you may also want to disable file & folder selections.

· Add (Files/folders NOT to copy): If clicked a dialog box appears letting you enter a filter expression for files to exclude. You can enter a filename, a folder name, a complete path, etc. Anything matching this expression will be not be copied. You can enter multiple filters at the same time by using the forward slash (/) to separate them, e.g. item1/item2/item3. You can also press the Again button to immediately enter another filter item.

note

Note: The "Enter File Mask" window appears when double clicking any of the filter names in the right hand side "files/folders NOT to copy" *or in the left hand side "files/folders to copy"* pane:

· Remove (Files/folders NOT to copy): If clicked then the selected items will be removed from the list. You can also double-click on an item in the list to change it.

· Re-apply Filter: If clicked, then the filter will be re-applied to the selections you have made in the tree. For example, if you have selected to exclude all files with the extension .tmp then if you have selected a file in the tree which does have that extension then you will be prompted if you'd like to unselect that file. Use the "Re-apply Filter" button instead of the OK button when you haven't made any changes to the filters but want to re-apply them.

When you make a change to the filters, and click OK to save them, then the new filters will be re-applied to the selections you made in the tree.

note

Note: to modify an existing filter double-click it or select it and press F2. You can also click on a filter item (in Files/folders to copy or Files/folders NOT to copy) and press Ctrl-C to copy all the filter items to the Windows clipboard. Pressing Ctrl-A will select all filter items.

note

Note: to copy all the filters from another profile, right-click on the Files/folders to copy or Files/folders NOT to copy box and select “Copy these settings from another profile” from the pop-up menu.

note

Note: you can use SyncBackSE and Windows Environment variables in the filters, e.g. %HOMEPATH%

What are the filters compared with?

A filter is compared with the folders and filenames (which include the path). The root source and destination directories are not used. For example, if your source directory is C:\my files\" and it includes a folder called subfolder and a file called file.txt then the filters would be compared against the following:

\

\subfolder\

\file.txt

Example filters for SyncBackSE V5

The filters in SyncBackSE V5 allow for files and folders to be filtered based on their name. There are three filter types to choose from (see the Help file for details). This article gives examples using DOS Expressions, which is the default filter type.

First, there are three important rules to remember about filters:

1. The selections in the tree override the filters. For example, you can filter out all .txt files but still select some .txt files in the tree.

2. Filters apply to the entire filename, including the path, but the source and destination base are not part of the path. For example, if your source directory is C:\My Documents\ then that will not be in the filename used with the filter. This makes sense if you remember that the source and destination root directories are different, but their sub-directories are going to have the same names.

3. Folder names end with a backslash, where as files do not, e.g. \My \ and \My Documents\filename.txt

4. All file and folder names start with a backslash.

Remember to include folders and files in the filter

If you set your Files/folders to copy filter to just *\*.txt then it will only include text files in the root folder and unselect all child folders. Why? Because you forgot to also include folders. You need to also add *\ to Files/folders to copy to include all the folders (or change that as appropriate to include only folders with certain names, for example).

Another example is if you set your Files/folders to copy filter to just *\ then it will only include folders and no files. Why? Because all folders end with a backslash (\) but no files do. If you want all folders and files the filter should be * (or *\*)

Filters are applied top-down

When SyncBackSE scans a folder it starts from the top (the root) and works its way down the child folders. For each file and folder it first looks to see if it has been specifically selected, or not, in the file & folder selection tree. Selections override filters. If no selection decision has been made then it uses the filters. It first checks to see if the file or folder matches any inclusion filter. If not, it is filtered out, i.e. skipped (ignored). If it's a folder that is being filtered out then all files and child folders of that folder are ignored. If it matches the filter then it checks to see if it matches an exclusion filter. If it does then it is filtered out.

For example, say you have the following folder structure:

\
\Parent\
\Parent\Child\
\Parent\Child\GrandChild\

The root folder (\) is always included and cannot be filtered out. After scanning the files in the root folder, it would then scan Parent, then Child, then GrandChild. Each folder must match a filter (or have been selected in the tree) otherwise everything in it is ignored. For example, if you had the following filter to copy all text files in the Child folder then it would fail:

\Child\*.txt

Why would it fail? Two reasons. First, because the Parent folder does not match that filter so the Child folder is never looked at. Second, the Child folder doesn't match that filter (it is \Parent\Child\). Folders end with a backslash. Therefore the filters must be changed to the following so the folders are included:

\Parent\
\Parent\Child\
\Parent\Child\*.txt

Example DOS Expressions

Notice that many of the examples below also include filters to include folders.

*\ *\*.txt | All text files (.txt) in all folders. The *\ filter ensures all folders are looked at.
*\ *\temp\*.txt | All text files in all folders called temp
\temp\ \temp\*.txt | All text files in the root folder called temp. For example, if your source directory is C:\My Documents\ then this filter is for all text files in C\My Documents\temp\
*\test\ | All folders called test. Note that no files will be copied unless another filter is added to include files, e.g. *\*.txt
*\parent\ *\parent\child | All folders called child whose parent directory is called parent. Notice the filter *\\ is required otherwise it will never look inside folders called parent. Note that no files will be copied unless another filter is added to include files, e.g. *\*.txt
\temp*\ | All root folders whose name starts with temp or is called temp. Note that no files will be copied unless another filter is added to include files, e.g. *\*.txt

Examples of wrong DOS Expressions

The examples below are examples of wrong filters. An explanation is given of why it is wrong.

*.txt | This will match any file, or folder, whose name ends with .txt. If you are trying to just include all text files then you should also remember to add *\ to the filters otherwise no child folders will be selected (see the notes below). If you just want text files in the root then the filter is valid if used on its own.
temp\*.txt | This filter will fail to match anything because all folder and filenames start with a backslash (\) character.


Open and Locked File Copying

Locked and Open Files

Open / locked files can only be copied by SyncBackSE when the following criteria are met:

· SyncBackSE is being used on Windows XP, Windows 2003, Windows Vista, or newer. Both 32-bit and 64-bit versions of Windows are supported.

· The open / locked file is on a local volume that is formatted with NTFS, or it is on a local volume that is formatted with FAT32 and you also have a local volume on an internal drive that is formatted with NTFS. You can copy locked files to any other drive (external or internal), network drive, Zip file, FTP, etc. The restriction is on where the locked file is, not where it is copied to.

· You are running SyncBackSE with a user who is a member of the Backup Operators group (or an Administrator)

"Local" means a volume on a drive that is physically connected to the computer, i. e. open / locked files cannot be copied from drives over the network.

"Internal" means a drive that is connected via IDE, SCSI, or SATA. Drives connected via USB, Firewire, etc. are considered external. Basically, if the drive is inside your computers case then it is considered internal. Note that the first page of the log file will contain a warning if open / locked files cannot be copied because either the above criteria is not met, or there is another problem.

Possible reasons why an open / locked file cannot be copied:

· Only one profile can copy open / locked files at any one time. If two profiles are running at the same time then only one of them will be able to copy the open / locked files. If you are running profiles in a group then unselect the option to run them in parallel.

· Desktop search programs like Copernicus Desktop Search (CDS), Google Desktop Search (GDS), and MSN Search Toolbar, can interfere with the copying of open / locked files. You may need to close those programs to guarantee that open / locked files can be copied.

· The Volume Shadow Copy Service (VSS) is not installed or working correctly. VSS is a part of Windows and not SyncBackSE. It is used to copy open / locked files. If there is a problem with VSS then the log file will contain the error messages.

· You are not using the latest version of SyncBackSE. You may download the latest version from our website.


Variables

Defining Variables

SyncBackSE includes a whole range of variables that can be used in various profile settings, e.g. the Source and Destination. Variables are values which are not known until the profile is run. At runtime the variables are replaced by their value. Note that you can also define your own profile variables, both at the group level and at the profile level. You can also get values from the registry.

For variables see the following sections on this page:

· Days
· Weeks
· Months
· Years
· Dates
· Times
· Drives, Files, and Folders
· Misc.
· Backup to email
· Emailing the log
· Registry
· U3 version variables
· Important notes

Examples of variable usage

Although variables appear to be complex, they are in fact very simple. Just remember that a variables is replaced with its value when the profile is run. A couple of examples will make it clear:

· You are the administrator for a number of employees computers and want to create a backup profile that makes a backup of all the users documents. This profile will be imported on each users computer so you don't need to manually create it on each computer. Each user has their own 'My Documents' folder on a computer, so if you set the source folder to one users folder then it wouldn't work for other users (because they have different usernames, so the path would be different). To avoid this you can simply set the source to %CSIDL_PERSONAL%. Now when the profile is run it will replace the %CSIDL_PERSONAL% string with the users My Documents path.

· You want to backup to a Zip file and use the current date in the filename of the Zip file. To do this simply set your destination (for example) to X:\Backup\%DATE%.Zip

Days

The following variables are related to days of the week, month, etc:

%DAY% Current day of the month, e. g. 10

%DAYOFMONTH% Alias for %DAY%

%DAYODDEVEN% Odd or even day (O = odd day, E = even day)

%DAY_P% Yesterdays day of the month (could be previous month)

%DAY_N% Tomorrows day of the month (could be next month)

%DAYOFWEEK% Current day of the week, (1 = Monday, 7 = Sunday)

%DAYOFWEEK_P% Yesterdays day of the week

%DAYOFWEEK_N% Tomorrows day of the week

%DAYOFYEAR% Current day of the year (January 1st = 1)

%DAYOFYEAR_P% Yesterdays day of the year

%DAYOFYEAR_N% Tomorrows day of the year

%NTHDAYOFWEEK% Note that this value may differ from the value that the WeekOfTheMonth variable returns, because NthDayOfWeek counts every occurrence of the given weekday, while WeekOfTheMonth only counts a week if it includes 4 or more days in the month. Thus, for example, if today is a Saturday and is the first day of a month, NthDayOfWeek returns 1, while WeekOfTheMonth returns 5 (or maybe 4), indicating the last week of the previous month.

%DAYSINMONTH% Number of days in current month.

%DAYSINYEAR% Number of days in current year.

These new variables allow you, for example, to keep 7 days worth of backups, e. g. you could set your destination to D:\Backup\%DAYOFWEEK%\ so that you'll always have backups of the last seven days worth of files.

%DAYOFWEEKNAME% The first three letters of the day of the week, e.g. Mon. Note that English is always used.

%DAYOFWEEKNAME_P% The first three letters of yesterday

%DAYOFWEEKNAME_N% The first three letters of tomorrows

%LASTRUNDAY% The day of the month that the profile was last run (empty string if it has not yet been run)

%LASTSUCCESSRUNDAY% The day of the month that the profile was last run without error (empty string if it has not yet been run without error)

Weeks

The following variables are related to weeks of the month, year, etc:

%WEEKOF% Week of the year (1 to 53). WeekOf uses the ISO 8601 standard to define the week of the year. That is, a week is defined as running from Monday through Sunday, and the first week of the year is defined as the one that includes the first Thursday of the year (the first week that includes four or more days in the year). This means that if the first calendar day of the year is a Friday, Saturday, or Sunday, then for the first three, two, or one days of the calendar year, WeekOf returns the last week of the previous year. Similarly, if the last calendar day of the year is a Monday, Tuesday, or Wednesday, then for the last one, two, or three days of the calendar year, WeekOf returns 1 (the first week of the next calendar year).

%WEEKOFODDEVEN% Odd or even week of the year (O = odd week, E = even week)

%WEEKOFTHEMONTH% Week of the month (1 to 6). WeekOfTheMonth uses the ISO 8601 standard definition of a week. That is, a week is considered to start on a Monday and end on a Sunday. The first week of a month is defined as the first week with four or more days in that month. Thus, if the first day of the month is a Friday, Saturday, or Sunday, the first one, two, or three days of the month are defined as belonging to the last week of the previous month. Similarly, if the last day of the month is a Monday, Tuesday, or Wednesday, then the last one, two, or three days of the month are defined as belonging to the first week of the next month.

%WEEKSINYEAR% The number of weeks in the year (52 or 53). WeeksInYear defines the first week of the year according to the ISO 8601 standard. That is, the first week of the year is the one that includes the first Thursday of the year (the first week that has 4 or more days in the year). This means that WeeksInYear always returns either 52 or 53.

Months

The following variables are related to months of the year:

%MONTH% Current month, e. g. 12

%MONTH_P% Previous month

%MONTH_N% Next month

%MONTHNAME% The first three letters of the current month, e.g. Jan. Note that English is always used.

%MONTHNAME_P% The first three letters of last month

%MONTHNAME_N% The first three letters of next month

%LASTRUNMONTH% The month that the profile was last run (empty string if it has not yet been run)

%LASTSUCCESSRUNMONTH% The month that the profile was last run without error (empty string if it has not yet been run without error)

Years

The following variables are related to years:

%YEAR% Current year, e. g. 2007

%YEAR_P% Previous year

%YEAR_N% Next year

%QUARTEROFYEAR% Returns the current quarter for the current year, i.e. 1 for January to March, 2 for April to June, 3 for July to September, and 4 for October to December.

%LASTRUNYEAR% The year that the profile was last run (empty string if it has not yet been run)

%LASTSUCCESSRUNYEAR% The year that the profile was last run without error (empty string if it has not yet been run without error)

Dates

The following variables are related to dates:

%DATE% Current date (it will be in the short date format configured in your installation of Windows)

%DATE_P% Yesterdays date

%DATE_N% Tomorrows date

Times

The following variables are related to times:

%TIME% Current time (it will be in the short time format configured in your installation of Windows)

%HOUR% Current hour (24 hour clock format), e. g. 19

%MINUTE% Current minute

%SECOND% Current second

%MILLISECOND% Current millisecond (0 to 999)

%HOUROFTHEYEAR% The number of complete hours between the current date & time and 12:00 AM on Jan 1 of the year.

%HOUROFTHEMONTH% The number of complete hours between the current date & time and 12:00 AM on the first day of the month.

%HOUROFTHEWEEK% The number of complete hours between the current date & time and 12:00 AM on Monday of the week.

%MINUTEOFTHEYEAR% The number of minutes between the current date & time and 12:00:00:00 AM on Jan 1 of the year.

%MINUTEOFTHEMONTH% The number of minutes between the current date & time and

12:00 AM on the first day of the month.

%MINUTEOFTHEWEEK% The number of minutes between the current date & time and 12:00 AM on Monday of the week (the week starts on Monday).

%MINUTEOFTHEDAY% The number of minutes between the current date & time and 12:00 AM on the same day.

%SECONDOFTHEYEAR% The number of seconds between the current date & time and 12:00:00:00 AM on Jan 1 of the year.

%SECONDOFTHEMONTH% The number of seconds between the current date & time and 12:00:00 AM on the first day of the month.

%SECONDOFTHEWEEK% The number of seconds between the current date & time and 12:00:00 AM on Monday of the week (the week starts on Monday).

%SECONDOFTHEDAY% The number of seconds between the current date & time and 12:00:00 AM on the same day.

%SECONDOFTHEHOUR% The number of seconds between the current date & time and the start of the same hour on the same day.

%MILLISECONDOFTHEYEAR% The number of milliseconds between the current date & time and 12:00:00:00 AM on Jan 1 of the year.

%MILLISECONDOFTHEMONTH% The number of milliseconds between the beginning (Midnight on the first day) of the month and the current date & time.

%MILLISECONDOFTHEWEEK% The number of milliseconds between the current date & time and 12:00:00:00 AM on Monday of the current week (the week starts on Monday).

%MILLISECONDOFTHEDAY% The number of milliseconds between the current date & time and the beginning (midnight) on the same day.

%MILLISECONDOFTHEHOUR% The number of milliseconds between the current time and the start of the same hour on the same day.

%MILLISECONDOFTHEMINUTE% The number of milliseconds between the current time and the start of the same minute on the same day.

Drives, Files, and Folders

The following variables are related to drives, files, and folders:

%THISDRIVE% The drive that SyncBackSE is running on, e. g. C:

%THISPATH% The path that SyncBackSE is running from, e.g. C:\Program Files\2BrightSparks\SyncBackSE

%THISPROGRAM% The path and filename of the SyncBackSE program itself.

%SYNCBACKFOLDER% The default folder that SyncBackSE stores it’s profiles in, e.g. C:\Documents and Settings\[username]\Local Settings\Application Data\2BrightSparks\SyncBack\ (for Vista it's %LOCALAPPDATA%\SyncBack\). Note that this is not necessarily where the profiles are stored (you may have configured it to store them in %THISPATH%, for examples)

%SYNCBACKBACKUPFOLDER% The default folder that SyncBackSE stores it’s profile backup files in, e.g. C:\Documents and Settings\[username]\Local Settings\Application Data\2BrightSparks\SyncBack\ProfileBackup\ (for Vista it's %LOCALAPPDATA%\SyncBack\ProfileBackup\). Note that this is not necessarily where the backups are stored.

There are six special variables than can be used to identify drives based on their label or serial number. These are very useful when using external USB drives, for example, which may have a different drive letter each time they are plugged-in:

%LABEL=?% The entry is replaced by the drive with that label. For example, if your C drive is labelled My Disk then %LABEL=My Disk%Documents would be translated into C:\Documents. Note that you can only use one label per string but can use it multiple times. Also, the drives A and B are ignored (use LABELALL to include drives A and B, see below).

%LABELALL=?% This is the same as the LABEL variable except it also includes the drives A and B, which are typically floppy disk drives. When the floppy drive is accessed to get the label of the disk in it may become irritating, which is why you should use LABEL unless you need the label of a disk in drive A or B.

%SERIAL=?% The entry is replaced by the drive with that serial number. For example, if your D drive has a serial number of BC46-F69E then %SERIAL=BC46-F69E%Program Files will be translated at runtime into D:\Program Files. Note that you can only use one serial per string but can use it multiple times. Also, the drives A and B are ignored (use SERIALALL to include drives A and B, see below).

%SERIALALL=?% This is the same as the SERIAL variable except it also includes the drives A and B, which are typically floppy disk drives. When the floppy drive is accessed to get the serial number of the disk in it may become irritating, which is why you should use SERIAL unless you need the label of a disk in drive A or B.

%DISKLABEL% The label of the disk in the drive.

%DISKSERIAL% The unique serial number of the disk in the drive.

%CSIDL_DESKTOP% The virtual folder representing the Windows desktop, the root of the namespace.

%CSIDL_PROGRAMS% The file system directory that contains the user's program groups (which are themselves file system directories). A typical path is C:\Documents and Settings\[username]\Start Menu\Programs.

%CSIDL_PERSONAL% The virtual folder representing the My Documents desktop item. A typical path is C:\Documents and Settings\[username]\My Documents\

%CSIDL_FAVORITES% The file system directory that serves as a common repository for the user's favorite items. A typical path is C:\Documents and Settings\[username]\Favorites.

%CSIDL_STARTUP% The file system directory that corresponds to the user's Startup program group. The system starts these programs whenever any user logs onto Windows. A typical path is C:\Documents and Settings\[username]\Start Menu\Programs\Startup.

%CSIDL_RECENT% The file system directory that contains shortcuts to the user's most recently used documents. A typical path is C:\Documents and Settings\[username]\My Recent Documents.

%CSIDL_SENDTO% The file system directory that contains Send To menu items. A typical path is C:\Documents and Settings\[username]\SendTo.

%CSIDL_STARTMENU% The file system directory containing Start menu items. A typical path is C:\Documents and Settings\[username]\Start Menu.

%CSIDL_DESKTOPDIRECTORY% The file system directory used to physically store file objects on the desktop (not to be confused with the desktop folder itself). A typical path is C:\Documents and Settings\[username]\Desktop.

%CSIDL_NETHOOD% A file system directory containing the link objects that may exist in the My Network Places virtual folder. A typical path is C:\Documents and Settings\[username]\NetHood.

%CSIDL_FONTS% A virtual folder containing fonts. A typical path is C:\Windows\Fonts.

%CSIDL_TEMPLATES% The file system directory that serves as a common repository for document templates. A typical path is C:\Documents and Settings\[username]\Templates.

%CSIDL_COMMON_STARTMENU% The file system directory that contains the programs and folders that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu.

%CSIDL_COMMON_PROGRAMS% The file system directory that contains the directories for the common program groups that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs.

%CSIDL_COMMON_STARTUP% The file system directory that contains the programs that appear in the Startup folder for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs\Startup.

%CSIDL_COMMON_DESKTOPDIRECTORY% The file system directory that contains files and folders that appear on the desktop for all users. A typical path is C:\Documents and Settings\All Users\Desktop. Valid only for Windows NT systems.

%CSIDL_APPDATA% The file system directory containing application data for all users. A typical path is C:\Documents and Settings\All Users\Application Data.

%CSIDL_PRINTHOOD% The file system directory that contains the link objects that can exist in the Printers virtual folder. A typical path is C:\Documents and Settings\[username]\PrintHood.

%CSIDL_LOCAL_APPDATA% The file system directory that serves as a data repository for local (non-roaming) applications. A typical path is C:\Documents and Settings\[username]\Local Settings\Application Data.

%CSIDL_ALTSTARTUP% The file system directory that corresponds to the user's non-localized Startup program group. This is usually an empty value.

%CSIDL_COMMON_ALTSTARTUP% The file system directory that corresponds to the non-localized Startup program group for all users. This is usually an empty value.

%CSIDL_COMMON_FAVORITES% The file system directory that serves as a common repository for favorite items common to all users.

%CSIDL_INTERNET_CACHE% The file system directory that serves as a common repository for temporary Internet files. A typical path is C:\Documents and Settings\[username]\Local Settings\Temporary Internet Files.

%CSIDL_COOKIES% The file system directory that serves as a common repository for Internet cookies. A typical path is C:\Documents and Settings\[username]\Cookies.

%CSIDL_HISTORY% The file system directory that serves as a common repository for Internet history items.

%CSIDL_PROFILE% The user's profile folder. A typical path is C:\Documents and Settings\[username]

%CSIDL_COMMON_MUSIC% The file system directory that serves as a repository for music files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Music

%CSIDL_COMMON_PICTURES% The file system directory that serves as a repository for image files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Pictures

%CSIDL_COMMON_VIDEO% The file system directory that serves as a repository for video files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Videos

%CSIDL_CDBURN_AREA% The file system directory acting as a staging area for files waiting to be written to CD. A typical path is C:\Documents and Settings\username\Local Settings\Application Data\Microsoft\CD Burning

%CSIDL_WINDOWS% The Windows directory. This corresponds to the %windir% or %SYSTEMROOT% environment variables. A typical path is C:\Windows

%CSIDL_PROGRAM_FILES% The Program Files folder. A typical path is C:\Program Files

%CSIDL_PROGRAM_FILES_COMMON% A folder for components that are shared across applications. A typical path is C:\Program Files\Common

%CSIDL_COMMON_APPDATA% The file system directory containing application data for all users. A typical path is C:\Documents and Settings\All Users\Application Data

%CSIDL_2BS_APPDATA% This is the same as %SYNCBACKFOLDER%

%CSIDL_2BS_APPDATA_PROFILESBACKUP% This is the same as %SYNCBACKBACKUPFOLDER%

Misc.

%SBVERSION% The complete version number of the SyncBackSE program itself, e.g. 4.0.8.0

%PROFILENAME% The profile name. This can be used in the source/left and/or destination/right path.

%GROUPNAME% The group name. This can be used in the source/left and/or destination/right path. If the profile is not being run as part of a group then the value returned is an empty string. See also %VISUALGROUPNAME%

Backup to email

Some variables can be used in the subject and email body when performing a backup to an email server (Pro version only).

%FILENAME% The filename of the file being backed up

%UPLOADDATETIME% The date & time the file was sent to the email server

%UPLOADDATETIME_GMT% As per %UPLOADDATETIME% except the GMT/UTC date & time is used

%MODIFIEDDATETIME% The last modification date & time of the file sent to the email server

%MODIFIEDDATETIME_GMT% As per %MODIFIEDDATETIME% except the GMT/UTC date & time is used

%CREATEDDATETIME% The creation date & time of the file sent to the email server

%CREATEDDATETIME_GMT% As per %CREATEDDATETIME% except the GMT/UTC date & time is used

%FILEATTRIBS% The attributes of the file sent to the email server

%FILESIZE% The size of the file (in bytes) sent to the email server

%FILEHASH% The hash value of the file sent to the email server

%ISCATALOG% Y if this is a catalog email, else N. A catalog email is an email that contains details on the files that are on the email server.

Emailing the log and late setting variables

There are a number of special variables that cannot be used in the source or destination settings, for example, because their value is not set until the profile is run (or at some later stage during the profile run). Some variables values are not set until near the end of a profile run. Because of this they can only be used correct in certain settings, e.g. the email body.

%LOGFILENAME% Filename of first page of latest log file. This is not set until the log file is closed, so it can only be used in Run After when the profile has been configured to run the 'after' program after the log file has been closed.

%SNAPSOURCE% If a shadow volume is being used to copy locked files from the source/left then this is the path of that shadow volume.

%SNAPDEST% If a shadow volume is being used to copy locked files from the destination/right then this is the path of that shadow volume.

%VISUALGROUPNAME% If the profile is part of a group, and it is run on its own from the main user interface (not necessarily as part of the group), then this is the name of the group. It is different from %GROUPNAME% because that value is only set if it is run as part of a group.

%ISFULLBACKUP% If this is a full-backup, i.e. a rescan is being done of the destination, then this is Y, else N

%ISRESTORE% If this is a restore then Y is returned, else N

%ISSIMULATION% If this is a simulated run then Y is returned, else N

%PROFILEFAILED% If the profile run was a success then 0 is returned, else 1 is returned on error/abort (this is the same variable that can be used in Run After).

%ATTACHMENTSTOTAL% The total number of attachments for the email.

%CRITICALERROR% If there was a critical error then this is the error message, otherwise it is an empty string.

%DELETEDTOTAL% The total number of files that were deleted.

%SKIPPEDTOTAL% The total number of files that were skipped, e.g. only in the destination and the profile was configured to ignore files that are only in the destination.

%COPIEDTOTAL% The total number of files that were copied.

%MOVEDTOTAL% The total number of files that were moved.

%DATECHANGEDTOTAL% The total number of files whose last modification date & time were copied.

%ATTRIBCHANGEDTOTAL% The total number of files whose attributes were copied.

%RUNBEFOREERROR% If the Run Before program failed (e.g. because it doesn't exist, or couldn't be started) then this is the error message.

%RUNAFTERERROR% If the Run After program failed (e.g. because it doesn't exist, or couldn't be started) then this is the error message.

%COPYERRORSTOTAL% The total number of file copy/delete errors.

%COMPRESSERRORSTOTAL% The total number of errors related to compression.

%NONCRITICALERRORS% The non-critical errors (this can be several lines).

%NONCRITICALERRORSTOTAL% The total number of non-critical errors.

%STARTTIME% The date & time the profile was run.

%ENDTIME% The date & time the profile completed.

%STARTSCANTIME% The date & time the scan for changes started.

%ENDSCANTIME% The date & time the scan for changed ended.

%BYTESCOPIED% The total number of bytes that were copied.

%BYTESDELETED% The total number of bytes that were deleted.

%BYTESREPLACED% The total number of bytes that were replaced/overwritten.

%COMPARECHANGEDTOTAL% The total number of files that have changed.

%COMPAREHASHCHANGEDTOTAL% The total number of files which have different hash values.

%COMPAREDESTONLYTOTAL% The total number of files in the destination only.

%COMPARESOURCEONLYTOTAL% The total number of files in the source only.

%COMPAREDATETIMETOTAL% The total number of files whose last modification date & time is different.

%COMPARESIZETOTAL% The total number of files whose size is different.

%COMPAREATTRIBTOTAL% The total number of files whose attributes are different.

%COMPAREHASHERRORTOTAL% The total number of files whose hash value could not be calculated to compare them.

%TOSKIPCNT% The number of files that are going to be skipped.

%TOPROMPTCNT% The number of files where the user will be prompted on the action to take.

%TODELETESRCCNT% The number of files that are to be deleted from the source/left.

%TODELETEDESTCNT% The number of files that are to be deleted from the destination/right.

%TOCOPYTODESTCNT% The number of files to be copied to the destination/right.

%TOCOPYTOSRCCNT% The number of files to be copied to the source/left.

%TOMOVETODESTCNT% The number of files to be moved to the destination/right.

%TOMOVETOSRCCNT% The number of files to be moved to the source/left.

%TOCHANGESRCATTRIBSCNT% The number of files in the source/left that will have their attributes/date & time changed.

%TOCHANGEDESTATTRIBSCNT% The number of files in the destination/right that will have their attributes/date & time changed.

%TORENAMESRCCNT% The number of files in the source/left that will be renamed.

%TORENAMEDESTCNT% The number of files in the destination/right that will be renamed.

%BYTESCOPYTOSRC% The total number of bytes to be copied (includes moved files) to the source/left.

%BYTESCOPYTODEST% The total number of bytes to be copied (includes moved files) to the destination/right.

%BYTESDELETEFROMSRC% The total number of bytes to be deleted (includes moved files) from the source/left.

%BYTESDELETEFROMDEST% The total number of bytes to be deleted (includes moved files) from the destination/right.

%PAGE% Used only in log filename.

%COMPAREDIRSCHANGEDTOTAL% The number of directories that have been changed.

%COMPAREDIRSDESTONLYTOTAL% The number of directories that are only in the destination.

%COMPAREDIRSSOURCEONLYTOTAL% The number of directories that are only in the source.

%FTPCONNECTCNT% The number of (re)connections made to the FTP server

%VERSIONSRESTOREDTOTAL% The total number of versions restored

%COMPAREUNCHANGEDTOTAL% The total number of unchanged files

%TORESTOREVERSRCCNT% The total number of files to be restored on the source/left

%TORESTOREVERDESTCNT% The total number of files to be restored on the destination/right

%FREEBYTESSOURCEBEFORE% The number of free bytes on the source/left before the profile started copying, moving, and deleting files

%FREEBYTESDESTBEFORE% The number of free bytes on the destination/right before the profile started copying, moving, and deleting files

Registry

As well as variables, you can also get values from the registry. For example, the following will retrieve the current version of Firefox that is installed:

%@HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Mozilla Firefox\CurrentVersion%

To get values from the registry you must use %@ followed by one of the following (these define which part of the registry to read):

HKEY_CLASSES_ROOT

HKEY_CURRENT_USER

HKEY_LOCAL_MACHINE

HKEY_USERS

HKEY_PERFORMANCE_DATA

HKEY_CURRENT_CONFIG

HKEY_DYN_DATA

Then specify the path in the registry, e.g. \SOFTWARE\Mozilla\Mozilla Firefox\CurrentVersion, and finally finish with %

If there is no such value in the registry then the variable is not expanded.

U3

There are some variables that can only be used with the U3 version of SyncBackSE.

Important note about Variable usage

An important point to remember is that Windows has it's own environment variables, e.g. %USERNAME%. When these variables are used in a batch file, or on the command line, then Windows automatically expands them. Unknown variables are simply deleted. For example, if you had the following batch file:

@echo off

"c:\program files\2brightsparks\SyncBackSE\SyncBackSE.exe" -source "x:\%DAY%\"

Then when run it would actually be expanded to do the following:

@echo off

"c:\program files\2brightsparks\SyncBackSE\SyncBackSE.exe" -source "x:\\"

Note that the %DAY% has been removed because it's an unknown Windows variable (it's a SyncBackSE variable). To stop Windows from changing SyncBackSE variables you must use two percentage signs, e.g.

@echo off

"c:\program files\2brightsparks\SyncBackSE\SyncBackSE.exe" -source "x:\%%DAY%%\"


Progress Bar

Progress Bar

The progress bar appears when a task is running and provides visual feedback of the progress of that task to the user:


Expression Filters

Expression Filters in SyncBackSE

This section of the help file provides information and guidance about expression filters.

Regular Expressions

Regular expressions are a system for matching patterns in text data. They provide a powerful set of tools for finding particular words or combinations of characters in strings.

Matching simple expressions

Most characters match themselves. The only exceptions are called special characters:

Description | Symbol | Meaning
asterisk | * | match zero or more times
plus sign | + | match one or more times
question mark | ? | match zero or one time
backslash | \ | escape the following character
period | . | match any one character
caret | ^ | negate a match in [ ], or start of line
square brackets | [ and ] | character class
parentheses | ( and ) | grouping
dollar sign | $ | end of line
ampersand | & | and
or sign | | | or

To match a special character, precede it with a backslash, like this \*. For example,

This expression... | matches this... | but not this...
a | a | b
\.\* | .* | dog
100 | 100 | ABCDEFG

Matching any character

A period (.) matches any character except a newline character.

This expression... | matches this... | but not this...
.art | dart | art
 | cart | hurt
 | tart | dark

Matching certain types of characters

Some character types can be matched by a shorthand notation:

This expression... | matches this...
\d | digits (0-9)
\D | non-digits
\w | "word" characters (alphanumeric and underscore)
\W | non-word characters
\s | whitespace characters (space, tab)
\S | non-whitespace characters

Repeating expressions

You can repeat expressions with an asterisk or plus sign.

A regular expression followed by an asterisk (*) matches zero or more occurrences of the regular expression. If there is any choice, the first matching string in a line is used.

A regular expression followed by a plus sign (+) matches one or more occurrences of the one-character regular expression. If there is any choice, the first matching string in a line is used.

A regular expression followed by a question mark (?) matches zero or one occurrence of the one-character regular expression.

For example:

This expression... | matches this... | but not this...
a+b | ab | b
 | aaab | baa
a*b | b | daa
 | ab | aaab
.*cat | cat | dog
 | 9393cat |
 | the old cat |
 | c7sb@#puiercat |
a[n]? h | a herb | ann hat
 | an herb |

So to match any series of zero or more characters, use ".*". On its own this isn't much use, but in the middle of a longer regular expression, it can be.

Grouping expressions

If an expression is enclosed in parentheses (( and )), the editor treats it as one expression and applies any asterisk (*) or plus (+) to the whole expression.

For example

This expression... | matches this... | but not this...
(ab)*c | abc | ababab
 | ababababc | ababd
(.a)+b | xab | b
 | ra5afab | aagb

Choosing one character from many

A string of characters enclosed in square brackets ([ ]) matches any one character in that string. If the first character in the brackets is a caret (^), it matches any character except those in the string. For example, [abc] matches a, b, or c, but not x, y, or z. However, [^abc] matches x, y, or z, but not a, b, or c.

A minus sign (-) within square brackets indicates a range of consecutive ASCII characters. For example, [0-9] is the same as [0123456789]. The minus sign loses its special meaning if it's the first (after an initial ^, if any) or last character in the string.

If a right square bracket is immediately after a left square bracket, it does not terminate the string but is considered to be one of the characters to match. If any special character, such as backslash (\), asterisk (*), or plus sign (+), is immediately after the left square bracket, it doesn't have its special meaning and is considered to be one of the characters to match.

This expression... | matches this... | but not this...
[aeiou] [0-9] | a6 | ex
 | i3 | 9a
 | u2 | $6
[^cfl]og | dog | cog
 | bog | fog
END[.] | END. | END;
 |  | ENDDO
 |  | ENDIAN

Matching the beginning or end of a line

You can specify that a regular expression match only the beginning or end of the line. These are called anchor characters:

If a caret (^) is at the beginning of the entire regular expression, it matches the beginning of a line.

If a dollar sign ($) is at the end of the entire regular expression, it matches the end of a line.

If an entire regular expression is enclosed by a caret and dollar sign (^like this$), it matches an entire line.

This expression... | matches this... | but not this...
^(the cat).+ | the cat runs | see the cat run
.+(the cat)$ | watch the cat | the cat eats

So, to match all strings containing just one characters, use "^.$".


Uninstalling SyncBackSE

How to Uninstall SyncBackSE

If you used the default installation procedure for SyncBackSE you may uninstall the program by going to Windows Start > All Programs > 2BrightSparks > SyncBackSE > Uninstall SyncBackSE.

The exception to this is if you installed the program in a custom location, in which case you will have to find out where SyncBackSE is located. You can easily find this using the Windows search facility.

Please be aware that uninstalling SyncBackSE will delete your profiles.

All versions of SyncBackSE can safely be installed over an existing installation. By doing this, you will ensure any profiles you have created continue to be active.

Lastly, make sure that SyncBackSE is not running while you attempt to uninstall. Remember that SyncBackSE can be seen in the task bar on the lower right when active (you may need to click the little left pointing arrow to see the SyncBackSE icon). You may have also created a scheduled task which you will need to disable if uninstalling.


U3 Enabled Version

U3 Enabled Smart Drives

Although SyncBackSE can run independently on any thumb drive, you can also use a special version of SyncBackSE which is "U3 enabled". This means that if you have purchased a drive with the U3 Launcher, SyncBackSE will work in that environment too.

U3 smart applications such as SyncBackSE run on all U3 compliant devices including dozens of the largest USB flash drive manufacturers like SanDisk, Memorex, Kingston and Verbatim.

U3 Enabled SyncBackSE Download

The U3 installation file for SyncBackSE can be downloaded here:

http://www.2brightsparks.com/assets/software/SyncBackSE.u3p

note

Note that the file name SyncBackSE.u3p will be automatically changed to SyncBackSE.zip when using Microsoft Internet Explorer to download. When using IE, download the file, then rename to SyncBackSE.u3p after the download completes. The Firefox Internet browser does not rename the file in this way.

Changes and Restrictions

U3 enabling devices results in changes and restrictions as compared to the general release version of SyncBackSE. This is as a result of the specific compliance protocols of U3 enabled applications.

note

Note the following changes and restrictions when running SyncBackSE from a U3 device:

· It is in English only.

· There is no update check as checks for new versions of the software are handled by the U3 Launcher

· If multiple U3 devices are connected you can run SyncBackSE from each U3 device and from the computer itself.

· The "Minimize on close" option cannot be used as the U3 Launcher sends a window close message to all programs run from the U3 device when it is ejected.

· Auto-backup of profiles on program close is not available.

· Profiles cannot be set to run on Windows startup/login or shutdown as the U3 device may not be available.

· Profiles exported from versions of SyncBackSE prior to V4.1 cannot be imported as they use the registry.

· Schedules are not imported.

· The U3 variables %U3_HOST_EXEC_PATH%, %U3_APP_DATA_PATH%, %U3_DEVICE_EXEC_PATH%, %U3_DEVICE_PATH%, %U3_DEVICE_DOCUMENT_PATH%, etc. can be used whenever variables can be used. For example, to backup to your U3 device set the destination to %U3_DEVICE_DOCUMENT_PATH%\Backup\


Scripting

Scripting

sbpro-feature-16x16 Scripting is a Pro only feature. This section of the help file provides information about scripting support. Scripting is a way in which the functionality of SyncBackSE can be changed or extended by writing small scripts. A script is a set of instructions and is similar to the macro support in Microsoft Office, and Java Script in web pages. It is also similar to plug-ins in other software, e.g. WinAmp. SyncBackSE can use scripts written in any scripting language (supported by the Windows Scripting Host) that is installed on the computer, but typically they are written in VBScript or JScript. We cannot provide a tutorial on how to write scripts, but the following web pages can get you started on learning VBScript:

VBScript Tutorial: http://www.w3schools.com/vbscript/default.asp

VBScript Introduction: http://www.devguru.com/technologies/VBScript/home.asp

VBScript Reference: http://www.pctools.com/guides/scripting/id/2/?act=reference

VBScript Language Reference: http://msdn.microsoft.com/en-us/library/d1wf56tt.aspx

Microsoft Scripting Center: http://www.microsoft.com/technet/scriptcenter/default.mspx

Scripting: http://msdn.microsoft.com/en-us/library/ms950396.aspx

Scripting Overview

When SyncBackSE performs certain actions it will check to see if there are any scripts installed that can be called when the action is performed. For example, whenever the profiles are listed it in the main window it checks to see if there are any main interface scripts installed. If so, it checks if those scripts can be called, and if so, calls the appropriate function in the script. In technical terms, these are events. You write functions in the scripts that perform actions when certain events occur. To make it easier for the scripts to communicate with SyncBackSE it also provides helper objects, e.g. SBSystem. Depending on the script type, one or more of those helper objects will be available to the script.

Installing Scripts

To start using a script with SyncBackSE you must first install it via Preferences -> Scripts in the main menu. Note that installing a script does not automatically make the script active. If it's a Main Interface or Profile Configuration script then you must install it then go to the relevant tab and tick the checkbox for that script. To use a Runtime script in a profile, after installing it you must select it in the Scripts page of the profiles configuration. If it's a Location script then you must create (or modify) a profile so it does a backup or sync with that script.

You can also install scripts via the command line interface by simply passing the filename of the script (the same way as importing profiles).

Exporting Scripts

To export a script, go to the Scripts window (via Preferences -> Scripts in the main menu), select the script (or scripts) you wish to export, then right-click on the selection and choose Export from the pop-up menu.

Script Order

The order in which the scripts are set to run is important. This is because, in some cases, only one script can perform an action. For example, if you have a runtime script that renames a file then obviously a file can only be renamed once. This means the first script to rename a file is the one that will rename it. Any following scripts cannot rename the file.

Script Types

There are four different types of scripts:

1. Main Interface scripts: these are scripts that can be used with the main user interface in SyncBackSE. For example, you could write a script that adds columns to the main window.
2. Profile Configuration scripts: these are scripts that be used when configuring a profile.
3. Location scripts: these are scripts that are used with profiles to store and retrieve files. For example, you could write a location script that copies files to and from a database.
4. Runtime scripts: these are scripts that are used by profiles when they are run. For example, you could write a profile to decides on which files to copy, or add columns to the Differences window.

A single script file can be more than one type of script. For example, you could write a script that is both a main interface and runtime script. SyncBackSE knows what type a script is because the script tells SyncBackSE via the Description function. It also knows what scripting language is being used based on comments in the header (first 10 lines) of a script, and failing that, the filename extension of the script file.

For example, the following VBScript is a profile configuration, runtime, and location script:

'

' Use SBLang to define what language this script is in:

'

' SBLang=VBScript

'

Function Description(ScriptType)

Description = "The description of this script!"

ScriptType = 7

End Function

Scripts Online

If you have scripts you wish to share, or want to download more scripts, visit the following web page:

http://www.2brightsparks.com/syncback/scripts/index.html


Base

These are functions that should be defined in all scripts regardless of their type. All scripts must implement the Description function, but the others are optional. The functions are called by SyncBackSE at the appropriate time.

Function Description(ByRef ScriptType)

ScriptType: Set this to the type of script

Return value: A short description of the script (this is shown to the user)

This function is mandatory. All scripts must declare this function.

Called to get a description of the script and what type of script it is. The

description is not stored and so can be dynamic, however this should not be

relied upon in future. The description is stripped of newline and carriage

return characters.

The script type is an integer that defines when the script should be used by

SyncBack. It is a bitmask (i.e. the values can be or'ed together) of the

following types:

0 = Not a valid script

1 = A script that can be used when configuring profiles (a 'configuration' script)

2 = A script that can be used by profiles at run-time (a 'run-time' script)

4 = A script that can be used by in the main user interface (a 'main' script)

8 = A script that can be used by profiles to store and retrieve files (a 'location' script)

A single script file can be used in more than one place. For example, if a

script was both a location and a run-time script then its ScriptType value

would be 10 (which is 2 + 8). The script type is stored by SyncBack when the

script is installed.

Function Description(ByRef ScriptType)

Description = "A short description of what this script does"

ScriptType = 10

End Function

Function FilesToExport(Interactive, Counter)

Interactive: Passed as True if the script can prompt the user

Counter: This is initially passed as 0 (zero) and incremented on each call

Return value: The complete filename of a file to be exported along with the script

Called when a script is being exported as part of a profile. This function is

called repeatedly until an empty string is returned. For the first call the

Counter value is zero, and is incremented on each call.

The script should return the filenames (one per call) of files that SyncBack

should include into the exported profile (the .SPS file). The filenames must be

complete filenames including the drive and path. Note that when the script is

imported, the files (and the script) will all be put into their own unique

folder and then the Install function will be called (the script can then move

those files, if required, and do any other installation tasks, e.g. register

COM objects).

Do not include the filename of the script itself as that is included

automatically. This function does not need to be defined if the script has no

accompanying files.

If Interactive is True then the script can prompt for user input, otherwise

it must not ask for user input (e.g. dialogs boxes should not be displayed).

Function FilesToExport(Interactive, Counter)

If Counter = 0 Then

FilesToExport = "C:\abc\def\ghi.txt"

ElseIf Counter = 1 Then

FilesToExport = "D:\another\folder\file.exe"

Else

FilesToExport = ""

End If

End Function

Function Install(Interactive)

Interactive: Passed as True if the script can prompt the user

Return value: An error message on failure

Called when the script is installed into SyncBack. On failure it should return

an error message, in which case the script will not be installed.

This function is called when a script is installed, either by the user via the

Script window, or via the import of a profile that uses scripts. It can be used,

for example, to move files used by the script to their correct places or to

register COM objects. Note that if a script is already installed then Install

is not called.

You should not prompt the user, or expect user input, if Interactive is passed

as FALSE.

Function Install(Interactive)

If Interactive Then

SBSystem.Say "Installed"

End If

End Function

Sub Uninstall()

This function is called when the script is uninstalled from SyncBack. It should

assume no user is present, i.e. it should not prompt the user for input.

Sub Uninstall()

SBSystem.Say "Uninstalled"

End Sub


Main Interface Scripts

These are functions that are defined in your Main Interface script and are called by SyncBackSE. A main interface script can enhance or change the main user interface. For example, you can add columns to show extra information about profiles, or perform some action when a key is pressed. The functions are called by SyncBackSE at the appropriate time. Main Interface scripts have access to the SBSystem and SBVariables objects.

Function MainColumnHint(Col, IsGroup, ProfileName)

Col: The column number

IsGroup: True if the profile is a group

ProfileName: The name of the profile

Return value: The hint string to display

This subroutine is called from the main window when a custom column hint

is required. The first custom column is column zero (0). The script is only

called for its custom columns and not for columns created by other scripts.

Function MainColumnsCount()

Return value: The number of custom columns, or zero if none are required

This function is called from the main window to ask the script how many

custom columns it wants created in the main window. Note that this value

is cached so the function is only called once (when the main window

appears, i.e. when the program is run).

Function MainColumnSort(Col, IsGroup1, IsGroup2, ProfileName1, ProfileName2)

Col: The column the display is being sorted on

IsGroup1: True if ProfileName1 is a group

IsGroup2: True if ProfileName2 is a group

ProfileName1: The name of a profile

ProfileName2: The name of a profile

Return value: An integer (<0 if profile 1 should go before profile 2, 0=same profile, > 0 if profile 1 should go after profile 2)

This function is called from the main window when a custom column is

being sorted. The first custom column is column zero. The script is only called

for its custom columns and not for columns created by other scripts.

Function MainColumnText(Col, IsGroup, ProfileName)

Col: The column number

IsGroup: True if ProfileName refers to a group profile

ProfileName: The name of the profile

Return value: The text to display in the column

This function is called from the main window when text for a custom

column is required. The first custom column is column zero (0). The script is

only called for its custom columns and not for columns created by other scripts.

Function MainColumnTitle(Col, ByRef Width)

Col: The column number

Width: Set it to the width the column should be (in pixels)

Return value: The columns title

This function is called from the main window when the title for a

custom column is required. The first custom column is column zero (0). The

script is only called for its custom columns and not for columns created by

other scripts.

Function NewVersionCheck(ByRef ErrMsg)

If: a check cannot be made then set an error message, else set to an empty string

Return value: If a new version is available then return the URL to open the web browser with, else return empty string

This function is called when SyncBack checks to see if a new version of SyncBack

is available. The function should not prompt the user as update checks are

usually made in the background. Also take into account that it may be

unattended.

- If any script returns an error message then the update check is aborted.

- If any script returns a URL then the update check is aborted and the user is

told a new version is available.

- If a script returns the URL string "*" then the update check is aborted and

the user is told there is no new version.

- If all the scripts return an empty string URL, and no error messages, then

SyncBack will check the 2BrightSparks web site to see if there is a new verison

available.

Sub MainColumnClicked(Col, IsGroup, ProfileName)

Col: The column number

IsFile: True if it is a group profile

ProfileName: The name of the profile

This subroutine is called from the main window when a custom column is

clicked. The first custom column is column zero (0). The script is only called

for its custom columns and not for columns created by other scripts.

Sub MainEnded()

This subroutine is called when SyncBack stops. The script should not prompt the

user or expect any user interaction. It should also not try to stop the program

from exiting.

Sub MainFocusChanged(IsGroup, ProfileName)

IsGroup: True if ProfileName refers to a group

ProfileName: The name of the profile

This subroutine is called from the main window when the focused node

changes.

Sub MainKeyPress(Key, Shift, IsGroup, ProfileName)

Key: The key that as pressed

Shift: The shift state

IsGroup: True if ProfileName refers to a group profile

ProfileName: The name of the profile

This subroutine is called from the main window when a key is pressed. It

is called for each selected row. It is not called if the Delete key is pressed

(as that is handled by SyncBack itself).

The Key value refers to the virtual key codes.

The Shift state can be a selection values (see RunDiffKeyPress for details)

Sub MainStarted(Unattended)

Unattended: If True then do not prompt the user or expect any user interaction

This subroutine is called when SyncBack starts.

Sub RefreshDisplay()

This subroutine is called when SyncBack refreshes or updates the main display.


Profile Configuration Scripts

These are functions that are defined in your Profile Configuration script and are called by SyncBackSE. The functions are called by SyncBackSE at the appropriate time. The functions available will be expanded in later versions of SyncBackSE. Profile Configuration scripts have access to the SBSystem and SBVariables objects.

Property Group

Returns the TRUE if this is a group profile.

This property is read-only.

Property Name

Returns the name of the profile.

This property is read-only.

Property UsesScript

Returns the TRUE if this profile is using this script. For example, you may

have a script that is both a configuration and run-time script. Although the

script may be enabled as a configuration script, the profile that is currently

being edited may not be using the profile as a run-time script.

This property is read-only.

Sub InitialiseVars()

Checking: Passed as True if the variables are being checked to see if they exist

This subroutine is called when the variables are initialised when a profile is

being created or modified. Checking is passed as TRUE.

Note that if your script is also a run-time script then this sub-routine is

shared. A configuration script does not have access to the SBRunning object.

In the example below the variable MyScriptVar is set to a dummy value if it's

a call to check if the variable is valid.

'

' Called very early when a profile is run (Checking is False)

' Also called in profile config when asking what variables the script sets (Checking is True)

'

Sub InitialiseVars(Checking)

If Checking Then

' Profile is being saved

SBVariables.SetVar "MyScriptVar", "?"

Else

' Profile is being run

' Do nothing

End If

End Sub


Location Scripts

These are functions that are defined in your Location script and are called by SyncBackSE. A location script is one that controls how files and folders are stored. For example, you could create a location script to backup to a 7zip archive file, or to a database, for example. The functions are called by SyncBackSE at the appropriate time. For a profile to use a location script you must configure the profile to use it. Location scripts have access to the SBLocation and SBSystem objects.

Function LocAbilities()

Return value: The abilities of the script

This function is called so SyncBack knows what abilities (functions) the

location script supports. Note that the value is cached, so the first value

returned is used through-out the entire profile run.

The script can optionally support a number of features (the values can be

OR'ed together, e.g. CAN_USEATTRIBUTES + CAN_NTFSATTRIBUTES:

For example:

Function LocAbilities()

' Cannot use CAN_EXACTDATETIME because some drives may be FAT32

' Cannot use CAN_NTFSATTRIBUTES because some drives may be FAT32

LocAbilities = 32 + 128 + 256 + 4096 + 131072

End Function

Function LocConnect(MainThread)

MainThread: Passed as True if it is being called from a user interface

Return value: An error message if the script cannot be connect, otherwise an empty string

This function is called to tell the script to connect to the storage location.

There are two different ways in which this function is called: from the profile

thread, or from the main thread (which is the user interface, e.g. the

Differences window or the File Prompt window). When a profile is run then an

instance of the script is created, and that instance is used while the profile

is running. However, when there is user interaction (e.g. from the Differences

window) then a new script instance is created. This means the state is different

between the scripts, i.e. they have different global variables.

Return an error message if the script cannot connect to the storage location,

e.g. the network is down.

Function LocConnected()

Return value: An error message if the script is not connected, otherwise an empty string

This function is called to tell ask the script if it is connected to its

storage location. If it is connected (or doesn't need to connect to anything)

then return an empty string, otherwise return an error message.

See also LocReconnect and LocConnect

Function LocCRC32(Filename, ByRef CRC32)

Filename: The complete path of the file to get the hash value of

CRC32: Set this to the CRC32 hash value of the file, in string format

Return value: An error message if the CRC32 cannot be retrieved, otherwise an empty string

This function is called when the CRC32 hash value of a file is required, e.g.

for verification. The entire filename is passed, including the base path. If the

CRC32 hash value cannot be retrieved then an error message should be returned.

Note that the CRC32 hash value should be returned in string format,

e.g. E75A6A52

For example:

Function LocCRC32(FullPath, CRC32)

CRC32 = ""

LocCRC32 = "CRC32 not supported"

End Function

Function LocDeleteFile(Filename, ByRef DoesNotExist)

Filename: The complete path of the file to delete

DoesNotExist: Set to True if the file does not exist, otherwise set to False

Return value: An error message if the file exists and cannot be deleted, otherwise an empty string

This function is called when the script must delete a file. The entire filename

is passed, including the base path. If the file cannot be deleted then an error

message should be returned. If the file does not exist then set DoesNotExist to

True, but do not return an error message.

For example:

Function LocDeleteFile(FullPath, DoesNotExist)

LocDeleteFile = ""

DoesNotExist = Not FSO.FileExists(FullPath)

If Not DoesNotExist Then

FSO.DeleteFile FullPath, True

End If

End Function

Function LocDirExists(FullPath)

FullPath: The complete directory path including the base path

Return value: An empty string if the directory exists, otherwise an error message

This function is called when the script must check if a directory (folder)

exists. The entire directory path will be passed, including the base path. If

the directory exists then an empty string should be returned, otherwise return

an error message.

For example:

Function LocDirExists(FullPath)

If FullPath = "" Then

LocDirExists = ""

ElseIf FSO.FolderExists(FullPath) Then

LocDirExists = ""

Else

LocDirExists = "Folder does not exist"

End If

End Function

See also LocFileExists

Function LocDisconnect()

Return value: An error message if the disconnect failed

This function is called when the location should disconnect from its storage,

e.g. when the profile has finished or the user has aborted. If the script does

not need to disconnect, or it disconnects without any problem, then it should

return an empty string.

For example:

Function LocDisconnect()

LocDisconnect = ""

Set Drives = nothing

Set FSO = nothing

if Not (DebugLog is nothing) then

DebugOut "---Disconnected: " & CStr(Now)

DebugLog.WriteBlankLines(1)

DebugLog.Close

Set DebugLog = nothing

End If

End Function

See also LocConnect

Function LocFileExists(FullFilename)

FullFilename: The complete filename including the base path

Return value: An empty string if the file exists, otherwise an error message

This function is called when the script must check if a file exists. The entire

filename will be passed, including the base path. If the file exists then an

empty string should be returned, otherwise return an error message.

For example:

Function LocFileExists(FullPath)

If FullPath = "" then

LocFileExists = "File does not exist"

ElseIf FSO.FileExists(FullPath) Then

LocFileExists = ""

Else

LocFileExists = "File does not exist"

End If

End Function

See also DirExists

Function LocFreeSpace()

Return value: The free space in bytes, else -1

This function is called when the location should return how much free space

(in bytes) the storage location has. If it's not relevant or practical then

return -1. Take note of the 32-bit integer limit in VBScript, so return the

value as a string, e.g. LocFreeSpace = CStr(CCur(3221225472))

Function LocGet(fromFName, toFName)

fromFName: The complete filename of the file to retrieve from the scripts storage location

toFName: Where script should store the file on the local filesystem

Return value: If the file cannot be retrieved and stored then return an error message

This function is called when SyncBack needs the location to retrieve one if

its files and store it on the filesystem.

For example:

Function LocGet(fromFName, toFName)

If Not FSO.FileExists(fromFName) Then

LocGet = "File does not exist"

Else

' Read-only?

If FSO.FileExists(toFName) Then

Set FileObj = FSO.GetFile(toFName)

Attrs = FileObj.Attributes

If Attrs And 1 Then

FileObj.Attributes = Attrs - 1

End If

Set FileObj = nothing

End If

FSO.CopyFile fromFName, toFName, True

LocGet = ""

End If

End Function

Function LocGetAttributes(Filename, ByRef Attributes)

Filename: The complete path of the file or directory

Attributes: The filesystem attributes of the file or directory

Return value: An error message if the attributes cannot be retrieved, otherwise an empty string

This function is called when the filesystem attributes for a file or directory

need to be retrieved. The entire path of the file or directory to get the

attributes of is passed. Note that if it's a directory then it will have a

trailing backslash. If the attributes cannot be retrieved then an error message

should be returned.

For example:

Function LocGetAttributes(Filename, Attrs)

If Filename = "" Then

' Its a special folder

LocGetAttributes = ""

Attrs = 1 + 2 + 4 + 16

Exit Function

End If

If SBSystem.IsFolder(Filename) Then

'

' A folder

'

If not FSO.FolderExists(Filename) Then

LocGetAttributes = "Folder does not exist"

Exit Function

End If

Set FolderObj = FSO.GetFolder(Filename)

Attrs = FolderObj.Attributes

LocGetAttributes = ""

Else

'

' A file

'

If not FSO.FileExists(Filename) Then

LocGetAttributes = "File does not exist"

Exit Function

End If

Set FileObj = FSO.GetFile(Filename)

Attrs = FileObj.Attributes

LocGetAttributes = ""

End If

End Function

Function LocMakeDir(FullPath)

FullPath: The complete path of the directory to create

Return value: An error message if the directory cannot be created, otherwise an empty string

This function is called when the location should create a directory. The entire

path of the directory to create is passed. If the directory cannot be created

then an error message should be returned.

Note that an empty string should be returned if the directory already exists. Do

not return an error message.

For example:

Function LocMakeDir(FullPath)

LocMakeDir = ""

If FullPath = "" Then

Exit Function

ElseIf Not FSO.FolderExists(FullPath) Then

FSO.CreateFolder(FullPath)

End If

End Function

Function LocPut(fromFName, toFName, fromAttrs, fromDateTime, fromFileSize, DoSafeCopy, ByRef SafeFName)

fromFName: The complete filename of the file to retrieve from the local filesystem

toFName: Where script should store the file in its storage location

fromAttrs: The filesystem attributes of the file (ignore if < 0)

fromDateTime: The last modification date & time of the file (local timezone) (ignore if &lt;=1.0)

fromFileSize: The size of the file (in bytes). Note this is a string to avoid the 32-bit integer limit in VBScript. (ignore if < 0)

DoSafeCopy: Passed as True if the file should be copied to a temporary file first and not to toFName

SafeFName: Set this to the filename used to store the file if DoSafeCopy was passed as True

Return value: If the file cannot be stored then return an error message

This function is called when SyncBack needs the location to store a file in

its storage location. The file to store can be copied from the local filesystem.

If DoSafeCopy is True then the file should be copied to a temporary file first

and not to the filename specified in toFName. The full path of the safe filename

used should be returned in SafeFName.

For example:

Function LocPut(fromFName, toFName, fromAttrs, fromDateTime, fromFileSize, DoSafeCopy, SafeFName)

If Not FSO.FileExists(fromFName) Then

LocPut = "File does not exist"

Else

' Safe copy?

If DoSafeCopy Then

' Note that we must return a SafeFName that we will understand when

' it is passed back to us (we will be asked to move the file)

FulltoFName = toFName & ".$$$"

SafeFName = toFName & ".$$$"

Else

FulltoFName = toFName

SafeFName = ""

End If

' Destination file read-only?

If FSO.FileExists(FulltoFName) Then

Set FileObj = FSO.GetFile(FulltoFName)

Attrs = FileObj.Attributes

If Attrs And 1 Then

FileObj.Attributes = Attrs - 1

End If

Set FileObj = nothing

End If

' SBSystem.UpdateFileStatus("Copying " & fromFName & "...")

FSO.CopyFile fromFName, FulltoFName, True

If fromAttrs >= 0 Then

Set FileObj = FSO.GetFile(FulltoFName)

FileObj.Attributes = fromAttrs

Set FileObj = nothing

End If

If fromDateTime > 1.0 Then

SBSystem.SetLastModDateTime FulltoFName, fromDateTime

End If

LocPut = ""

End If

End Function

Function LocReconnect()

Return value: An error message if the script cannot reconnect, otherwise an empty string

This function is called to tell the script to reconnect to the storage location.

This is called when LocConnected indicates it is not connected, for example.

Return an error message if the reconnect failed, e.g. it cannot reconnect

because the network is down.

Function LocRemoveDir(FullPath)

FullPath: The complete path of the empty directory to delete

Return value: An error message if the directory cannot be deleted, otherwise an empty string

This function is called when the location should delete an empty directory. The

entire path of the directory to delete is passed. If the directory cannot be

deleted then an error message should be returned.

Note that an empty string should be returned if the directory does not exist. Do

not return an error message.

IMPORTANT: Do not delete a directory unless it is empty, i.e. if contains no

files and no sub-directories.

For example:

Function LocRemoveDir(FullPath)

LocRemoveDir = ""

If FullPath = "" Then

Exit Function

ElseIf FSO.FolderExists(FullPath) Then

Set Folder = FSO.GetFolder(Path)

If Folder.Files.Count > 0 Then

LocRemoveDir = "Directory contains files"

Exit Function

End If

If Folder.SubFolders.Count > 0 Then

LocRemoveDir = "Directory contains directories"

Exit Function

End If

Set Folder = nothing

FSO.DeleteFolder FullPath, True

End If

End Function

Function LocRenameDir(OldFullPath, NewFullPath)

OldFullPath: The existing path

NewFullPath: The new path (rename it to this)

Return value: An error message if the directory cannot be renamed, otherwise an empty string

This function is called when the script must rename a directory. Entire

paths are passed, including the base path. If the directory cannot be renamed

then return an error message.

For example:

Function LocRenameDir(FromPath, ToPath)

If FromPath = "" Then

LocRenameDir = "Root directory cannot be moved"

Exit Function

ElseIf ToPath = "" Then

LocRenameDir = "Cannot move to root directory"

Exit Function

End If

If Not FSO.FolderExists(FromPath) Then

LocRenameDir = "Source directory does not exist"

Exit Function

End If

If FSO.FolderExists(ToPath) Then

LocRenameDir = "To destination directory already exists"

Exit Function

End If

FSO.MoveFolder FromPath, ToPath

LocRenameDir = ""

End Function

Function LocRenameFile(OldFullFilename, NewFullFilename)

OldFullFilename: The existing filename

NewFullFilename: The new filename (rename it to this)

Return value: An error message if the file cannot be renamed, otherwise an empty string

This function is called when the script must rename a file. Entire filenames

are passed, including the base path. If the file cannot be renamed then return

an error message.

For example:

Function LocRenameFile(FromName, ToName)

If Not FSO.FileExists(FromName) Then

LocRenameFile = "Source file does not exist"

Exit Function

End If

If FSO.FileExists(ToName) Then

LocRenameFile = "To destination file already exists"

Exit Function

End If

FSO.MoveFile FromName, ToName

LocRenameFile = ""

End Function

Function LocScanList(FullPath)

FullPath: The complete directory path including the base path

Return value: An error message if the directory cannot be scanned, otherwise an empty string

This function is called when the script must tell SyncBack what files and

sub-directories are in a directory. The entire path of the directory to scan

is passed. For each file it must call SBLocation.AddFile, and for each folder

it must call SBLocation.AddDir. If the directory cannot be scanned, e.g.

access denied or it doesn't exist, then an error message should be returned.

For example:

Function LocScanList(FullPath)

LocScanList = ""

if FullPath = "\" or FullPath = "" then

'

' Return the list of drives

'

For Each DiskDrive in Drives

If DiskDrive.IsReady then

If SBLocation.AddDir(DiskDrive.DriveLetter) = False then

Exit Function

End If

End If

Next

else

'

' Return the list of folders and files

'

DriveLetter = Mid(FullPath, 2, 1)

if DriveLetter = "" then

Exit Function

End If

DrivePath = Mid(FullPath, 3, Len(FullPath) - 2)

If DrivePath = "" then

DrivePath = "\"

End If

Path = DriveLetter & ":" & DrivePath

' Return a list of sub-folders

Set Folder = FSO.GetFolder(Path)

Set FolderCol = Folder.SubFolders

For Each SubFol in FolderCol

If SBLocation.AddDir(SubFol.Name) = False then

Exit Function

End If

Next

' Return a list of files

Set FilesCol = Folder.Files

For Each FileItem in FilesCol

CFileSize = CStr(CCur(FileItem.Size))

If SBLocation.AddFile(FileItem.Name, "", CFileSize, FileItem.Attributes, FileItem.DateLastModified) = False then

Exit Function

End If

Next

end if

End Function

Function LocScanPrepare()

Return value: An error message if the storage location cannot be prepared, otherwise an empty string

This function is called to tell the script to prepare the storage location for

scanning. It is called after LocConnect.

For example:

Function LocConnect(MainThread)

LocConnect = ""

IsMainThread = MainThread

Set FSO = CreateObject("Scripting.FileSystemObject")

Set Drives = FSO.Drives

Set Folder = FSO.GetFolder("C:\")

If Not IsMainThread Then

Set DebugLog = Folder.CreateTextFile("debug.txt", True, True)

Else

Set DebugLog = Folder.CreateTextFile("debug_main.txt", True, True)

End If

DebugOut "---Connected: " & CStr(Now)

End Function

Function LocSetAttributes(Filename, Attributes)

Filename: The complete path of the file or directory

Attributes: The filesystem attributes to set the file or directory to

Return value: An error message if the attributes cannot be set, otherwise an empty string

This function is called when the filesystem attributes for a file or directory

need to be set. The entire path of the file or directory to change the

attributes of is passed. Note that if it's a directory then it will have

a trailing backslash. If the attributes cannot be changed then an error

message should be returned.

For example:

Function LocSetAttributes(Filename, Attrs)

If Filename = "" Then

' Its a special folder

LocSetAttributes = "Cannot set roots attributes"

Exit Function

End If

If SBSystem.IsFolder(Filename) Then

'

' A folder

'

If not FSO.FolderExists(Filename) Then

LocGetAttributes = "Folder does not exist"

Exit Function

End If

Set FolderObj = FSO.GetFolder(Filename)

FolderObj.Attributes = Attrs

LocSetAttributes = ""

Else

'

' A file

'

If not FSO.FileExists(Filename) Then

LocGetAttributes = "File does not exist"

Exit Function

End If

Set FileObj = FSO.GetFile(Filename)

FileObj.Attributes = Attrs

LocSetAttributes = ""

End If

End Function

Function LocSetModDateTime(Filename, ModDateTime)

Filename: The complete path of the file

ModDateTime: The last modication date & time (local timezone)

Return value: An error message if the date & time cannot be changed, otherwise an empty string

This function is called when the last modification date & time of a file

must be changed. The entire path of the file to change the date & time of is

passed. If the last modification date & time cannot be changed then an error

message should be returned.

For example:

Function LocSetModDateTime(FullPath, ModDateTime)

LocSetModDateTime = SBSystem.SetLastModDateTime(FullPath, ModDateTime)

End Function


Runtime Scripts

These are functions that are defined in your Runtime script and are called by SyncBackSE. A runtime script can be used to change what happens when a profile is run. For example, you could stop a profile from being run if certain conditions aren't met, or perform actions when some files are copied, deleted, or renamed. The functions are called by SyncBackSE at the appropriate time. Runtime scripts are used by profiles and have access to the SBRunning, SBSystem, and SBVariables objects.

Function RunBeforeCopyFile(ToLeft, Filename, ByRef ToDirCreated, ByRef FromFileLocked, ByRef ToFileLocked, ByRef DoneCopy)

ToLeft: True if the left/source file is to be copied from the right/destination

Filename: The file to be copied (not including the base path)

ToDirCreated: Set to True if a directory was created

FromFileLocked: Set to True if the file to be copied is locked

ToFileLocked: Set to True if the file to be replaced is locked

DoneCopy: Set to True if the file was copied

Return value: An error message if the copy failed

This function is called before a file is to be copied, and before any version

is made. On failure the function shoud return an error message (do not return

an error message if the script is not copying files). If a directory was created

in order to copy the file then ToDirCreated should be returned as True. If the

from file is locked then FromFileLocked should be returned as True (and an error

message should be returned). If the to file is locked then ToFileLocked should

be returned as True (and an error message should be returned). If the file was

copied then DoneCopy should be returned as True.

Note that once a script has copied a file then no other scripts will be called

to copy the file. This means the order of run-time scripts used in a profile

is important.

This function is not called if the run is a simulation.

See also RunAfterCopyFile

Function RunBeforeDeleteFile(Left, Filename, ByRef FileLocked, ByRef DoneDelete)

Left: True if the left/source file is to be deleted

Filename: The file to be deleted (not including the base path)

FileLocked: Set to True if the file to be deleted is locked

DoneDelete: Set to True if the file was deleted

Return value: An error message if the delete failed

This function is called before a file is to be deleted (and before a version

has been made). On failure the function should return an error message (do not

return an error message if the script is not deleting files). If the file is

locked then FileLocked should be returned as True (and an error message should

be returned). If the file was deleted then DoneDelete should be returned

as True.

Note that once a script has deleted a file then no other scripts will be called

to delete the file. This means the order of run-time scripts used in a profile

is important. Obviously a file can only be deleted once.

This function is not called if the run is a simulation.

See also RunAfterDeleteFile

Function RunBeforeRenameFile(Left, FromFilename, ToFilename, ByRef ToDirCreated, ByRef FileLocked, ByRef DoneRename)

Left: True if the left/source file is to be renamed

FromFilename: The old name of the file (not including the base path)

ToFilename: The new name of the file (not including the base path)

ToDirCreated: Set to True if the directory for ToFilename was created

FileLocked: Set to True if one of the files is locked so cannot be renamed

DoneRename: Set to True if the file was renamed

Return value: An error message if the rename failed

This function is called before a file is to be renamed. On failure the function

shoud return an error message (do not return an error message if the script is

not renaming files). If a directory was created in order to rename the file then

ToDirCreated should be returned as TRUE. If one of the files is locked then

FileLocked should be returned as TRUE (and an error message should be

returned). If the file was renamed then DoneRename should be returned as True.

Note that once a script has renamed a file then no other scripts will be called

to rename the file. This means the order of run-time scripts used in a profile

is important. Obviously a file can only be renamed once.

This function is not called if the run is a simulation.

See also RunAfterRenameFile

Function RunBeforeSetAttrs(Left, Filename, useAttrs, ByRef DoneSet)

Left: True if the left/source files attributes are to be changed

Filename: The name of the file (not including the base path)

useDateTime: The attributes to use

DoneSet: Set to True if the files attributes were changed

Return value: An error message on failure

This function is called when a files filesystem attributes are going to be

changed. On error return an error message (do not return an error message if the

script is not changing the files attributes). If the files attributes were

changed then DoneSet should be returned as True. It is called only when the

action is CACTION_USE_SRC_DETAILS or CACTION_USE_DEST_DETAILS, and is not called

when a file is copied and its attributes are to be changed, for example.

Note that once a script has set a files attributes then no other scripts

will be called to set the files attributes. This means the order of run-time

scripts used in a profile is important.

This function is not called if the run is a simulation.

See also RunAfterSetAttrs

Function RunBeforeSetModDateTime(Left, Filename, useDateTime, ByRef DoneSet)

Left: True if the left/source files date & time is to be changed

Filename: The name of the file (not including the base path)

useDateTime: The date & time to change it to (local timezone)

DoneSet: Set to True if the files date & time was changed

Return value: An error message on failure

This function is called when a files last modification date & time is going to

be set. On error return an error message (do not return an error message if the

script is not setting the files date & time). If the files date & time was

changed then DoneSet should be returned as True. It is called only when the

action is CACTION_USE_SRC_DETAILS or CACTION_USE_DEST_DETAILS, and is not called

when a file is copied and its date & time is changed, for example.

Note that once a script has set a files date & time then no other scripts

will be called to set the files date & time. This means the order of run-time

scripts used in a profile is important.

This function is not called if the run is a simulation.

See also RunAfterSetModDateTime

Function RunDiffColumnsCount()

Return value: The number of custom columns, or zero if none are required

This function is called from the Differences window to ask the script how many

custom columns it wants created in the Differences window. Note that this value

is cached so the function is only called once (when the Differences window

appears).

Function RunDiffColumnsCount()

RunDiffColumnsCount=2

End Function

Function RunDiffColumnSort(Col, IsFile1, IsFile2, Filename1, Filename2)

Col: The column the display is being sorted on

IsFile1: True if Filename1 is a file, otherwise it's a folder

IsFile2: True if Filename2 is a file, otherwise it's a folder

Filename1: The name of a file/folder

Filename2: The name of a file/folder

Return value: An integer (<0 if file 1 should go before file 2, 0=same filename, > 0 if file 1 should go after file 2)

This function is called from the Differences window when a custom column is

being sorted. The first custom column is column zero. The script is only called

for its custom columns and not for columns created by other scripts.

Note that sorting can be extremely slow if there are hundreds of thousands of

items to sort.

See also RunDiffColumnsCount

Function RunDisabledCheck(ByRef NoLog)

NoLog: Set this to TRUE if a log should not be created

Return value: A reason why the script should not continue running

This function is called very early on in the profile run and gives the script a

chance to stop the profile from running. If the script does not want the profile

to run it should return the reason, otherwise it should return an empty string

if the profile should continue.

To stop a log file from being produced then set NoLog to True. For example, you

may expect certain conditions, e.g. the network being unavailable, and so do not

want a log file to be produced.

Function RunDisabledCheck(NoLog)

NoLog = FALSE

If SBRunning.Restore Then

RunDisabledCheck = "You cannot restore your files"

Else

RunDisabledCheck = ""

End If

End Function

Function RunLogLocationInfoCaption(Left, Cnt)

Left: True is this call is for information on the left/source

Cnt: On the first call this is zero, and then incremented on each call

Return value: The caption string to use

This function is called when the log file is being created. It gives the script

an opportunity to add custom information to the log file about the left/source

and/or right/destination locations.

Note that RunLogLocationInfoToAdd is called first, and then

RunLogLocationInfoCaption() is called the appropriate number of times.

See RunLogLocationInfoToAdd for an example.

Function RunLogLocationInfoInfo(Left, Cnt)

Left: True is this call is for information on the left/source

Cnt: On the first call this is zero, and then incremented on each call

Return value: The information string to use

This function is called when the log file is being created. It gives the script

an opportunity to add custom information to the log file about the left/source

and/or right/destination locations.

Note that RunLogLocationInfoToAdd is called first, and then

RunLogLocationInfoInfo is called the appropriate number of times.

See RunLogLocationInfoToAdd for an example.

Function RunLogLocationInfoToAdd(Left)

Left: True is this call is for information on the left/source

Return value: The number of caption/info calls to make

This function is called when the log file is being created. It gives the script

an opportunity to add custom information to the log file about the left/source

and/or right/destination locations.

Note that RunLogLocationInfoToAdd< is called first, and then

RunLogLocationInfoInfo is called the appropriate number of times.

Function RunLogLocationInfoToAdd(Left)

If Left = True Then

RunLogLocationInfoToAdd = 2

Else

RunLogLocationInfoToAdd = 0

End If

End Function

Function RunLogLocationInfoCaption(Left, Cnt)

If Left = True Then

If Cnt = 0 Then

RunLogLocationInfoCaption = "Caption 1"

Else

RunLogLocationInfoCaption = "Caption 2"

End If

Else

RunLogLocationInfoCaption = ""

End If

End Function

Function RunLogLocationInfoInfo(Left, Cnt)

If Left = True Then

If Cnt = 0 Then

RunLogLocationInfoInfo = "Info 1"

Else

RunLogLocationInfoInfo = "Info 2"

End If

Else

RunLogLocationInfoInfo = ""

End If

End Function

Sub InitialiseVars(Checking)

Checking: Passed as True if the variables are being checked to see if they exist

This subroutine is called when the variables are initialised. Checking is passed

as FALSE. Note that you need to be careful as many things haven't been

initialised or created when this is called, e.g. no locations. It is called very

early during the profile run (it is called just after RunDisabledCheck is

called).

If you are setting variables then it is recommended you also make your script

a Configuration script. This is so the users can see which variables the script

sets, and also they can use the variables, e.g. in the source or destination

paths.

In the example below the variable MyScriptVar is set to a dummy value if it's

a call to check if the variable is valid.

'

' Called very early when a profile is run (Checking is False)

' Also called in profile config when asking what variables the script sets (Checking is True)

'

Sub InitialiseVars(Checking)

If Checking Then

' Profile is being saved

SBVariables.SetVar "MyScriptVar", "?"

Else

' Profile is being run

' Do nothing

End If

End Sub

Sub RunAfterConfig()

This function is called very early on in the profile run and gives the script a

chance to do any early initialisation work. It is called before any attempt is

made to connect to the left/source or destination/right. It is called after

RunBeforeConfig and at this point the left/source folder is known, for

example.

Sub RunAfterCopyFile(ToLeft, Filename, Failed)

ToLeft: True if the file was copied from the right/destination

Filename: The name of the file (not including the base path)

Failed: True if the copy failed

This function is called after a file has been copied. If Failed is True then

either the copy failed or the user has aborted. Note that Failed being False

does not necessarily mean the file was actually copied, i.e. it does not

guarantee a file was created because the location may not actually copy the

file, e.g. it may actually simply send it to a printer. What a script location

does when it copies a file is beyond SyncBack's control.

This function is not called if the run is a simulation.

See also RunBeforeCopyFile

Sub RunAfterDeleteFile(Left, Filename, Failed)

Left: True if the left/source file was deleted

Filename: The name of the file (not including the base path)

Failed: True if the delete failed

This function is called after a file has been deleted. If Failed is True then

either the delete failed or the user has aborted. Note that Failed being False

does not necessarily mean the file was actually deleted, e.g. it may not have

existed.

This function is not called if the run is a simulation.

See also RunBeforeDeleteFile

Sub RunAfterEmailLog(ErrMsg)

ErrMsg: An error message (if the log could not be sent via email)

This subroutine is called after the log is emailed. If there was a problem

sending the email then ErrMsg contains an error message.

Note this subroutine is not called if the profile is not configured to send

the log via email.

Sub RunAfterEmailLog(ProfileResult, Failed, Diffs)

ProfileResult: The result of the profile run

Failed: True if the profile run had failures

Diffs: True if the profile found differences between the left/source and destination/right

Return value: Return False to not send the email, else return True

This subroutine is called before the log is to be emailed. This gives the script

an opportunity to not send the email.

Note this subroutine is not called if the profile is not configured to send

the log via email.

Sub RunAfterFolderCompare(Filename, ByRef Action)

Filename: The name of the folder (not including the base path)

Action: The action that has been decided upon based on the profiles settings

This function is called after a folder (directory) is compared. The script can

change the Action to something else, or leave it as-is.

See also RunBeforeFolderCompare

Sub RunAfterRenameFile(Left, FromFilename, ToFilename, Failed)

Left: True if the left/source file was renamed

FromFilename: The old name of the file (not including the base path)

ToFilename: The new name of the file (not including the base path)

Failed: True if the rename failed

This function is called after a file has been renamed. If Failed is True then

either the rename failed or the user has aborted. Note that Failed being False

does not necessarily mean the file was actually renamed, i.e. it does not

guarantee a file was renamed because the location may not actually rename the

file. What a script location does when it renames a file is beyond SyncBack's

control.

This function is not called if the run is a simulation.

See also RunBeforeRenameFile

Sub RunAfterSetAttrs(Left, Filename, useAttrs, Failed)

Left: True if the left/source files attributes were changed

Filename: The name of the file (not including the base path)

useAttrs: The attributes that were used

Failed: True if the change failed

This function is called after a files filesystem attributes have been

changed. It is called only when the action was CACTION_USE_SRC_DETAILS or

CACTION_USE_DEST_DETAILS, and is not called when a file is copied and its

attributes are changed, for example. If Failed is True then either the change

failed or the user has aborted. Note that Failed being False does not

necessarily mean the files attributes were actually changed.

This function is not called if the run is a simulation.

See also <a RunBeforeSetAttrs>RunBeforeSetAttrs</a<

Sub RunAfterSetModDateTime(Left, Filename, useDateTime, Failed)

Left: True if the left/source files date & time was changed

Filename: The name of the file (not including the base path)

useDateTime: The date & time it was changed to (local timezone)

Failed: True if the change failed

This function is called after a files last modification date & time has been

changed. It is called only when the action was CACTION_USE_SRC_DETAILS or

CACTION_USE_DEST_DETAILS, and is not called when a file is copied and its

date & time is changed, for example. If Failed is True then either the change

failed or the user has aborted. Note that Failed being False does not

necessarily mean the date & time of the file was actually changed.

This function is not called if the run is a simulation.

See also RunBeforeSetModDateTime

Sub RunBeforeConfig()

This function is called very early on in the profile run and gives the script a

chance to do any early initialisation work. It is called before any attempt is

made to connect to the left/source or destination/right. It is called after

RunDisabledCheck and before the profile is prepared. Note

that very little is initialised at this point, e.g. there is no left/source

folder.

See also RunAfterConfig

Sub RunBeforeFileCompare(Filename, ByRef Skip)

Filename: The filename of the file (not including the base path)

Set: Skip to True to ignore/skip the file

This subroutine is called before a file is compared for differences.

Sub RunBeforeFolderCompare(Filename, ByRef Skip)

Filename: The name of the folder (not including the base path)

Skip: Set to True to skip this folder

This function is called before a folder (directory) is compared. It gives the

script an opportunity to skip a folder (it's action will be set to CACTION_SKIP)

See also RunAfterFolderCompare

Sub RunDiffColumnClicked(Col, IsFile, Filename)

Col: The column number

IsFile: True if Filename refers to a file, else it's a folder

Filename: The name of the file/folder (not including the base path)

This subroutine is called from the Differences window when a custom column is

clicked. The first custom column is column zero (0). The script is only called

for its custom columns and not for columns created by other scripts.

See also RunDiffKeyPress

Sub RunDiffColumnClicked(Col, IsFile, Filename)

SBSystem.Say "Custom Column " & Col

End Sub

Sub RunDiffColumnHint(Col, IsFile, Filename)

Col: The column number

IsFile: True if Filename refers to a file, else it's a folder

Filename: The name of the file/folder (not including the base path)

Return value: The hint string to display

This subroutine is called from the Differences window when a custom column hint

is required. The first custom column is column zero (0). The script is only

called for its custom columns and not for columns created by other scripts.

Function RunDiffColumnHint(Col, IsFile, Filename)

RunDiffColumnHint = Filename

End Function

Sub RunDiffColumnText(Col, IsFile, Filename)

Col: The column number

IsFile: True if Filename refers to a file, else it's a folder

Filename: The name of the file/folder (not including the base path)

This subroutine is called from the Differences window when text for a custom

column is required. The first custom column is column zero (0). The script is

only called for its custom columns and not for columns created by other scripts.

Function RunDiffColumnText(Col, IsFile, Filename)

If Col = 0 Then

RunDiffColumnText = "Custom Column 1: " & Filename

Else

RunDiffColumnText = "Custom Column 2: " & Filename

End If

End Function

See also RunDiffColumnsCount

Sub RunDiffColumnTitle(Col, ByRef Width)

Col: The column number

Width: Set it to the width the column should be (in pixels)

This subroutine is called from the Differences window when the title for a

custom column is required. The first custom column is column zero (0). The

script is only called for its custom columns and not for columns created by

other scripts.

Function RunDiffColumnTitle(Col, Width)

If Col = 0 Then

RunDiffColumnTitle = "Custom Column 1"

Width = 100

Else

RunDiffColumnTitle = "Custom Column 2"

Width = 150

End If

End Function

Sub RunDiffFocusChanged(IsFile, Filename)

IsFile: True if Filename refers to a file, else it's a folder

Filename: The name of the file/folder (not including the base path)

This subroutine is called from the Differences window when the focused node

changes.

Sub RunDiffFocusChanged(IsFile, Filename)

SBSystem.Say "Focus changed"

End Sub

Sub RunDiffKeyPress(Key, Shift, IsFile, Filename)

Key: The key that as pressed

Shift: The shift state

IsFile: True if Filename refers to a file, else it's a folder

Filename: The name of the file/folder (not including the base path)

This subroutine is called from the Differences window when a key is pressed. It

is called for each selected row. It is not called if the Delete key is pressed

(as that is handled by SyncBack itself).

The Key value refers to the virtual key codes.

The Shift state can be a selection of the following values:

0 = no shift state

1 = Shift key is pressed (ssShift)

2 = Alt key is pressed (ssAlt)

4 = Ctrl key is pressed (ssCtrl)

8 = Left mouse button is pressed (ssLeft)

16 = Right mouse button is pressed (ssRight)

32 = Middle mouse button is pressed (ssMiddle)

64 = Mouse double-clicked (ssDouble)

See also RunDiffColumnClicked

' This example says the filename if S is pressed

Sub RunDiffKeyPress(Key, ShiftState, IsFile, Filename)

If Key = 83 Then

SBSystem.Say Filename

End If

End Sub

Sub RunDoFullBackup(LeftDir, RightDir, ByRef FullBackup)

LeftDir: The base directory of the left/source

RightDir: The base directory of the right/destination

FullBackup: True if this is a full backup run. Change as required.

This function is called when a decision must be made on whether the profile run

should be a full backup or an incremental/differential backup.

Note that once a script has decided on wheter it is a full backup or not then no

other scripts will be called to decide. This means the order of run-time scripts

used in a profile is important.

See also FullBackup

Sub RunFileCompareDiff(Filename, Diff, WhyIgnored, ByRef Skip)

Filename: The filename of the file (not including the base path)

Diff: The differences between the files

WhyIgnored: The reason why the file is being ignored (if it is)

Set: Skip to True to ignore/skip the file

This subroutine is called after a file has been compared for differences and

the left/source and right/destination files are different.

Sub RunFileCompareSame(Filename, ByRef Diff)

Filename: The filename of the file (not including the base path)

Diff: Set to the difference between the files, or CDIFF_IDENTICAL

This subroutine is called after a file has been compared for differences and

the left/source and right/destination files are found to be identical.

Sub RunProfileResult(ProfileResult, ErrMsg)

ProfileResult: The result of the profile run

ErrMsg: If a fatal error occurred, this is the error message

This function is called when the result of the profile run is known and has been

saved. It is usually done before the profile finishes. For example:

Sub RunProfileResult(ProfileResult, ErrMsg)

SBRunning.DebugOut CStr(ProfileResult), ErrMsg, 1

End Sub


SBLocation

These are functions that can be accessed from scripts via the SBLocation object. For example:

SBLocation.BaseDir

The SBLocation object is only accessible from Location scripts.

Function AddDir(Name)

Name: The name of the directory, without the path

Return value: Return FALSE if the script wants to abort the scan

This function should be called by the Script inside the LocScanList whenever

a new directory (folder) is found, i.e. the script must call this function for

every directory in the directory being scanned.

Name: The name should not include the path. It is just the name of the

directory. It must be a unique name for that folder, i.e. two sub-directories in

the same directory cannot have the same name. Note that you do not need to pass

the special folders . or ..

Function AddFile(Name, CRC32, FileSize, Attrs, ModDateTime)

Name: The name of the file, without the path

CRC32: The CRC32 hash value of the file, or empty string if unknown

FileSize: The size of the file, in bytes, or -1 if unknown

Attrs: The filesystem attributes of the file, or -1 if unknown

ModDateTime: The last modification date & time of the file, or 1.0 if unknown

Return value: Return FALSE if the script wants to abort the scan

This function should be called by the Script inside the LocScanList function whenever

a new file is found, i.e. the script must call this function for every file

in the folder being scanned.

Name: The name should not include the path. It is just the name of the file.

It must be a unique name for that folder, i.e. two files in the same folder

cannot have the same name.

CRC32: Do not waste time calculating the CRC32 hash value. Only provide it if

it is already known, e.g. it's a Zip file so you can get the hash value

quickly, otherwise pass an empty string.

FileSize: The size of the file, in bytes. If the size is unknown then pass -1.

If IsIgnoringSize is returning True, and retrieving the file size would incur

more processing time, then you can pass -1. Note that this parameter is a string

to avoid the 32-bit limit on integers used by VBScript. If you are using

VBScript, then convert the number to a currencty and then to a string,

e.g. CFileSize = CStr(CCur(FileItem.Size))

Attrs: The filesystem attributes of then file. If the attributes are unknown

then pass -1. Note that these must be standard Windows filesystem attributes.

ModDateTime: The last modification date & time of the file (in the local

timezone). If the last modification date & time is unknown then pass 1.0. Also,

if IsIgnoringDateTime is returning True, and retrieving the date & time would

incur more processing time, then you can pass 1.0

Property Abort

Returns TRUE if the profile is being aborted. Set it to TRUE to abort the

profile. Note that the abort may not be immediate, and an abort cannot be

aborted (i.e. once True you cannot change it to False).

Property BaseDir

Returns the base directory of the location.

This is a read-only property.

Property IsIgnoringDateTime

Returns True if this location can ignore file last modification date & times.

Note that this should only be used in the LocScanList script function

otherwise the return value is always False. This can be used to optimize the

location, e.g. if it takes time to get a files last modification date & time,

and IsIgnoringDateTime is returning True, then the script should not waste

time trying to retrieve it (in the LocScanList script function).

This is a read-only property.

Property IsIgnoringSize

Returns True if this location can ignore file sizes. Note that this should only

be used in the LocScanList script function otherwise the return value is

always False. This can be used to optimize the location, e.g. if it takes time

to get a files size, and IsIgnoringSize is returning True, then the script

should not waste time trying to retrieve it (in the LocScanList script

function).

This is a read-only property.

Property IsLeft

Returns True if this location is the left/source location, otherwise it is the

right/destination location.

This is a read-only property.

Property VersionsType

Returns an integer value that states what is being done with versions folders:

0 = They are being treated as any other directory (usually because neither location if using versioning)

1 = Versions directories and being skipped and assumed not to exist (usually because this location doesn't use versioning, but the other one does)

2 = File versions are being read from the versions directories, i.e. the location uses versioning

Note that this information is for reference only as SyncBack will manage all

aspects of versioning for the script.

This is a read-only property.

Property VersionSubDir

Returns the name of the versions sub-folder, e.g. $SBV$. Note that this

information is for reference only as SyncBack will manage all aspects of

versioning for the script.

This is a read-only property.


SBRunning

These are functions that can be accessed from scripts via the SBRunning object. For example:

SBLocation.Warning "Filename", "Warning message"

The SBRunning object is only accessible from Runtime scripts.

Function FolderHasFiles(Name)

Name: The name of the folder (not including the base folder)

Return value: True if the file contains files

This function returns True if a folder that has been scanned contains any

files (that have not been filtered out). Note that the folder name should not

include the base folder.

Function GetFileAction(Filename)

Name: The name of the file (not including the base folder)

Return value: The action to be performed

This function returns the action that will be performed for a particular

file. Note that the filename should not include the base folder. If the file

does not exist then 0 (CACTION_ERROR) is returned.

For folders see GetFolderAction

Function GetFileAttrs(Filename, Left)

Filename: The filename (not including the base folder)

Left: If True then return the attributes of the left/source file

Return value: The files attributes

This function returns a files filesystem attributes. Note that the filename

should not include the base folder. If the file does not exist then -2 is

returned. If the file has no file attributes, then -1 is returned.

To set a files attributes use SetFileAttrs

See also GetFileDetails

Function GetFileDateTime(Filename, Left)

Filename: The filename (not including the base folder)

Left: If True then return the date & time of the left/source file

Return value: The files last modification date & time

This function returns the last modification date & time of a file (in the

local timezone). Note that the filename should not include the base folder.

If the file does not exist then 0.9 is returned. If the file has no date & time

then 1.0 is returned.

To set a files modification date and time use SetFileDateTime

See also GetFileDetails

Function GetFileDetails(Filename, Left, ByRef StoredName, ByRef Size, ByRef Attrs, ByRef Hash, ByRef ModDateTime, ByRef Exists)

Filename: The filename (not including the base folder)

Left: Pass True to get the details of the left/source file

StoredName: The stored name of the file (if there is one)

Size: The size of the file in bytes (note this is a string)

Attr: The filesystem attributes of the file

Hash: The CRC32 hash value of the file (as a string)

ModDateTime: The last modification date & time of the file (local timezone)

Exists: Returned as True if the file exists on either the left/source or right/destination

Return value: False if the file does not exist on either the left/source or right/destination

This function returns all the details of a file in a single call. It is more

efficient to use this function if more than a single piece of information on a

file is required. Note that the filename should not include the base folder.

If the file does not exist at all on either the left/source or right/destination

then False is returned and Exists is set to False. However, if you request the

details of the file on the left/source and the file only exists on the

right/destination, for example, then False is returned but Exists is set to

True. If Exists is True then the file does exist on the left/source or

right/destination (or both).

When using VBScript you must define the parameter types for ByRef

parameters, e.g.:

SBRunning.GetFileDetails(Filename, True, CStr(StoredName), CStr(Size), _

CInt(Attrs), CStr(Hash), CDbl(ModDateTime), CBool(Exists))

Function GetFileDiff(Filename)

Filename: The filename (not including the base folder)

Return value: The difference between the files

This function returns the differences between a file in the left/source and/or

right/destination. Note that the filename should not include the base folder.

If the file does not exist then 0 (CDIFF_IDENTICAL) is returned.

For folders see GetFolderDiff

Function GetFileHash(Filename, Left)

Filename: The filename (not including the base folder)

Left: If True then return the hash value of the left/source file

Return value: The files CRC32 hash value (as a string)

This function returns the CRC32 hash value (in string format) of a file. Note

that the filename should not include the base folder. If the file does not

exist, or has no CRC32 hash value, then an empty string is returned.

To set a files hash value use SetFileHash

See also GetFileDetails

Function GetFileSize(Filename, Left)

Filename: The filename (not including the base folder)

Left: If True then return the size of the left/source file

Return value: The files size in bytes

This function returns the size of a file (in bytes). Note that the filename

should not include the base folder. If the file does not exist then -2 is

returned. If the file size is unknown then -1 is returned. Note that this

function returns a string to avoid the 32-bit integer limit in VBScript.

To set a files size use SetFileSize

See also GetFileDetails

Function GetFolderAction(Name)

Name: The name of the folder (not including the base folder)

Return value: The action to be performed

This function returns the action that will be performed for a particular

folder. Note that the folder name should not include the base folder. If the

folder does not exist then 0 (CACTION_ERROR) is returned.

For files see GetFileAction

Function GetFolderDiff(Name)

Name: The name of the folder (not including the base folder)

Return value: The difference between the folders

This function returns the differences between a folder in the left/source and/or

right/destination. Note that the folder name should not include the base folder.

If the folder does not exist then 0 (CDIFF_IDENTICAL) is returned.

For files see GetFileDiff

Function GetMovedName(Filename)

Filename: The filename (not including the base folder)

Return value: The file it has been moved from or to

This function returns the name a file has been moved from or to. For example,

if SyncBack detects that file \folder\file.txt has been moved to

\somewhere\else.txt then calling GetMovedName('\folder\file.txt') will return

'\somewhere\else.txt' and calling GetMovedName('\somewhere\else.txt') will

return '\folder\file.txt'

Note that the filenames do not include the base folder.

If the file has not been moved, or does not exist, then an empty string is

returned.

Function GetStoredFileName(Filename, Left)

Filename: The filename (not including the base folder)

Left: If True then return the stored name of the left/source file

Return value: The files stored filename

This function returns the stored (actual) filename of a file. Note that the

filename should not include the base folder. If the file does not exist

then an empty string is returned. If it doesn't have a stored name then it's

normal filename is returned.

See the function GetStoredFolderName for information on what a stored name is.

See also GetFileDetails

Function GetStoredFolderName(Filename, Left)

Filename: The folder name (not including the base folder)

Left: If True then return the stored name of the left/source folder

Return value: The folders stored filename

This function returns the stored (actual) name of a folder. Note that the

filename should not include the base folder. If the folder does not exist

then an empty string is returned. If it doesn't have a stored name then it's

normal name is returned.

A folder may have a different name on one side, e.g. the right/destination

name may be different from the left/source name. For example, if a folder is

on a DVD then its name may be different from the name it had on the hard-drive

(when it was copied to the DVD). This is because the filesystem on the DVD has

stricter rules on what a valid filename is and the maximum length of that

name.

Generally stored names are only used when restoring from a CD/DVD

For example, GetStoredFolderName("\Folder\A long folder name\", False) may

return "\FOLDER\ALONGFOL"

To get the stored name of a file use GetStoredFileName

Function LeftFileExists(Filename)

Filename: The filename to check for

Return value: True if the file exists in the left/source

Returns True if the file exists in the left/source. Note that the filename

should not include the base folder.

This property is read-only.

See also LeftFolderExists and RightFileExists

Function LeftFolderExists(Name)

Name: The name of the folder to check for

Return value: True if the folder exists in the left/source

Returns True if the folder exists in the left/source. Note that the name

should not include the base folder.

This property is read-only.

See also RightFolderExists and LeftFileExists

Function RightFileExists(Filename)

Filename: The filename to check for

Return value: True if the file exists in the right/destination

Returns True if the file exists in the right/destination. Note that the filename

should not include the base folder.

This property is read-only.

See also RightFolderExists and LeftFileExists

Function RightFolderExists(Name)

Name: The name of the folder to check for

Return value: True if the folder exists in the right/destination

Returns True if the folder exists in the right/destination. Note that the name

should not include the base folder.

This property is read-only.

See also LeftFolderExists and RightFileExists

Function SetFileAttrs(Filename, Left, NewAttrs)

Filename: The filename (not including the base folder)

Left: Pass True to set the attributes of the left/source file

NewAttrs: The file attributes to set

Return value: The files attributes, or -1 on failure

This function sets the filesystem attributes of a file. Note that the

filename should not include the base folder.

This function does not actually change the attributes of the file. It instead

tells SyncBack what the attributes of the file are.

See also GetFileAttrs

Function SetFileDateTime(Filename, Left, NewAttrs)

Filename: The filename (not including the base folder)

Left: Pass True to set the date & time of the left/source file

NewDateTime: The date & time to use (local timezone)

Return value: The date & time of the file, or 1.0 on failure

This function sets the last modification date & time of a file. Note that the

filename should not include the base folder.

This function does not actually change the last modification date & time of the

file. It instead tells SyncBack what the last modification date & time of the

file is.

See also GetFileDateTime

Function SetFileHash(Filename, Left, NewHash)

Filename: The filename (not including the base folder)

Left: Pass True to set the hash value of the left/source file

NewHash: The CRC32 hash value of the file

Return value: The hash value of the file, or empty string on failure

This function sets the CRC32 hash value (string format) of a file. Note that the

filename should not include the base folder.

This function does not actually change the hash value of the file. It instead

tells SyncBack what the hash value of the file is.

See also GetFileHash

Function SetFileSize(Filename, Left, NewSize)

Filename: The filename (not including the base folder)

Left: Pass True to set the size of the left/source file

NewSize: The size of the file

Return value: The size of the file, or -1 on failure

This function sets the size of a file. Note that the filename should not

include the base folder. To avoid the 32-bit limit in VBScript the NewSize is

a string, and so is the return value.

This function does not actually change the size of the file. It instead tells

SyncBack what the size of the file is.

See also GetFileSize

Function Sleep(Seconds)

Seconds: The number of seconds to sleep

Return value: True if the user has aborted the profile

Sleep for the specified number of seconds, but also checks to see if the profile

has aborted while sleeping. If the user has aborted the profile run then the

function returns True immediately, i.e. the sleep is aborted.

Property Abort

Returns TRUE if the profile is being aborted. Set it to TRUE to abort the

profile. Note that the abort may not be immediate, and an abort cannot be

aborted (i.e. once True you cannot change it to False).

Property DifferentialBackup

Returns True if the profile is being run as a differential backup. If it is then

that also implies it is a Fast Backup profile.

This property is read-only.

See also FastBackupType and DynamicFastBackup

Property DynamicFastBackup

Returns True if the profile is being run as a dynamnic fast backup backup.

This property is read-only.

See also FastBackupType and DifferentialBackup

Property FastBackupType

Returns the type of Fast Backup the profile is being run as:

0 = It is not a Fast Backup

1 = It is an original Fast Backup

2 = It is an archival Fast Backup

This property is read-only.

See also DynamicFastBackup and DifferentialBackup

Property FileCount

Returns the number of files in the profile.

This property is read-only.

For the number of folders see FolderCount

Property FolderCount

Returns the number of folders (directories) in the profile.

This property is read-only.

For the number of folders see FileCount

Property FullBackup

Returns True if this is a full-backup profile run.

This property is read-only.

See also FastBackupType

Property GroupName

Returns the name of the group profile, or empty string if the profile is not

being run as part of a group.

This property is read-only.

See also VisualGroupName

Property LeftAbilities

Returns the abilities of the source/left location.

This property is read-only.

See also RightAbilities

Property LeftFolder

Returns the left/source base folder, e.g. C:\My Files\To Backup\

This property is read-only.

See also RightFolder and LeftName

Property LeftName

Returns the name of the left/source, e.g. My Files To Backup

This property is read-only.

See also RightName

Property Name

Returns the name of the profile.

This property is read-only.

See also GroupName and ProfileType

Property ProfileType

Returns the type of the profile.

This property is read-only.

See also ProfileTypeDesc

Property ProfileTypeDesc

Returns a description of the profile based on its type (see ProfileType).

This property is read-only.

Property Restore

Returns True if the profile is being run in restore mode.

This property is read-only.

See also Simulated

Property RightAbilities

Returns the abilities of the destination/right location.

This property is read-only.

See also LeftAbilities

Property RightFolder

Returns the right/destination base folder, e.g. C:\My Backup Files\

This property is read-only.

See also LeftFolder and RightName

Property RightName

Returns the name of the right/destination, e.g. My Backup Files

This property is read-only.

See also LeftName

Property Simulated

Returns True if the profile is being run in simulation mode.

This property is read-only.

See also Restore

Property Unattended

Returns True if the profile is being run unattended, i.e. the script should not

prompt the user or expect any user interaction.

This property is read-only.

Property VisualGroupName

If the profile is being run as part of a group, or it is being run from the

user interface from within a group, then this is the name of the group. Note

that the property GroupName is returned as an empty string

if the profile is not being run as part of a group, but VisualGroupName may

still return a group name if the user has clicked on the profile in a group and

then run it.

This property is read-only.

Sub CriticalError(Filename, TheError, IncErrorCount)

Filename: The filename of the file the error relates to

TheError: The error message

IncErrorCount: Pass True if the critical error count should be incremented

This subroutine records a critical error in the profiles log file. The error

must be related to a particular file. Note that the filename should not include

the base folder. For example, if the base folder is C:\My Files\, and the

file is C:\My Files\Folder\Filename.txt, then the filename to pass should be

\Folder\Filename.txt

A critical error means the profile has failed. The profile will continue running

but once completed its last run status will be 'Failure'.

For example, CriticalError "\folder\file.txt", "Your wife says you cannot copy this file", TRUE

See also NotCriticalError and Warning

Sub DebugOut(Str1, Str2, Level)

Str1: Typically this is a filename or refers to the object the error is about

Str2: Typically this is the error message

Level: The severity of the message

This subroutine records a message in the debug log. Note that nothing is

recorded if debug output is not enabled. Level refers to the severity of the

message (1=error, 5=warning, 10=information). The user can set the minimum level

a message should be, e.g. they could filter out anything above level 5.

For example, DebugOut "\folder\file.txt", "Klingons off the starboard bow", 1

To record a message in the Windows event log use EventOut

Sub EventOut(Msg, Level)

Msg: The message to record in the Windows event log

Level: The severity of the message

This subroutine records an event in the Windows Applications Event Log. Level

refers to the severity of the message (1=error, 5=warning, 10=information).

For example, EventOut "The toilet seat has not been left down", 1

To record a message in the debug log for the profile use DebugOut

Sub Exception(ExceptionReport)

ExceptionReport: The exception report

This subroutine records an exception report in the profiles log file. An

exception report is typically a number of lines of text that detail where an

unexpected error occurred in the program/script. This is usally done when

something serious unexpectedly happens in the program, e.g. an attempt is made

to read from a nil pointer.

To record a message in the debug log for the profile use DebugOut

To record a message in the Windows event log use EventOut

Sub NotCriticalError(Filename, TheError)

Filename: The filename of the file the error relates to

TheError: The error message

This subroutine records a non-critical error in the profiles log file. The error

must be related to a particular file. Note that the filename should not include

the base folder. For example, if the base folder is C:\My Files\, and the

file is C:\My Files\Folder\Filename.txt, then the filename to pass should be

\Folder\Filename.txt

A non-critical error does not mean the profile has failed.

For example, NotCriticalError "\folder\file.txt", "The date and time of the file could not be set"

See also CriticalError and Warning

Sub RebootRequired()

This subroutine tells SyncBack that the computer should be rebooted aftet the

profile has completed. For example, if a file can only be replaced on reboot

then this subroutine should be called. Note that a reboot is not guaranteed

to occur as the user may decide not to reboot.

Sub Warning(Filename, TheWarning)

Filename: The filename of the file the warning relates to

TheError: The warning message

This subroutine records a warning message in the profiles log file. The warning

must be related to a particular file. Note that the filename should not include

the base folder. For example, if the base folder is C:\My Files\, and the

file is C:\My Files\Folder\Filename.txt, then the filename to pass should be

\Folder\Filename.txt

A warning does not mean the profile has failed.

For example, Warning "\folder\file.txt", "The file has your credit card number in it"

See also NotCriticalError and CriticalError


SBSystem

These are functions that can be accessed from scripts via the SBSystem object. For example:

SBSystem.Say "Hello"

The SBSystem object is accessible from any type of script.

Function BuildDateTime(Day, Mon, Year, Hour, Min, Sec, MSec)

Day: Day of the month

Mon: Month of the year

Year: Year

Hour: Hour of the day (24-hour clock)

Min: Minute of the hour

Sec: Second of the minute

MSec: Milli-seconds of the second

Return value: A date & time value, or 1.0 if the parameters passed are invalid

This function builds a date & time that can be used with SyncBack, e.g. in the

AddFile function. Note that the date variable type in VBScript is already

compatible with SyncBack.

For example, for 24th June 1971 15:31:02.123 you would call

BuildDateTime(24, 6, 1971, 15, 31, 02, 123)

Function CheckNetworkDrive(UNCOrPath)

UNCOrPath: UNC path or drive path to check

Return value: An error message on failure

This function checks to see if a network drive can be reached. A UNC path,

e.g. \\server\share\folder\, or networked drive path, e.g. Z:\, can be passed.

If it can be reached then an empty string is returned, otherwise an error

message is returned.

To check if a computer can be reached (via its hostname or IP address) use the

function Ping

Function COMRegister(Filename)

Filename: Filename of the COM/OCX/ActiveX component to register

Return value: An error message on failure

This function registers an COM/OCX/ActiveX component (DLL or EXE). Note that

typically the user must have Administrator privileges to register components.

On success an empty string is returned, otherwise an error message is returned.

Function CRC32(Filename)

Return value: CRC32 hash value of the file, or empty string on failure

This function returns the CRC32 hash value of a file in string format. Note

that it may take a long time to calculate the hash values of large files, or

files accessed via a slow connection.

See also MD5

Function DecryptFile(Filename)

Filename: The full filename of the file to decrypt

Return value: Returns error message on failure

This function decrypts an NTFS encrypted file. If the file does not exist, or

is not encrypted, then no error message is returned. Note that it cannot

decrypt folders.

See also EncryptFile

Function EncryptFile(Filename)

Filename: The full filename of the file to encrypt

Return value: Returns error message on failure

This function encrypts a file using NTFS encryption. If the file does not exist,

or is already encrypted, then no error message is returned. If the file is

compressed, EncryptFile will decompress the file before encrypting it. Note

that it cannot encrypt folders.

See also DecryptFile

Function Exec(CmdLine, WaitSecs, ByRef RetVal, ByRef ErrMsg)

CmdLine: The full program name and parameters

WaitSecs: The number of seconds to wait

RetVal: The integer return value of the program executed

ErrMsg: An error message if the program could not be executed

Return value: Returns True if the program was executed

This function executes a program and optionally waits for it to complete.

CmdLine can contain command line parameters. It must be a fully qualified

filename, e.g. C:\abc\def param1 param2

If WaitSecs < 0 then it will wait forever the program to finish

If WaitSecs = 0 then it will not wait for the program to finish

If WaitSecs > 0 then it will wait that number of seconds for it to finish

You need to wrap double quotes around the program name (no need if it does

not contain spaces) otherwise the return value will always be 1. Also,

command line parameters should be wrapped in double quotes if they contain

spaces. For example:

"D:\Documents and Settings\Mick\Desktop\deldest.bat" param1 "param 2"

and NOT:

D:\Documents and Settings\Mick\Desktop\deldest.bat param1 param 2

CmdLine can be prefixed with special parameters:

/min to minimize the window

/hide to hide the window

e.g. /min "D:\Documents and Settings\Mick\Desktop\deldest.bat" "param 1"

If you choose to wait for the program to terminate then its return value

is returned in RetVal. Otherwise the value in RetVal is unknown and should be

ignored.

On failure ErrMsg will be set to an error message.

If the program was executed then True is returned. False is returned if the

program could not be executed, e.g. doesn't exist. Note that True does not

mean the program did what you required. To verify that check RetVal.

Note that for VBScript you must set the variable type for the ByRef parameters, e.g.:

SBSystem.Exec "C:\Windows\System32\Notepad.exe", 0, CInt(RetVal), CStr(ErrMsg))

To view a web page use the function OpenBrowser, and to

open a file use the function OpenFile

Function GetProfileName(Idx)

Idx: The profile name to retrieve (first profile is zero)

Return value: The name of the profile, or empty string if there is no such profile

This function retrieves the name of a profile. To get the number of profiles use

the ProfileCount property. Note that the first profile is zero (0),

and the last is ProfileCount - 1

Note that you should call ProfileCount to refresh the list.

Function GMTToLocal(GMTTime)

GMTTime: A date & time in the GMT/UTC timezone

Return value: A local date & time

This function convert a GMT/UTC date & time to a local date & time. The function

LocalToGMT will convert a local date & time to a GMT/UTC date & time.

Function IsFolder(Filename)

Filename: The filename to check

Return value: True if Filename has a trailing backslash

This function checks if a string has a trailing backslash, and if so, returns

True. Note that the function does not check if the file or folder actually

exists.

For example, SBSystem.IsFolder("c:\abc\def") will return False, but

SBSystem.IsFolder("c:\abc\def\") will return True.

Function LanguageCode(DomainName, ToTranslate)

DomainName: The translation domain to use (use default for SyncBack translations)

ToTranslate: The string to translate

Return value: The translated string, or ToTranslate if it cannot be translated

This function translates a string from English to the current language, assuming a translation

is available. See also AddTranslationDomain to add translations.

Function LocalToGMT(GMTTime)

LocalTime: A date & time in the local timezone

Return value: A GMT/UTC date & time

This function convert a local date & time to a GMT/UTC date & time. The function

GMTToLocal will convert a GMT/UTC date & time to a local date & time.

Function MD5(Filename)

Return value: MD5 hash value of the file, or empty string on failure

This function returns the CRC32 hash value of a file in string format. Note

that it may take a long time to calculate the hash values of large files, or

files accessed via a slow connection.

See also CRC32

Function OpenBrowser(URL)

URL: The URL of the web page to open in a browser

Return value: True if the browser was opened to display the web page

This function opens the default web browser and directs it to go to the URL

given. Note that it returns True only if the browser is opened, but it cannot

know if the URL itself is valid or accessible.

For example, SBSystem.OpenBrowser("http://www.2BrightSparks.com/")

To open a file use the function OpenFile

To check if a server can be reached use the function Ping

Function OpenFile(Filename)

Filename: The complete filename of the file to open

Return value: An error message of failure, else an empty string

This function opens a file, e.g. a text document, with the default program for

that file type, e.g. Notepad. Note that it returns an empty string only if the

appropriate program was opened, but it cannot know if the file itself was opened

by the program.

For example, SBSystem.OpenFile "c:\folder\file.txt"

On failure an error message is returned.

To open a web page use the function OpenBrowser

Function Ping(HostnameOrIP)

HostnameOrIP: An I.P. address or hostname

Return value: An error message on failure

This function 'pings' a server to see if it is accessible. Note that some

servers do not respond to ping requests (e.g. at time of writing microsoft.com

does not). If the server responds to the ping requests then an empty string is

returned, otherwise an error message is returned.

For example, SBSystem.Ping("google.com")

To check if a network drive is accessible use the function CheckNetworkDrive

Function SBCmdLineParam(ParamIdx)

ParamIdx: The command line parameter to retrieve (first param is zero)

Return value: The command line parameter, or empty string if there is no such parameter

This function retrieves the command line parameters passed to SyncBack. To get

the number of parameters use the SBCmdLineParamsCount property. Note that the

first parameter is zero (0), and the last is SBCmdLineParamsCount - 1

Function SBVersion(Filename, ByRef Major, ByRef Minor, ByRef Release, ByRef Build)

Filename: The filename of an executable, or an empty string for SyncBack

Major: The major version number of the executable

Minor: The minor version number of the executable

Release: The release version number of the executable

Build: The build version number of the executable

Return value: If an empty filename was passed then the name SyncBack is using

This function gets the version information from an executable. If Filename is

passed as an empty string then it will return the version information of

SyncBack itself. Also, passing an empty string will return the application name

of SyncBack. In some situations SyncBack may be branded under a different name.

If a filename is passed then the filename itself (stripped of the path) is

returned.

When using VBScript you must specify the type for the ByRef parameters, e.g.:

SBSystem.SBVersion Filename, CInt(Major), CInt(Minor), CInt(Release), CInt(Build))

Function SetLastModDateTime(Filename, LocalDateTime)

Filename: Complete filename of the file to change the modification date & time of

LocalDateTime: The local date & time to change the modification date & time to

Return value: An error message on failure

This function sets the last modification date & time of a file to the one

supplied. The filename must be a complete filename, and the date & time should

be in the local timezone. It returns an error message on failure.

For example, SBSystem.SetLastModDateTime("c:\folder\file.txt", Now)

Function UpdateFileStatus(Status)

Status: The file status message to display in the SyncBack main window

Return value: True if the profile is terminating

This function updates the current file status shown in the SyncBack main window.

Note that SyncBack itself will display the appropriate status messages when

files are being copied, deleted, etc. The current file status message is the

message displayed below the current status messages.

For example, SBSystem.UpdateFileStatus("Taking the stereo from your car...")

See also UpdateStatus

Function UpdateStatus(Status)

Status: The status message to display in the SyncBack main window

Return value: True if the profile is terminating

This function updates the current status shown in the SyncBack main window.

Note that SyncBack itself will display the appropriate status messages when

tasks are being performed, e.g. Scanning for changes. The status message is the

message displayed above the current file status message.

For example, SBSystem.UpdateStatus("Taking your dog for a walk...")

See also UpdateFileStatus

Property LanguageCode

This property returns the language code of the user interface, e.g. "en" for

English. See also AddTranslationDomain and TranslateString

This is a read-only property.

Property NoDesktop

This property returns True if there is a desktop. It would return False, for

example, if no user is currently interactively logged in, or if a different

user is currently interactively logged in.

This is a read-only property.

Property ProfileCount

This property returns the number of profiles. To retrieve the names of the

profiles use GetProfileName

This is a read-only property.

Property SBCmdLineParamsCount

This property returns the number of command line parameters passed to SyncBack.

The parameters themselves can be retrieved using the SBCmdLineParam function.

This is a read-only property.

Property SBFilename

This property returns the complete filename of the SyncBack program.

This is a read-only property.

Property ScriptFilename

This property returns the complete filename of the script itself. This should

not be stored as it may change, e.g. if imported onto another computer then the

path may be different. To get just the path the script is in use ScriptPath

This is a read-only property.

Property ScriptPath

This property returns the path (directory) the script itself is in. This should

not be stored as it may change, e.g. if imported onto another computer then the

path may be different. To get the complete filename of the script use the

function ScriptFilename

This is a read-only property.

Property UniqueID

This property returns a universally unique 32 character long string.

This is a read-only property.

Sub AddTranslationDomain(DomainName)

DomainName: The name of the translation domain

This function adds a custom translation domain so that a script can provide

its own translations for strings. Strings are translated using TranslateString.

A domain is the name of a .MO translation file (without the .MO extension). The

.MO file must be placed into the appropriate \locale\[language code]\LC_MESSAGES\

sub-folders of the SyncBack installation folder. There should be a .MO file

for each language that strings can be translated into. MO files are created

using the freeware POEdit program.

See the TranslationExample.vbs for an example.

Sub Say(ToSay)

ToSay: What the computer should say, or the filename of a .WAV file

This subroutine uses the speech engine in Windows to have the computer say what

you request. It can also be used to play .WAV files (by passing the filename).

For example, SBSystem.Say "2 bright sparks rock my world"

Sub Sleep(Seconds)

Seconds: The number of seconds to sleep

This function sleeps for the specified number of seconds. Note that you should

not sleep for more than a few seconds in case the user wants to abort. The

script (and profile or anything else) cannot abort while sleeping.

For example, SBSystem.Sleep 2

See also SBRunning.Sleep


SBVariables

These are functions that can be accessed from scripts via the SBVariables object. For example:

SBSystem.SetProperty "MyVar", "Value"

The SBVariables object is accessible from Main Interface, Runtime and Profile Configuration scripts.

Function Count()

Return value: The number of variables defined

This function returns the number of variables defined.

Function GetGlobalProperty(PropName, PropDefault, Internal)

PropName: The name of the property

PropDefault: The value to return if the property does not exist

Internal: Pass True to retrieve properties that SyncBack uses, otherwise it's a property created by a script

Return value: The value of the property (as a string) or an empty string on error

This function retrieves a global property (setting) value. This is different

from GetProperty and GetProfileProperty because

those are used with profiles (the property is profile specific).

Note that PropName must be a single property name.

To check if a property exists or not pass a default value that cannot be valid,

e.g.

If SBVariables.GetGlobalProperty("PropName", "!NOTEXIST!", False) = "!NOTEXIST!" Then

' Does not exist

Else

' Exists

End If

See also SetGlobalProperty

Function GetProfileProperty(ProfileName, PropName, PropDefault, Internal)

ProfileName: The name of the profile to read the property from

PropName: The name of the property

PropDefault: The value to return if the property does not exist

Internal: Pass True to retrieve properties that SyncBack uses, otherwise it's a property created by a script

Return value: The value of the property (as a string) or an empty string on error

This function retrieves a profile property (setting) value from a specific

profile. It works the same way as GetProfileProperty except you can specify

the profile.

See also SetProfileProperty

Function GetProperty(PropName, PropDefault, Internal)

PropName: The name of the property

PropDefault: The value to return if the property does not exist

Internal: Pass True to retrieve properties that SyncBack uses, otherwise it's a property created by a script

Return value: The value of the property (as a string) or an empty string on error

This function retrieves a profile property (setting) value. The difference

between properties and variables is that properties are stored as part of the

profiles settings, but variables are not. That means their value is kept between

profile runs. Note that PropName must be a single property name.

To check if a property exists or not pass a default value that cannot be valid,

e.g.

If SBVariables.GetProperty("PropName", "!NOTEXIST!", False) = "!NOTEXIST!" Then

' Does not exist

Else

' Exists

End If

See also SetProperty

Note that this function will do nothing if called from a Main Interface script.

You must use the GetProfileProperty function.

Function GetVar(VarName)

VarName: A string containing variables

Return value: VarName with the variables expanded

This function retrieves a variable value. The difference between properties and

variables is that properties are stored as part of the profiles settings, but

variables are not. Also, variables like environment variables are set by the

operating system or other programs.

VarValue1 = SBVariables.GetVar("%USERPROFILE%")

VarValue1 = SBVariables.GetVar("Username is %USERNAME% and profile is %USERPROFILE%")

See also SetProperty, GetVarName, and SetVar

Function GetVarName(Idx, ByRef Value)

Idx: The number of the variable to get the name of (0=first variable)

Value: Value is set to the value of the variable

Return value: The name of the variable, or empty string on failure

This function retrieves the name of a variable. The first variable is variable

zero (0). SBVariables.Count returns the number of variables defined.

When using VBScript you must define the parameter type for Value, e.g.:

VarName = SBVariables.GetVarName(0, CStr(VarValue))

Function SetGlobalProperty(PropName, NewPropValue)

PropName: The name of the property

NewPropValue: The new value of the property

Return value: The new value of the property (as a string) or an empty string on error

This function sets a global property (setting) value. This is different from

SetProperty and SetProfileProperty because

those are used with profiles (the property is profile specific).

Note that PropName must be a single property name. See GetGlobalProperty

for retrieving global property values.

See DeleteGlobalProperty to delete global properties.

Note that you cannot change internal SyncBack properties.

Function SetProfileProperty(ProfileName, PropName, NewPropValue)

PropName: The name of the profile to delete the property from

PropName: The name of the property

NewPropValue: The new value of the property

Return value: The new value of the property (as a string) or an empty string on error

This function sets a profile property (setting) value for a specific profile.

It works the same way as SetProperty except a profile can be

specified. See GetProfileProperty for retrieving property values from

a specific profile and DeleteProfileProperty to delete properties

from a speficic profile.

Note that you cannot change internal SyncBack properties.

Function SetProperty(PropName, NewPropValue)

PropName: The name of the property

NewPropValue: The new value of the property

Return value: The new value of the property (as a string) or an empty string on error

This function sets a profile property (setting) value. Note that PropName must

be a single property name. See GetProperty for retrieving property values.

See DeleteProperty to delete properties, and SetProfileProperty to

set the property for a specific profile.

Note that you cannot change internal SyncBack properties.

Note that this function will do nothing if called from a Main Interface script.

You must use the SetProfileProperty function.

Function SetVar(VarName, NewVarValue)

VarName: The name of the variable to set

NewVarValue: The new value of the variable

Return value: The new value of the variable (string) or an empty string on failure

This function sets the value of a variable. Note that variables cannot be

deleted.

SBVariables.SetVar("MyVariable", "The value")

See also GetVar

Sub DeleteGlobalProperty(PropName)

PropName: The name of the property to delete

This subroutine deletes a global property (setting) value. This is different

from DeleteProperty and DeleteProfileProperty because

those are used with profiles (the property is profile specific).

Note that PropName must be a single property name, and you cannot delete

internal SyncBack properties.

Sub DeleteProfileProperty(ProfileName, PropName)

ProfileName: The name of the profile to delete the property from

PropName: The name of the property to delete

This subroutine deletes a profile property (setting) value from a specific

profile. Note that PropName must be a single property name.

Note that you cannot delete internal SyncBack properties.

See also DeleteProperty

Sub DeleteProperty(PropName)

PropName: The name of the property to delete

This subroutine deletes a profile property (setting) value. Note that PropName

must be a single property name.

Note that you cannot delete internal SyncBack properties.

Note that this function will do nothing if called from a Main Interface script.

You must use the DeleteProfileProperty function.


Constants

These are constant values.

Abilities

The following are location abilities. Note that some of these cannot be

returned by LocAbilities:

1 = Does the location use Windows folders? Normal & Multi-Zip do. Cannot be used by LocAbilities().

2 = Can the directory attributes and date & times be copied to a new directory? Normal and Multi-Zipon NTFS can. Cannot be used by LocAbilities().

4 = Can file/folder NTFS security be copied? Normal and Multi-Zipon NTFS can. Cannot be used by LocAbilities().

8 = Can the BackupRead/BackupWrite API's be used? Normal on NTFS only. Cannot be used by LocAbilities().

16 = Can use MD5 hashing? Normal only. Cannot be used by LocAbilities().

32 = Do files/folders have Windows filesystem attributes? (CAN_USEATTRIBUTES)

64 = Are file dates & times stored exactly (including milli-seconds)? (CAN_EXACTDATETIME)

128 = Can file/folder attributes be changed? (CAN_CHANGEATTRIBUTES)

256 = Can file/folder last modification date & times be changed? (CAN_CHANGEDATETIME)

512 = Are all the files stored in a single Zip file? Cannot be used by LocAbilities().

1024 = Can the base path be empty? (CAN_HAVEEMPTYPATH)

2048 = Is the location on a Windows filesystem? e.g. a drive or UNC path. Cannot be used by LocAbilities().

4096 = Does the location support versioning? (CAN_VERSION)

8192 = Are files stored on a Windows filesystem uncompressed etc? Only Normal location. Cannot be used by LocAbilities().

16384 = Files & folders have NTFS extended attributes? (CAN_NTFSATTRIBUTES)

32768 = Accessed via a drive letter? This is different from CAN_STOREDONWINDOWS because the CD/DVD burner uses a drive letter but you cannot read from it. Cannot be used by LocAbilities().

65536 = Write-once, meaning cannot read from it only write to it, e.g. burn location and spanned/split zip (CAN_WRITEONCE)

131072 = Can files & folders be moved? (CAN_MOVE)

262144 = Can use CRC32 hashing? (CAN_USECRC32)

Actions

The following are actions that can be performed on files and folders (note that

many of these cannot be used with folders):

0 = Skip the file - there was an error (CACTION_ERROR)

1 = Do nothing, skip/ignore the file (CACTION_SKIP)

2 = Copy from right/destination to the left/source (CACTION_COPY_TOSOURCE)

3 = Copy from left/source to the right/destination (CACTION_COPY_TODEST)

4 = Delete from left/source (CACTION_DELSOURCE)

5 = Delete from right/destination (CACTION_DELDEST)

6 = Delete left/source & right/destination (CACTION_DELBOTH)

7 = A file is in left/source or right/destination, but not both, prompt the user (CACTION_MISSING_PROMPT)

8 = Contents same, but attributes and/or date & time changed, prompt the user (CACTION_DETAILS_PROMPT)

9 = The file has changed in both, prompt the user (CACTION_BOTH_PROMPT)

10 = Use the file attributes, security, and/or date & time from the left/source (CACTION_USE_SRC_DETAILS)

11 = Use the file attributes, security, and/or date & time from the right/destination (CACTION_USE_DEST_DETAILS)

12 = Move from right/destination to the left/source (CACTION_MOVE_TOSOURCE)

13 = Move from left/source to the right/destination (CACTION_MOVE_TODEST)

14 = The file is actually unchanged (for Fast Backup only) (CACTION_UNCHANGED)

15 = Rename the left/source file (for SmartSync only) (CACTION_RENAME_SOURCE)

16 = Rename the right/destination file (for SmartSync only) (CACTION_RENAME_DEST)

Differences

The following are differences. Note that the values can be or'ed together if

there is more than one difference:

0 = Skipped because of settings or files are identical (CDIFF_IDENTICAL)

1 = Different sizes (CDIFF_SIZE)

2 = Different hash values (CDIFF_HASH)

4 = Different modification date & time (CDIFF_DATETIME)

8 = In right/destination only (CDIFF_DESTONLY)

16 = In left/source only (CDIFF_SRCONLY)

32 = Different attributes (CDIFF_ATTRIB)

64 = Only the versions exist (will show in Differences window) (CDIFF_VERSION)

IgnoredReason

The following are reasons why a file or folder is ignored:

0 = Unknown (EIRUnknown)

1 = Not select in folder & file selectin tree (EIRNotSelected)

2 = File/folder does not exist (EIRDoesNotExist)

3 = Is a junction point and settings say they are to be ignored (EIRJunctionPoint)

4 = A new folder and parent folder settings say new folders are to be ignored (EIRNewFolder)

5 = A new file and parent folder settings say new files are to be ignored (EIRNewFile)

6 = Filtered out due to filter settings (EIRFiltered)

7 = File is not a Zip file (when multi-zip and a non-zip file is found) (EIRNotZipFile)

8 = Skipped due to error (EIRError)

9 = Wasn't modified within the required time (EIRNotModifiedWithin)

10 = File size is too small or too large (EIRSizeOutOfBounds)

11 = The source & destination file are the same (EIRIdentical)

12 = Many reasons, e.g. in destination but not source (EIRAdvancedSetting)

13 = Old file (only in source or dest) not deleted as it's not old enough (EIRNotOldEnoughToDelete)

14 = Source cannot be modified, e.g. Fast Backup (EIRCannotModifySource)

15 = The destination file is newer so cannot be replace (EIROtherFileNewer)

16 = The destination file is read-only so cannot be replace (EIRCannotReplaceReadOnly)

17 = The destination file is read-only so cannot be deleted (EIRCannotDelReadOnly)

18 = Source is read-only so cannot be copied (EIRCannotMoveCopyReadOnly)

19 = Source file does not have archive attribute set so cannot be copied (EIRCannotMoveCopyNotAttrib)

20 = Source file does not have hidden attribute set so cannot be copied (EIRCannotMoveCopyHidden)

21 = Source file does not have system attribute set so cannot be copied (EIRCannotMoveCopySystem)

22 = Not copied due to DST time difference (EIRDST)

23 = Files same size (EIRSameSize)

24 = Ignored by script (EIRScript)

ProfileTypes

The following are profile types:

0 = Error (EPTError)

1 = Unknown profile type (EPTUnknown)

2 = Custom (EPTCustom)

3 = Backup from source to destination (EPTBackupFromSrc)

4 = Backup from destination to source (EPTBackupFromDest)

5 = Sync (old style) (EPTOldSync)

6 = SmartSync (EPTSmartSync)

7 = Group (EPTGroup)

8 = Mirror from source to destination (EPTMirrorRight)

9 = Mirror from destination to source (EPTMirrorLeft)

Results

The following are profile run results:

0 = No result (ELR_None)

1 = Unknown profile (ELR_UnknownProfile)

2 = Profile is already running (ELR_AlreadyRunning)

3 = Profile has been imported and not run yet (ELR_Imported)

4 = Profile is running (ELR_Running)

5 = Internal error (ELR_InternalError)

6 = Simulated run was aborted (ELR_SimAborted)

7 = Simulated run failed (ELR_SimFailed)

8 = Simulated run was a success (ELR_SimSuccess)

9 = Restore was aborted (ELR_RestAborted)

10 = Restore failed (ELR_RestFailed)

11 = Restore was a success (ELR_RestSuccess)

12 = Run was aborted (ELR_Aborted)

13 = Run failed (ELR_Failed)

14 = Run was a success (ELR_Success)

15 = Failed due to network connection (ELR_NetFailed)

16 = Failed because left or right could not be scanned (ELR_ScanFailed)

17 = Failed because the left and right could not be compared (ELR_CompFailed)

18 = Run failed because Run Before program stopped profile (ELR_RunBeforeFailed)

19 = Run failed because profile is disabled (ELR_Disabled)

20 = Run failed because drive errors were found (ELR_SMARTFailed)

21 = Run failed because the log could not be emailed (ELR_EmailFailed)

22 = Run failed because the Volume Shadow Copy service failed (ELR_SnapshotFailed)


Example Scripts

SyncBackSE comes with following example scripts:

· AllDrives.vbs: This is a location script which gives access to all the drives on a computer. This means you could use it as your source or destination, set the base directory to \, and then choose files and folders from multiple drives.

· CreateRestorePoint.vbs: This is a runtime script which creates a system restore point in Windows whenever the profile is run.

· DecryptCopy.vbs: This is a runtime script which will remove the NTFS encryption from the copy of files. For example, you may have a profile that does a backup from one NTFS partition to another, but you may not want the backup copies to be encrypted. This should only be used in profiles that copy to NTFS partitions. See all the EncryptCopy.vbs script.

· EncryptCopy.vbs: This is a runtime script which will NTFS encrypt the copies of files. For example, you may have a profile that does a backup from one NTFS partition to another, and want the backup copies to be NTFS encrypted. This should only be used in profiles that copy to NTFS partitions. See all the DecryptCopy.vbs script.

· ExtraInfo.vbs: This is both a runtime and main interface script. It adds a column to the main interface that shows how many files were copied, deleted, etc. in the last profile run. Note that after installing it you must both enable it (as a main interface script), and also configure your profiles to use the script.

· IncVar.vbs: This is a runtime script that shows how to create and use your own variables in a profile, and also how to set when a rescan for a Fast Backup profile should be performed. Edit the script before using it.

· MOTD.vbs: This is a main interface script that shows a "Message of the day". Edit the script before using it.

· OncePerDay.vbs: This is a runtime script that shows how to restrict a profile so that it can only be run at most once per day.

· WaitForFinish.vbs: This is a runtime script that stops a profile from starting until a program has finished (or isn't running). Edit the script before using it.


Legal Information

Legal Documentation

Please read the following legal documentation which presents 2BrightSparks Pte Ltd's policies on licensing and distribution.

Distribution

Privacy Statement

General Terms

Credits


Distribution

Software Distribution Agreement for SyncBackSE Shareware Version

This Software Distribution Agreement (hereinafter referred to as "AGREEMENT") is a legal AGREEMENT between you, and 2BrightSparks Pte Ltd (hereinafter referred to as "AUTHOR") for distributing the computer software program entitled SyncBackSE (hereinafter referred to as "SOFTWARE").

This AGREEMENT describes the terms and conditions by which AUTHOR will license other parties to distribute the SOFTWARE which is intended solely for distribution as SHAREWARE. No use, distribution or reproduction of the SOFTWARE or copies of the SOFTWARE is authorized except in compliance with the terms and conditions herein. Distribution of the SOFTWARE in accordance with the provisions of this Software Licence Agreement is encouraged.

You should carefully read the following terms and conditions before distributing this SOFTWARE. Unless you have a different licence AGREEMENT signed by AUTHOR, your use of this SOFTWARE indicated your acceptance of this licence AGREEMENT.

By copying or distributing this SOFTWARE, you agree to be bound by the terms and conditions of this AGREEMENT as well as those of the "Software Licence Agreement".

GENERAL DEFINITIONS

As stated, the SOFTWARE is marketed as SHAREWARE.

Definition of Shareware

Shareware distribution gives users a chance to try software before buying it. If you try a Shareware program and continue using it, you are required to register it (or purchase the Licensed version).

Copyright laws apply to both Shareware and retail software, and the copyright holder retains all rights, with a few specific exceptions as stated below. The author specifically grants the right to copy and distribute the software, either to all and sundry or to a specific group.

Shareware is a distribution method, not a type of software.

GENERAL TERMS AND CONDITIONS

• AUTHOR shall be credited as the owner of the SOFTWARE in all distribution of the SOFTWARE. AUTHOR is the exclusive world-wide licenser of the SOFTWARE, and the copyrights and other proprietary rights therein. The SOFTWARE is intended solely for distribution as SHAREWARE (i.e., try-before-you-buy software); it is not public domain or free software or freeware.

• The SOFTWARE shall be identified by name and shall be identified as SHAREWARE in all distribution.

• You may copy and/or distribute the SOFTWARE only in its original, unaltered form, with all files included unmodified, and without making any additions, modifications or deletions except as provided in this paragraph. You may not modify the SOFTWARE or any of its files, and the SOFTWARE must be distributed as a complete package. You may not change, delete, merge or rename any files or elements of the SOFTWARE in any manner, and you may not add any files or new elements (except for installation routines which do not interfere with the proper operation or installation of the SOFTWARE).

• Since the SOFTWARE is intended for distribution only as SHAREWARE, you shall not charge any fee or other compensation for the SOFTWARE, although you may charge a distribution fee for costs associated with distributing the SOFTWARE. You are permitted, and encouraged, to make and distribute copies of the SOFTWARE to your friends, family members and co-workers for your and their private non-commercial use, in compliance with the terms and conditions hereof.

• You recognize that your right to distribute the SOFTWARE is nonexclusive and that AUTHOR can terminate the license granted to you at any time for any reason upon notice. AUTHOR reserves the right to withhold or withdraw permission to distribute the SOFTWARE from anyone at any time for any reason. The other provisions hereof shall survive any expiration or termination of this AGREEMENT.

• You shall take reasonable steps to ensure that the SOFTWARE and any other software, documentation and other materials distributed with the SOFTWARE are free from viruses.

• You may not use, copy, modify, distribute or transfer the SOFTWARE or any element thereof in whole or in part, except as expressly provided for herein.

• You may not rent or lease the SOFTWARE to anyone.

• AUTHOR reserves the right to update the contents of the SOFTWARE and its associated files, documentation and/or other elements, at its discretion from time to time, without the consent of, or any obligation to, any licensed users or distributors.

• You will hold AUTHOR, family members, distributors, licensees, sub-licensees and lawyers harmless from and against any and all claims, actions, damages, losses, liabilities, costs and expenses arising directly or indirectly from your acts and omissions in copying and distributing the SOFTWARE.

• If any provision of this AGREEMENT is held to be void, invalid or unenforceable, it will not affect the validity of the balance of this AGREEMENT, which shall remain valid and enforceable according to its terms and conditions.

• This agreement shall be governed by the laws of the United Kingdom.

SPECIAL TERMS AND CONDITIONS

• Distribution by BBS, on-line Services, FTP, FSP, News, WWW, Satellite, Other File Transfer Protocols: The SOFTWARE and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Floppy Disk / CD-ROM / DVD / Other Disk Types in a non-retail environment: The SOFTWARE and associated files may be copied, and used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Floppy Disk / CD-ROM / DVD / Other Disk Types by Anonymous access FTP/WWW Shareware Archives: The SOFTWARE and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Magazine Companion Disk / CD-ROM / Other Disk Types: The program and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with. We would greatly appreciate if you would inform 2BrightSparks about any review(s) you write about the SOFTWARE. Thanks.

• Distribution in a Retail Environment, Book Companion Disk / CD-ROM / Other Disk Types (Book): You may not distribute the program without obtaining explicit permission from AUTHOR.

• Other (e.g. Retail not covered above) CD-ROM Shareware Distribution: You may not distribute the program without obtaining explicit permission from AUTHOR.

• Internet Providers Disk / CD-ROM / Demo Disks / Connection Kits / etc.: You may distribute this SOFTWARE on your disk/CD only as bundled shareware with other programs without charge and permission as long as the "General Terms and Conditions" set forth above are complied with. If you intend to provide the program for your own diagnostic purposes then you may not distribute the program without obtaining explicit permission from the AUTHOR.

• Software/Hardware Manufacturers & Suppliers: You may not distribute the program pre-installed or otherwise on the machines you manufacture/distribute/etc. or bundled with your own products without obtaining explicit permission from AUTHOR.

• Other Type of Distribution: Please contact AUTHOR for details.

BY DISTRIBUTING THE SOFTWARE YOU ACKNOWLEDGE THAT YOU HAVE READ AND UNDERSTOOD THIS AGREEMENT AND YOU AGREE TO BE BOUND BY THIS AGREEMENT'S TERMS AND CONDITIONS. YOU ALSO AGREE THAT THIS AGREEMENT IS THE COMPLETE AND EXCLUSIVE STATEMENT OF THE RIGHTS AND LIABILITIES OF THE PARTIES AND SUPERSEDES ALL PROPOSALS OR PRIOR AGREEMENTS, ORAL OR WRITTEN AND ANY OTHER COMMUNICATION BETWEEN THE PARTIES RELATING TO THE SUBJECT MATTER OF THIS AGREEMENT.


Privacy Statement

Privacy Statement

We have created this privacy statement in order to demonstrate our firm commitment to privacy. The following discloses our information gathering and dissemination practices for 2BrightSparks.

We use your IP address to help diagnose problems with our server, and to administer our website. Your IP address is used to help identify you and to gather broad demographic information.

Cookies

We use cookies to identify you so we can retrieve your information so you don't have to re-enter it each time you visit our site. We also use cookies to help ensure our surveys are only completed once.

Subscriptions

Our site's Support Ticketing, Mailing List, and other forms requires users to give us contact information, like their name and email address. We use customer contact information from forms to send the user information about 2BrightSparks. The customer's contact information is also used to contact the visitor when necessary if they have subscribed to the Mailing List. Users may opt-out of receiving future mailings by choosing to nun-subscribe. Unique identifiers are collected to verify the user's identity and for use in our record system.

Collecting Unique Identifiers

2BrightSparks and its associated Web Store uses an order form for customers to request information, products, and services. We collect visitor's contact information and unique identifiers. Contact information from the order form is used to send orders and information about our company to our customers. The customer's contact information is also used to get in touch with the visitor when necessary. Users may opt-out of receiving future mailings. Unique identifiers are collected from website visitors to verify the user's identity and for use as account numbers in our record system.

External Linking

2BrightSparks contains links to other sites. We are not responsible for the privacy practices or the content of such websites.

Security

This site has security measures in place to protect the loss, misuse and alteration of the information under our control. All data is protected using the most advanced methods available. We do not store financial information like credit card numbers or personal information like social security numbers on this site.

Un-Subscribe

2BrightSparks gives users the option to contact us for removing their information from our database to not receive future communications or to no longer receive mail list messages.

Correct/Update

You can send an email to us by visiting our Support Area to change and/or modify information previously provided.

Additional Information

Why we use cookies

A cookie is a small data file that certain Web sites write to your hard drive when you visit them. A cookie file can contain information such as a user ID that the site uses to track the pages you have visited. The only personal information a cookie can contain is information you supply yourself. A cookie can't read data off your hard disk or read cookie files created by other sites.

We use cookies to assists in searches. Cookies further enhance our service by enabling us to fast-track much of our User's browsing habits with the aim of improving our services.

Do you share data with outside companies and/or organisations?

No. we do not share any 'off-line data' with any commercial entity (e-mail addresses collected for our mailing list, and any data collected for purposes other than for on-line publication on our website).

We only disclose data when required to do so by International law.


General Terms

2BrightSparks Pte Ltd: General Terms and Conditions

Last Modified: 17 June 2008

Products, Services, and Conditions of Use

You should carefully read the following Terms and Conditions before using our software products. Unless you have a different license agreement signed by 2BrightSparks, your use of our software indicates your acceptance of this license agreement and warranty.

Use of all software available from 2BrightSparks (hereinafter 'SOFTWARE') is contingent on your agreement our software licensing terms found on this web page.

As part of our service, we agree to provide you with software, information, and other services that we may decide to offer, subject to the terms of this agreement. Upon notice published through the service, we may modify this agreement at any time. You agree and continue to agree to use our products and services in a manner consistent with all applicable laws and regulations and in accordance with the terms and conditions set out in the policies and guidelines outlined below. Please note that you will be referred to as 'customer' in this agreement.

Limitation Of Liability And Warranty

The customer agrees that use of the services and products provided by 2BrightSparks is entirely at the customer's own risk. Services and products are provided 'as is,' without warranty of any kind, either express or implied, including without limitation any warranty for information, services, uninterrupted access, or products provided through or in connection with the service, including without limitation the software licensed to the customer and the results obtained through the service. Specifically, we disclaim any and all warranties, including without limitation: 1) any warranties concerning the availability, accuracy or content of information, products or services; and 2) any warranties of title or warranties of merchantability or fitness for a particular purpose.

This disclaimer of liability applies to any damages or injury caused by any failure of performance, error, omission, interruption, deletion, defect, delay in operation or transmission, computer virus, communication line failure, theft or destruction or unauthorized access to, alteration of, or use of record, whether for breach of contract, tortious behavior, negligence, or under any other cause of action. Customer specifically acknowledges the service is not liable for the defamatory, offensive or illegal conduct of other customers or third-parties and that the risk of injury from the foregoing rests entirely with customer.

Neither the software, products or services delivered by 2BrightSparks, nor any of its agents, affiliates or content providers shall be liable for any direct, indirect, incidental, special or consequential damages arising out of use of it or inability to gain access to or use the software or out of any breach of any warranty. Customer hereby acknowledges that the provisions of this section shall apply to all content on the service.

Governing Law

This agreement shall be governed by the laws of Singapore.

Trademarks

All trademarks appearing on the service are trademarks of their respective owners.

Modification

2BrightSparks reserves the right, at its discretion, to revise these Terms and Conditions at any time and without prior notice, and such revision shall be effective immediately upon the posting of the revised Terms and Conditions at the company website:

http://www.2brightsparks.com/terms.html

Software License Agreement

You should carefully read the following Terms and Conditions before using our software products. Unless you have a different license agreement signed by 2BrightSparks, your use of our software indicates your acceptance of this license agreement and warranty.

Use of all software available from 2BrightSparks (hereinafter 'SOFTWARE') is contingent on your agreement our software licensing terms found on this web page.

SyncBackSE Licensing Terms and Conditions

You are advised to revisit the following web page periodically as we reserve the right to change these terms and conditions at any time and without notification:

CONDITIONS OF USE

You agree and continue to agree to use our software in a manner consistent with all applicable laws and regulations and in accordance with the terms and conditions set out in the policies and guidelines outlined below.

Please note that you will be referred to as 'customer' in this agreement.

SOFTWARE LICENSE AGREEMENT

You should carefully read the following Terms and Conditions before using SyncBackSE. Unless you have a different license agreement signed by 2BrightSparks Pte Ltd, your use of our software indicates your acceptance of this license agreement.

Use of all software available from 2BrightSparks Pte Ltd, including SyncBackSE, (hereinafter 'SOFTWARE') is contingent on your agreement to the following terms:

LIMITATION OF LIABILITY

The use of all software including SyncBackSE available from 2BrightSparks Pte Ltd ('SOFTWARE') is contingent on your agreement to the following Limitation of Liability:

SOFTWARE is provided as is, and without warranty of any kind. To the maximum extent permitted by applicable law, 2BrightSparks Pte Ltd its suppliers, its distributors, and its affiliates, or others who may offer SOFTWARE, will not be liable for any damages whatsoever, whether direct or indirect, special, incidental, consequential, or punitive of any kind (including but not limited to damages for: loss of profits, loss of confidential or other information, business interruption, personal injury, loss of privacy, failure to meet any duty - including of good faith or of reasonable care - negligence, and any other pecuniary or other loss whatsoever) arising out of, or in any way related to the use of, or inability to use our SOFTWARE or support services, or the provision of or failure to provide support services, or otherwise under, or in connection with SOFTWARE documentation, or any provision of these terms and conditions, even if 2BrightSparks Pte Ltd or any supplier, distributor, or its affiliates has been advised of the possibility of such damages.

The Limitations on, and Exclusions of liability for damages in this agreement apply regardless of whether liability is based on breach of contract, tort (including negligence), delict, strict liability, breach of warranties or conditions, or any other legal theory. 2BrightSparks Pte Ltd furthermore disclaims all warranties, including without limitation any implied warranties of merchantability, fitness for a particular purpose, and on infringement.

The entire risk arising out of the use or performance of the SOFTWARE and documentation remains with the recipient. To the maximum extent permitted by applicable law, in no event shall 2BrightSparks Pte Ltd Pte Ltd be liable for any consequential, incidental, direct, indirect, special, punitive, or other damages whatsoever (including, without limitation, damages for loss of business profits, business interruption, loss of business information, or other pecuniary loss) arising out of this agreement or the use of or inability to use the product, even if 2BrightSparks Pte Ltd has been advised of the possibility of such damages.

The SOFTWARE and the accompanying files are sold "as is" and without warranties as to performance or merchantability or any other warranties whether expressed or implied. Because of the various hardware and software environments into which SOFTWARE may be put, no warranty of fitness for a particular purpose is offered.

Good data processing procedure dictates that any program be thoroughly tested with non-critical data before relying on it. The user must assume the entire risk of using the SOFTWARE. Any liability of the seller will be limited exclusively to product replacement or refund of purchase price.

OWNERSHIP

You may not reverse engineer, decompile or disassemble the SOFTWARE. 2BrightSparks Pte Ltd shall retain title and all ownership rights to the SOFTWARE.

COPYRIGHT

This SOFTWARE is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties.

MAINTENANCE

2BrightSparks Pte Ltd is not obligated to provide support, maintenance, or updates for the SOFTWARE (either by email, phone, or otherwise). However, any maintenance or updates provided by 2BrightSparks Pte Ltd shall be covered by this Agreement.

SOFTWARE USAGE AGREEMENT

One registered copy of SOFTWARE may either be used by a single person who uses the software personally on up to 5 computers for non-commercial use (home). A separate license must be purchased for each installation of the program for commercial use. Installing the program on a server counts as one installation.

In a commercial setting you may access the registered version of the SOFTWARE through a network, provided that you have obtained individual licenses for the SOFTWARE covering all workstations that will access the software through the network. For instance, if 4 different workstations access the SOFTWARE on the network, each workstation must have its own SOFTWARE license, regardless of whether they use the SOFTWARE at different times or concurrently.

RETURNS POLICY

Before purchasing software from 2BrightSparks Pte Ltd, you are strongly encouraged to 'test drive' it using the evaluation version. In the event you encounter a problem with the product, contact our support department for assistance. You may do this by submitting a Support Ticket in our Support Area at:

http://www.2brightsparks.com/help/

After your purchase, refunds will only be given at the discretion of the Company Management.

EVALUATION AND REGISTRATION

Subject to the terms of this agreement, you are hereby licensed to use the SOFTWARE for evaluation purposes without charge. The evaluation version of the SOFTWARE has limitations and reminders that the SOFTWARE is in use. For a full-featured, unrestricted version, a registration fee is required. Upon payment you will be sent an email that will provide the Serial Number to unlock the SOFTWARE.

SyncBackSE DISTRIBUTION AGREEMENT

This Software Distribution Agreement (hereinafter referred to as "AGREEMENT") is a legal AGREEMENT between you, and 2BrightSparks Pte Ltd (hereinafter referred to as "AUTHOR") for distributing the computer software program entitled SyncBackSE (hereinafter referred to as "SOFTWARE").

This AGREEMENT describes the terms and conditions by which AUTHOR will license other parties to distribute the SOFTWARE which is intended solely for distribution as SHAREWARE. No use, distribution or reproduction of the SOFTWARE or copies of the SOFTWARE is authorised except in compliance with the terms and conditions herein. Distribution of the SOFTWARE in accordance with the provisions of this Software Licence Agreement is encouraged.

You should carefully read the following terms and conditions before distributing this SOFTWARE. Unless you have a different licence AGREEMENT signed by AUTHOR, your use of this SOFTWARE indicated your acceptance of this licence AGREEMENT.

By copying or distributing this SOFTWARE, you agree to be bound by the terms and conditions of this AGREEMENT as well as those of the "Software Licence Agreement".

GENERAL DEFINITIONS

As stated, the SOFTWARE is marketed as SHAREWARE.

Definition of Shareware

Shareware distribution gives users a chance to try software before buying it. If you try a Shareware program and continue using it, you are required to register it (or purchase the Licensed version).

Copyright laws apply to both Shareware and retail software, and the copyright holder retains all rights, with a few specific exceptions as stated below. The author specifically grants the right to copy and distribute the software, either to all and sundry or to a specific group.

Shareware is a distribution method, not a type of software.

GENERAL TERMS AND CONDITIONS

• AUTHOR shall be credited as the owner of the SOFTWARE in all distribution of the SOFTWARE. AUTHOR is the exclusive world-wide licenser of the SOFTWARE, and the copyrights and other proprietary rights therein. The SOFTWARE is intended solely for distribution as SHAREWARE (i.e., try-before-you-buy software); it is not public domain or free software or freeware.

• The SOFTWARE shall be identified by name and shall be identified as SHAREWARE in all distribution.

• You may copy and/or distribute the SOFTWARE only in its original, unaltered form, with all files included unmodified, and without making any additions, modifications or deletions except as provided in this paragraph. You may not modify the SOFTWARE or any of its files, and the SOFTWARE must be distributed as a complete package. You may not change, delete, merge or rename any files or elements of the SOFTWARE in any manner, and you may not add any files or new elements (except for installation routines which do not interfere with the proper operation or installation of the SOFTWARE).

• Since the SOFTWARE is intended for distribution only as SHAREWARE, you shall not charge any fee or other compensation for the SOFTWARE, although you may charge a distribution fee for costs associated with distributing the SOFTWARE. You are permitted, and encouraged, to make and distribute copies of the SOFTWARE to your friends, family members and co-workers for your and their private non-commercial use, in compliance with the terms and conditions hereof.

• You recognise that your right to distribute the SOFTWARE is nonexclusive and that AUTHOR can terminate the license granted to you at any time for any reason upon notice. AUTHOR reserves the right to withhold or withdraw permission to distribute the SOFTWARE from anyone at any time for any reason. The other provisions hereof shall survive any expiration or termination of this AGREEMENT.

• You shall take reasonable steps to ensure that the SOFTWARE and any other software, documentation and other materials distributed with the SOFTWARE are free from viruses.

• You may not use, copy, modify, distribute or transfer the SOFTWARE or any element thereof in whole or in part, except as expressly provided for herein.

• You may not rent or lease the SOFTWARE to anyone.

• AUTHOR reserves the right to update the contents of the SOFTWARE and its associated files, documentation and/or other elements, at its discretion from time to time, without the consent of, or any obligation to, any licensed users or distributors.

• You will hold AUTHOR, family members, distributors, licensees, sub-licensees and lawyers harmless from and against any and all claims, actions, damages, losses, liabilities, costs and expenses arising directly or indirectly from your acts and omissions in copying and distributing the SOFTWARE.

• If any provision of this AGREEMENT is held to be void, invalid or unenforceable, it will not affect the validity of the balance of this AGREEMENT, which shall remain valid and enforceable according to its terms and conditions.

• This agreement shall be governed by the laws of the United Kingdom.

SPECIAL TERMS AND CONDITIONS

• Distribution by BBS, on-line Services, FTP, FSP, News, WWW, Satellite, Other File Transfer Protocols: The SOFTWARE and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Floppy Disk / CD-ROM / DVD / Other Disk Types in a non-retail environment: The SOFTWARE and associated files may be copied, and used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Floppy Disk / CD-ROM / DVD / Other Disk Types by Anonymous access FTP/WWW Shareware Archives: The SOFTWARE and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with.

• Distribution on Magazine Companion Disk / CD-ROM / Other Disk Types: The program and associated files may be copied, used and posted without charge and permission as long as the "General Terms and Conditions" set forth above are complied with. We would greatly appreciate if you would contact us about any review(s) you write about the SOFTWARE at:

http://www.2brightsparks.com/contact.html

• Distribution in a Retail Environment, Book Companion Disk / CD-ROM / Other Disk Types (Book): You may not distribute the program without obtaining explicit permission from AUTHOR.

• Other (e.g. Retail not covered above) CD-ROM Shareware Distribution: You may not distribute the program without obtaining explicit permission from AUTHOR.

• Internet Providers Disk / CD-ROM / Demo Disks / Connection Kits / etc.: You may distribute this SOFTWARE on your disk/CD only as bundled shareware with other programs without charge and permission as long as the "General Terms and Conditions" set forth above are complied with. If you intend to provide the program for your own diagnostic purposes then you may not distribute the program without obtaining explicit permission from the AUTHOR.

• Software/Hardware Manufacturers & Suppliers: You may not distribute the program pre-installed or otherwise on the machines you manufacture/distribute/etc. or bundled with your own products without obtaining explicit permission from AUTHOR.

• Other Type of Distribution: Please contact AUTHOR for details.

BY DISTRIBUTING THE SOFTWARE YOU ACKNOWLEDGE THAT YOU HAVE READ AND UNDERSTOOD THIS AGREEMENT AND YOU AGREE TO BE BOUND BY THIS AGREEMENT'S TERMS AND CONDITIONS. YOU ALSO AGREE THAT THIS AGREEMENT IS THE COMPLETE AND EXCLUSIVE STATEMENT OF THE RIGHTS AND LIABILITIES OF THE PARTIES AND SUPERSEDES ALL PROPOSALS OR PRIOR AGREEMENTS, ORAL OR WRITTEN AND ANY OTHER COMMUNICATION BETWEEN THE PARTIES RELATING TO THE SUBJECT MATTER OF THIS AGREEMENT.

Freeware

Licensing Terms and Conditions

2BrightSparks grants you a limited non-exclusive license to use FREEWARE downloadable from 2BrightSparks for personal, educational, charity, and commercial use, and donations are entirely optional.

If you are using the SOFTWARE free of charge under the terms of this Agreement, you are not entitled to support although we will respond to support requests if they relate to any SOFTWARE that is not performing it's task correctly (bugs etc).

Our Freeware is licensed to you in accordance with the terms and conditions of this Agreement. You represent and warrant that you will not violate any of the requirements of this Agreement and further represent and warrant that:

- You will not, and will not permit others to:

(i) reverse engineer, decompile, disassemble, derive the source code of, modify, or create derivative works from our Freeware, or

(ii) copy, distribute, publicly display, or publicly perform content contained in this Freeware other than as expressly authorized by this Agreement.

- You will not use our Freeware to engage in or allow others to engage in any illegal activity.

- You will not engage in using our Freeware that will interfere with or damage the operation of the services of any third parties by overburdening/disabling network resources through automated queries, excessive usage or similar conduct.

- You will not sell our Freeware or charge others for use of it (either for profit or merely to recover your media and distribution costs) whether as a stand-alone product, or as part of a compilation or anthology, without explicit prior written permission.

- You will not use our Freeware to engage in any activity that will violate the rights of third parties, including, without limitation, through the use, public display, public performance, reproduction, distribution, or modification of communications or materials that infringe copyrights, trademarks, publicity rights, privacy rights, other proprietary rights, or rights against defamation of third parties.

- You may not claim any sponsorship by, endorsement by, or affiliation with our company.

Limitation of Liability

Please read the LIMITATION OF LIABILITY above which applies to Freeware and Commercial software provided by 2BrightSparks Pte Ltd.


Credits

Program Credits

SyncBackSE Program Developers

2BrightSparks Pte Ltd © 2003-2008

Website: www.2BrightSparks.com

Additional Credits

SyncBackSE makes use of the following components and services:

SyncBackSE is written in Delphi 2007 by CodeGear: www.codegear.com

Resources: AbleStable, Serving the Creative Community: www.ablestable.com

Virtual Tree component by Mike Lischke: www.delphi-gems.com

Zip compression by Xceed Software Inc: www.xceedsoft.com

FTP by Smart FTP: www.smartftp.com

Email by AdminSystem Software Limited: www.emailarchitect.com

MD5 hashing by David Barton: crypto@cityinthesky.co.uk

Unicode controls by TMS Software: www.tmssoftware.com

Project JEDI: www.delphi-jedi.org

Regular expression component by Andrey V. Sorokin: RegExpStudio.com

Exception handling and CRC32 hashing by madExcept: madshi.net

Database by Ralf Junker: www.yunqa.de

CD/DVD burner by Numedia Soft, Inc.: www.numediasoft.com

Installer by Jordan Russell: jrsoftware.org

International Language Translations

catalan2 | Catalan translation by Jordi Rodellar Fustero
czech | Czech translation by Vlamo
dutch | Dutch translation by Gerard Entius and Hans Fraiponts
france2 | French translation by Philippe Septier
germany2 | German translation by Stefan Aicher
hungary2 | Hungarian translation by Jozsef Tamas Herczeg
italy2 | Italian translation by Roberto Lodigiani and Massimo Pedrazzoli
japanese2 | Japanese translation by Kawai & Tsu_Kun
norway | Norwegian translation by Kjetil Birkeland Moe
poland2 | Polish translation by Lukasz Puzon Brodowski
portugal-brazil |  | Portuguese (Brazilian) translation by Edson Wunderlich
china-trad2 |  | Simplified & Traditional Chinese translation by Larry Ho
spain-argentina |  | Spanish (Argentinean) translation by Gustavo Santiago
sweden2 | Swedish translation by Linus Rörstad


Company Information

2BrightSparks Pte Ltd

Overview

2BrightSparks Pte Ltd was incorporated in 2004 with Michael J. Leaver, Mike de Sousa, and Richard N. Gascoigne at its helm. The team is now seven strong and growing as it continues to deliver high quality utility software solutions used by IT professionals, corporations, and non-profit organizations across the globe.

2bs-bw-logo

For more about the 2BrightSparks team go to:

http://www.2brightsparks.com/about.html

Company Website

www.2brightsparks.com

Sales and Support

Sales and Support are available by submitting a support ticket from our Support Area.

Company Postal Address

2BrightSparks Pte Ltd

PSA Building

PO Box 364

Singapore 911143

Payment Processor

All payment transactions at 2BrightSparks are handled through the eSellerate payment system. At no time do we process or save customer payment card details at www.2BrightSparks.com.

If you would like to learn about eSellerate visit their site at:

http://www.esellerate.net/company_overview.asp